// generated by Fast Light User Interface Designer (fluid) version 1.0304

#include "ADnoteUI.h"
// ADNoteUI.cc
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2017, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code.
// Modified September 2017

#include <FL/Fl_Box.H>
    #include <FL/Fl_Group.H>
    #include "Params/ADnoteParameters.h"
    #include "Misc/SynthEngine.h"
    #include "UI/MiscGui.h"
    #include "UI/WidgetPDial.h"
    #include "UI/WidgetMWSlider.h"
    #include "FilterUI.h"
    #include "PresetsUI.h"
#include "MasterUI.h"

void ADvoicelistitem::cb_voicevolume_i(mwheel_val_slider_rev* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(100);
    int vol = lrint(o->value());
    if (synth->getGuiMaster()->partui->adnoteui->advoice->nvoice == nvoice)
        synth->getGuiMaster()->partui->adnoteui->advoice->voicevolume->value(vol);

    collect_data(synth, vol, (Fl::event_button() | 0xc8), 0, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voicevolume(mwheel_val_slider_rev* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicevolume_i(o,v);
}

void ADvoicelistitem::cb_voiceresonanceenabled_i(Fl_Check_Button* o, void*) {
  //
    bool enab = (o->value() > 0.5);
    synth->getGuiMaster()->partui->adnoteui->advoice->ResonanceEn->value(enab);

    collect_data(synth, enab, (Fl::event_button() | 0xc0), 130, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voiceresonanceenabled(Fl_Check_Button* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voiceresonanceenabled_i(o,v);
}

void ADvoicelistitem::cb_voicelistvibratto_i(mwheel_val_slider_rev* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(40);
    int lfodepth = lrint(o->value());
    if (synth->getGuiMaster()->partui->adnoteui->advoice->nvoice == nvoice)
        synth->getGuiMaster()->partui->adnoteui->advoice->voicefreqlfogroup->intensity->value(lfodepth);

    collect_data(synth, lfodepth, (Fl::event_button() | 0xc8), 1, npart, kititem, 0x80 + nvoice, 0, 1);
}
void ADvoicelistitem::cb_voicelistvibratto(mwheel_val_slider_rev* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicelistvibratto_i(o,v);
}

void ADvoicelistitem::cb_voicepanning_i(WidgetPDial* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(64);
    int panning = lrint(o->value());
    if (synth->getGuiMaster()->partui->adnoteui->advoice->nvoice == nvoice)
    {
        synth->getGuiMaster()->partui->adnoteui->advoice->voicepan->value(panning);
        synth->getGuiMaster()->partui->adnoteui->advoice->voicerandompan->value(panning < 1);
    }

    collect_data(synth, panning, (Fl::event_button() | 0xc8), 2, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voicepanning(WidgetPDial* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicepanning_i(o,v);
}

void ADvoicelistitem::cb_noiselabel_i(Fl_Box* o, void*) {
  //
    int tmp = pars->VoicePar[nvoice].Type;
    if (tmp == 0)
    {
        o->hide();
        voiceresonanceenabled->activate();
        detunevalueoutput->activate();
        voicedetune->activate();
        voiceoscil->activate();
        return;
    }
    if (tmp == 1)
        o->labelcolor(7);
    else
        o->labelcolor(5);
    o->show();
    voiceresonanceenabled->deactivate();
    detunevalueoutput->deactivate();
    voicedetune->deactivate();
    voiceoscil->deactivate();
}
void ADvoicelistitem::cb_noiselabel(Fl_Box* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_noiselabel_i(o,v);
}

void ADvoicelistitem::cb_detunevalueoutput_i(Fl_Value_Output* o, void*) {
  o->value(getDetune((pars->VoicePar[nvoice].PDetuneType == 0) ? (pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PDetuneType), 0, pars->VoicePar[nvoice].PDetune) * pars->getBandwidthDetuneMultiplier());
}
void ADvoicelistitem::cb_detunevalueoutput(Fl_Value_Output* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_detunevalueoutput_i(o,v);
}

void ADvoicelistitem::cb_voicedetune_i(mwheel_slider_rev* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(0);
    int detune = lrint(o->value());
    collect_data(synth, detune, (Fl::event_button() | 0xd8), 32, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voicedetune(mwheel_slider_rev* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_voicedetune_i(o,v);
}

void ADvoicelistitem::cb_Edit_i(Fl_Button*, void*) {
  //
              synth->getGuiMaster()->partui->adnoteui->editVoice(nvoice);
              synth->getGuiMaster()->partui->adnoteui->fromVoiceList = true;
              if((Fl::event_button() == 3)){
                synth->getGuiMaster()->partui->adnoteui->ADnoteVoiceList->hide();
              };
}
void ADvoicelistitem::cb_Edit(Fl_Button* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->parent()->user_data()))->cb_Edit_i(o,v);
}

void ADvoicelistitem::cb_voiceenabled_i(Fl_Check_Button* o, void*) {
  //
    bool enab = (o->value() > 0.5);
    if (enab)
        voicelistitemgroup->activate();
    else
        voicelistitemgroup->deactivate();
    o->redraw();
    if (synth->getGuiMaster()->partui->adnoteui->advoice->nvoice == nvoice)
    {
        synth->getGuiMaster()->partui->adnoteui->advoice->voiceonbutton->value(enab);
        if (enab)
            synth->getGuiMaster()->partui->adnoteui->advoice->voiceparametersgroup->activate();
        else
            synth->getGuiMaster()->partui->adnoteui->advoice->voiceparametersgroup->deactivate();
    }

    collect_data(synth, enab, (Fl::event_button() | 0xc8), 129, npart, kititem, 0x80 + nvoice);
}
void ADvoicelistitem::cb_voiceenabled(Fl_Check_Button* o, void* v) {
  ((ADvoicelistitem*)(o->parent()->user_data()))->cb_voiceenabled_i(o,v);
}

Fl_Group* ADvoicelistitem::make_window() {
  { ADnoteVoiceListItem = new Fl_Group(0, 0, 625, 30);
    ADnoteVoiceListItem->box(FL_ENGRAVED_BOX);
    ADnoteVoiceListItem->color(FL_BACKGROUND_COLOR);
    ADnoteVoiceListItem->selection_color(FL_BACKGROUND_COLOR);
    ADnoteVoiceListItem->labeltype(FL_NO_LABEL);
    ADnoteVoiceListItem->labelfont(0);
    ADnoteVoiceListItem->labelsize(14);
    ADnoteVoiceListItem->labelcolor(FL_FOREGROUND_COLOR);
    ADnoteVoiceListItem->user_data((void*)(this));
    ADnoteVoiceListItem->align(Fl_Align(FL_ALIGN_TOP));
    ADnoteVoiceListItem->when(FL_WHEN_RELEASE);
    { Fl_Group* o = voicelistitemgroup = new Fl_Group(38, 1, 584, 25);
      voicelistitemgroup->box(FL_FLAT_BOX);
      { mwheel_val_slider_rev* o = voicevolume = new mwheel_val_slider_rev(125, 3, 113, 20);
        voicevolume->tooltip("Volume");
        voicevolume->type(5);
        voicevolume->box(FL_THIN_DOWN_BOX);
        voicevolume->color(FL_BACKGROUND_COLOR);
        voicevolume->selection_color(FL_BACKGROUND_COLOR);
        voicevolume->labeltype(FL_NORMAL_LABEL);
        voicevolume->labelfont(0);
        voicevolume->labelsize(8);
        voicevolume->labelcolor(FL_FOREGROUND_COLOR);
        voicevolume->maximum(127);
        voicevolume->step(1);
        voicevolume->callback((Fl_Callback*)cb_voicevolume);
        voicevolume->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        voicevolume->when(FL_WHEN_CHANGED);
        o->value(pars->VoicePar[nvoice].PVolume);
        o->setValueType(VC_ADDVoiceVolume);o->useCustomTip(true);
      } // mwheel_val_slider_rev* voicevolume
      { Fl_Check_Button* o = voiceresonanceenabled = new Fl_Check_Button(269, 5, 15, 17);
        voiceresonanceenabled->tooltip("Resonance On/Off");
        voiceresonanceenabled->down_box(FL_DOWN_BOX);
        voiceresonanceenabled->labeltype(FL_EMBOSSED_LABEL);
        voiceresonanceenabled->labelfont(1);
        voiceresonanceenabled->labelsize(11);
        voiceresonanceenabled->callback((Fl_Callback*)cb_voiceresonanceenabled);
        voiceresonanceenabled->align(Fl_Align(FL_ALIGN_LEFT));
        o->value(pars->VoicePar[nvoice].Presonance);
      } // Fl_Check_Button* voiceresonanceenabled
      { mwheel_val_slider_rev* o = voicelistvibratto = new mwheel_val_slider_rev(505, 3, 115, 20);
        voicelistvibratto->tooltip("Frequency LFO amount");
        voicelistvibratto->type(5);
        voicelistvibratto->box(FL_THIN_DOWN_BOX);
        voicelistvibratto->color(FL_BACKGROUND_COLOR);
        voicelistvibratto->selection_color(FL_BACKGROUND_COLOR);
        voicelistvibratto->labeltype(FL_NORMAL_LABEL);
        voicelistvibratto->labelfont(0);
        voicelistvibratto->labelsize(8);
        voicelistvibratto->labelcolor(FL_FOREGROUND_COLOR);
        voicelistvibratto->maximum(127);
        voicelistvibratto->step(1);
        voicelistvibratto->callback((Fl_Callback*)cb_voicelistvibratto);
        voicelistvibratto->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        voicelistvibratto->when(FL_WHEN_CHANGED);
        voicelistvibratto->deactivate();
        o->value(pars->VoicePar[nvoice].FreqLfo->Pintensity);
        o->setValueType(VC_LFOdepthFreq);o->useCustomTip(true);
      } // mwheel_val_slider_rev* voicelistvibratto
      { WidgetPDial* o = voicepanning = new WidgetPDial(244, 3, 20, 20);
        voicepanning->tooltip("Voice panning - zero/leftmost is Random");
        voicepanning->box(FL_ROUND_UP_BOX);
        voicepanning->color(FL_BACKGROUND_COLOR);
        voicepanning->selection_color(FL_INACTIVE_COLOR);
        voicepanning->labeltype(FL_NORMAL_LABEL);
        voicepanning->labelfont(0);
        voicepanning->labelsize(10);
        voicepanning->labelcolor(FL_FOREGROUND_COLOR);
        voicepanning->maximum(127);
        voicepanning->step(1);
        voicepanning->callback((Fl_Callback*)cb_voicepanning);
        voicepanning->align(Fl_Align(FL_ALIGN_LEFT));
        voicepanning->when(FL_WHEN_CHANGED);
        o->setValueType(VC_PanningRandom);
        o->value(pars->VoicePar[nvoice].PPanning);
      } // WidgetPDial* voicepanning
      { Fl_Group* o = voiceoscil = new Fl_Group(88, 3, 30, 20);
        voiceoscil->box(FL_THIN_DOWN_FRAME);
        voiceoscil->color(FL_GRAY0);
        voiceoscil->selection_color((Fl_Color)71);
        voiceoscil->labelcolor((Fl_Color)179);
        osc = new Oscilloscope(o->x(), o->y(), o->w(), o->h(), "");
        osc->init(pars->VoicePar[nvoice].OscilSmp,0,pars->VoicePar[nvoice].Poscilphase, synth);
        if (pars->VoicePar[nvoice].Pextoscil != -1) {osc->init(pars->VoicePar[pars->VoicePar[nvoice].Pextoscil].OscilSmp, synth);}
        voiceoscil->end();
      } // Fl_Group* voiceoscil
      { noiselabel = new Fl_Box(93, 3, 20, 20, "N");
        noiselabel->labelfont(1);
        noiselabel->labelsize(13);
        noiselabel->labelcolor(FL_BACKGROUND2_COLOR);
        noiselabel->callback((Fl_Callback*)cb_noiselabel);
      } // Fl_Box* noiselabel
      { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(290, 3, 45, 20);
        detunevalueoutput->box(FL_THIN_DOWN_BOX);
        detunevalueoutput->labelsize(10);
        detunevalueoutput->minimum(-5000);
        detunevalueoutput->maximum(5000);
        detunevalueoutput->textfont(1);
        detunevalueoutput->textsize(10);
        detunevalueoutput->callback((Fl_Callback*)cb_detunevalueoutput);
        detunevalueoutput->align(Fl_Align(FL_ALIGN_CENTER));
        o->step(0.01, 1);
        o->value(getDetune(pars->VoicePar[nvoice].PDetuneType, 0, pars->VoicePar[nvoice].PDetune) * pars->getBandwidthDetuneMultiplier());
      } // Fl_Value_Output* detunevalueoutput
      { mwheel_slider_rev* o = voicedetune = new mwheel_slider_rev(335, 3, 164, 20);
        voicedetune->tooltip("Fine Detune (cents)");
        voicedetune->type(5);
        voicedetune->box(FL_THIN_DOWN_BOX);
        voicedetune->color(FL_BACKGROUND_COLOR);
        voicedetune->selection_color(FL_BACKGROUND_COLOR);
        voicedetune->labeltype(FL_NORMAL_LABEL);
        voicedetune->labelfont(0);
        voicedetune->labelsize(14);
        voicedetune->labelcolor(FL_FOREGROUND_COLOR);
        voicedetune->minimum(-8192);
        voicedetune->maximum(8191);
        voicedetune->step(1);
        voicedetune->callback((Fl_Callback*)cb_voicedetune);
        voicedetune->align(Fl_Align(FL_ALIGN_BOTTOM));
        voicedetune->when(FL_WHEN_CHANGED);
        o->value(pars->VoicePar[nvoice].PDetune - 8192);
      } // mwheel_slider_rev* voicedetune
      { Fl_Button* o = new Fl_Button(41, 4, 40, 19, "Edit");
        o->box(FL_THIN_UP_BOX);
        o->labelfont(1);
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_Edit);
      } // Fl_Button* o
      if (pars->VoicePar[nvoice].Enabled == 0) o->deactivate();
      voicelistitemgroup->end();
    } // Fl_Group* voicelistitemgroup
    { Fl_Check_Button* o = voiceenabled = new Fl_Check_Button(20, 3, 20, 20, "1");
      voiceenabled->box(FL_THIN_UP_BOX);
      voiceenabled->down_box(FL_DOWN_BOX);
      voiceenabled->color((Fl_Color)237);
      voiceenabled->labeltype(FL_EMBOSSED_LABEL);
      voiceenabled->labelfont(1);
      voiceenabled->labelsize(13);
      voiceenabled->callback((Fl_Callback*)cb_voiceenabled);
      voiceenabled->align(Fl_Align(FL_ALIGN_LEFT));
      char tmp[10]; snprintf(tmp, 10, "%d", nvoice + 1); o->label(strdup(tmp));
      o->value(pars->VoicePar[nvoice].Enabled);
    } // Fl_Check_Button* voiceenabled
    ADnoteVoiceListItem->end();
  } // Fl_Group* ADnoteVoiceListItem
  return ADnoteVoiceListItem;
}

ADvoicelistitem::ADvoicelistitem(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  nvoice = 0; pars = NULL;
}

void ADvoicelistitem::init(ADnoteParameters *parameters, int npart_, int kititem_, int nvoice_) {
  //
      synth = parameters->getSynthEngine();
      pars = parameters;
      npart = npart_;
      kititem = kititem_;
      nvoice = nvoice_;
      make_window();
      if (pars->VoicePar[nvoice].PFreqLfoEnabled > 0)
          voicelistvibratto->activate();
      else
          voicelistvibratto->deactivate();
      ADnoteVoiceListItem->show();
      end();
}

void ADvoicelistitem::refreshlist() {
  //
          voiceenabled->value(pars->VoicePar[nvoice].Enabled);
          voiceresonanceenabled->value(pars->VoicePar[nvoice].Presonance);
          voicevolume->value(pars->VoicePar[nvoice].PVolume);
          voicedetune->value(pars->VoicePar[nvoice].PDetune - 8192);
          voicepanning->value(pars->VoicePar[nvoice].PPanning);
          pars->setVoicePan(nvoice, voicepanning->value());
          voicelistvibratto->value(pars->VoicePar[nvoice].FreqLfo->Pintensity);
          if (pars->VoicePar[nvoice].Pextoscil != -1)
          {
              osc->init(pars->VoicePar[pars->VoicePar[nvoice].Pextoscil].OscilSmp, 0, pars->VoicePar[nvoice].Poscilphase, synth);
          }
          else
              osc->init(pars->VoicePar[nvoice].OscilSmp, 0, pars->VoicePar[nvoice].Poscilphase, synth);
          if (pars->VoicePar[nvoice].Enabled == 0)
              voicelistitemgroup->deactivate();
          else
              voicelistitemgroup->activate();
          detunevalueoutput->do_callback();
          noiselabel->do_callback();
          ADnoteVoiceListItem->redraw();
}

ADvoicelistitem::~ADvoicelistitem() {
  //
          ADnoteVoiceListItem->hide();
}

void ADvoiceUI::cb_ModFreqEn_i(Fl_Check_Button* o, void*) {
  //
                    if (o->value() == 0)
                        voiceFMfreqenvgroup->deactivate();
                    else
                        voiceFMfreqenvgroup->activate();
                    o->redraw();
                    send_data(104, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModFreqEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModFreqEn_i(o,v);
}

void ADvoiceUI::cb_ModCoarseDetune_i(Fl_Counter* o, void*) {
  //
                    send_data(101, o->value(), 0xc0);
}
void ADvoiceUI::cb_ModCoarseDetune(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModCoarseDetune_i(o,v);
}

void ADvoiceUI::cb_ModOctave_i(Fl_Counter* o, void*) {
  //
                    send_data(99, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModOctave(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModOctave_i(o,v);
}

void ADvoiceUI::cb_fmdetunevalueoutput_i(Fl_Value_Output* o, void*) {
  o->value(getDetune((pars->VoicePar[nvoice].PFMDetuneType == 0) ? (pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PFMDetuneType), 0, pars->VoicePar[nvoice].PFMDetune));
}
void ADvoiceUI::cb_fmdetunevalueoutput(Fl_Value_Output* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_fmdetunevalueoutput_i(o,v);
}

void ADvoiceUI::cb_ModDetune_i(mwheel_slider_rev* o, void*) {
  //
                    if (Fl::event_button() == 3)
                        o->value(0);
                    send_data(96, o->value(), 0xd8);
}
void ADvoiceUI::cb_ModDetune(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModDetune_i(o,v);
}

void ADvoiceUI::cb_ModDetuneType_i(Fl_Choice* o, void*) {
  //
                    send_data(100, o->value(), 0xd0);
}
void ADvoiceUI::cb_ModDetuneType(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModDetuneType_i(o,v);
}

void ADvoiceUI::cb_Mod440_i(Fl_Check_Button* o, void*) {
  //
send_data(98, o->value(), 0xd0);
}
void ADvoiceUI::cb_Mod440(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_Mod440_i(o,v);
}

void ADvoiceUI::cb_ModVolume_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(90);
send_data(80, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModVolume(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModVolume_i(o,v);
}

void ADvoiceUI::cb_ModVsense_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(64);
send_data(81, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModVsense(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModVsense_i(o,v);
}

void ADvoiceUI::cb_ModAmpEn_i(Fl_Check_Button* o, void*) {
  //
                    if (o->value() == 0)
                        voiceFMampenvgroup->deactivate();
                    else
                        voiceFMampenvgroup->activate();
                    o->redraw();
                    send_data(88, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModAmpEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModAmpEn_i(o,v);
}

void ADvoiceUI::cb_ModFdamp_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(0);
send_data(82, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModFdamp(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModFdamp_i(o,v);
}

void ADvoiceUI::cb_changeFMoscilbutton_i(Fl_Button*, void*) {
  //
                    if (oscedit != NULL)
                        delete oscedit;
                    int nv = nvoice;
                    if (pars->VoicePar[nvoice].PextFMoscil >= 0)
                        nv = pars->VoicePar[nvoice].PextFMoscil;
                    oscedit = new OscilEditor(pars->VoicePar[nv].FMSmp, fmoscil, NULL, NULL, synth, npart, kititem, nvoice + 0xC0);
                    if ((Fl::event_button() == 3))
                        synth->getGuiMaster()->partui->adnoteui->ADnoteVoice->hide();
}
void ADvoiceUI::cb_changeFMoscilbutton(Fl_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_changeFMoscilbutton_i(o,v);
}

void ADvoiceUI::cb_ModPhase_i(mwheel_slider_rev* o, void*) {
  //
                    send_data(112, o->value(), 0xd8);
}
void ADvoiceUI::cb_ModPhase(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ModPhase_i(o,v);
}

void ADvoiceUI::cb_ExtModOsc_i(Fl_Choice* o, void*) {
  //
                    send_data(113, o->value() - 1, 0xd0);
}
void ADvoiceUI::cb_ExtModOsc(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->parent()->user_data()))->cb_ExtModOsc_i(o,v);
}

void ADvoiceUI::cb_ExtMod_i(Fl_Choice* o, void*) {
  //
                  send_data(17, o->value() - 1, 0xd0);
}
void ADvoiceUI::cb_ExtMod(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_ExtMod_i(o,v);
}

void ADvoiceUI::cb_ModType_i(Fl_Choice* o, void*) {
  //
                if (o->value() == 0)
                    voiceFMparametersgroup->deactivate();
                else
                    voiceFMparametersgroup->activate();
                o->redraw();
                send_data(16, o->value(), 0xc8);
}
void ADvoiceUI::cb_ModType(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_ModType_i(o,v);
}

Fl_Menu_Item ADvoiceUI::menu_ModType[] = {
 {"OFF", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"MORPH", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"RING", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"PM", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"FM", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"PWM", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ADvoiceUI::cb_FreqEn_i(Fl_Check_Button* o, void*) {
  //
                  if (o->value() == 0)
                      voicefreqenvgroup->deactivate();
                  else
                      voicefreqenvgroup->activate();
                  o->redraw();
                  send_data(40, o->value(), 0xc8);
}
void ADvoiceUI::cb_FreqEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_FreqEn_i(o,v);
}

void ADvoiceUI::cb_FreqLfoEn_i(Fl_Check_Button* o, void*) {
  //
    bool enab = (o->value() > 0.5);
    if (enab)
    {
        voicefreqlfogroup->activate();
        synth->getGuiMaster()->partui->adnoteui->voicelistitem[nvoice]->voicelistvibratto->activate();
    }
    else
    {
        voicefreqlfogroup->deactivate();
        synth->getGuiMaster()->partui->adnoteui->voicelistitem[nvoice]->voicelistvibratto->deactivate();
    }
    o->redraw();

    send_data(41, o->value(), 0xc8);
}
void ADvoiceUI::cb_FreqLfoEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_FreqLfoEn_i(o,v);
}

void ADvoiceUI::cb_Octave_i(Fl_Counter* o, void*) {
  //
                  send_data(35, o->value(), 0xc8);
}
void ADvoiceUI::cb_Octave(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Octave_i(o,v);
}

void ADvoiceUI::cb_CoarseDetune_i(Fl_Counter* o, void*) {
  //
                  send_data(37, o->value(), 0xc0);
}
void ADvoiceUI::cb_CoarseDetune(Fl_Counter* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_CoarseDetune_i(o,v);
}

void ADvoiceUI::cb_detunevalueoutput1_i(Fl_Value_Output* o, void*) {
  o->value(getDetune((pars->VoicePar[nvoice].PDetuneType==0)?(pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PDetuneType),0,pars->VoicePar[nvoice].PDetune)*pars->getBandwidthDetuneMultiplier());
}
void ADvoiceUI::cb_detunevalueoutput1(Fl_Value_Output* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_detunevalueoutput1_i(o,v);
}

void ADvoiceUI::cb_Detune_i(mwheel_slider_rev* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(0);
    int detune = lrint(o->value());
    send_data(32, detune, 0xd8);
}
void ADvoiceUI::cb_Detune(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Detune_i(o,v);
}

void ADvoiceUI::cb_Freq440_i(Fl_Check_Button* o, void*) {
  //
                  int x = lrint(o->value());
                  if (x == 0 && Mod440->value() == 0)
                      fixedfreqetdial->deactivate();
                  else
                      fixedfreqetdial->activate();
                  send_data(34, o->value(), 0xc0);
}
void ADvoiceUI::cb_Freq440(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Freq440_i(o,v);
}

void ADvoiceUI::cb_fixedfreqetdial_i(WidgetPDial* o, void*) {
  //
send_data(33, o->value(), 0xc8);
}
void ADvoiceUI::cb_fixedfreqetdial(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_fixedfreqetdial_i(o,v);
}

void ADvoiceUI::cb_FreqDetunetype_i(Fl_Choice* o, void*) {
  //
send_data(36, o->value(), 0xd0);
}
void ADvoiceUI::cb_FreqDetunetype(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_FreqDetunetype_i(o,v);
}

void ADvoiceUI::cb_bend_i(WidgetPDial* o, void*) {
  //
send_data(38, o->value(), 0xc8);
}
void ADvoiceUI::cb_bend(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_bend_i(o,v);
}

void ADvoiceUI::cb_offset_i(WidgetPDial* o, void*) {
  //
send_data(39, o->value(), 0xc8);
}
void ADvoiceUI::cb_offset(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_offset_i(o,v);
}

void ADvoiceUI::cb_changevoiceoscilbutton_i(Fl_Button*, void*) {
  //
    if (oscedit)
        delete oscedit;
    int nv = nvoice;
    if (pars->VoicePar[nvoice].Pextoscil >= 0)
        nv=pars->VoicePar[nvoice].Pextoscil;
    oscedit = new OscilEditor(pars->VoicePar[nv].OscilSmp, voiceoscil, NULL, NULL, synth, npart, kititem, nvoice + 0x80);
    if ((Fl::event_button() == 3))
        synth->getGuiMaster()->partui->adnoteui->ADnoteVoice->hide();
}
void ADvoiceUI::cb_changevoiceoscilbutton(Fl_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_changevoiceoscilbutton_i(o,v);
}

void ADvoiceUI::cb_VoiceOscPhase_i(mwheel_slider_rev* o, void*) {
  //
                if (Fl::event_button() == 3)
                    o->value(0);


                send_data(136, o->value(), 0xd8);
}
void ADvoiceUI::cb_VoiceOscPhase(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_VoiceOscPhase_i(o,v);
}

void ADvoiceUI::cb_ResonanceEn_i(Fl_Check_Button* o, void*) {
  //
    bool enab = (o->value() > 0.5);
    pars->VoicePar[nvoice].Presonance = enab;
    synth->getGuiMaster()->partui->adnoteui->voicelistitem[nvoice]->voiceresonanceenabled->value(enab);
    send_data(130, enab, 0xc0);
}
void ADvoiceUI::cb_ResonanceEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_ResonanceEn_i(o,v);
}

void ADvoiceUI::cb_UseOsc_i(Fl_Choice* o, void*) {
  //
                send_data(137, o->value() - 1, 0xd0);
}
void ADvoiceUI::cb_UseOsc(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_UseOsc_i(o,v);
}

void ADvoiceUI::cb_UnisonEn_i(Fl_Check_Button* o, void*) {
  //
send_data(56, o->value(), 0xd0);
}
void ADvoiceUI::cb_UnisonEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_UnisonEn_i(o,v);
}

void ADvoiceUI::cb_unisonsize_i(Fl_Spinner* o, void*) {
  //
send_data(53, o->value(), 0xc0);
}
void ADvoiceUI::cb_unisonsize(Fl_Spinner* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_unisonsize_i(o,v);
}

void ADvoiceUI::cb_UnisonStereo_i(WidgetPDial* o, void*) {
  //
send_data(50, o->value(), 0xc8);
}
void ADvoiceUI::cb_UnisonStereo(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_UnisonStereo_i(o,v);
}

void ADvoiceUI::cb_UnisonVib_i(WidgetPDial* o, void*) {
  //
send_data(51, o->value(), 0xc8);
}
void ADvoiceUI::cb_UnisonVib(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_UnisonVib_i(o,v);
}

void ADvoiceUI::cb_UnisonInvert_i(Fl_Choice* o, void*) {
  //
send_data(54, o->value(), 0xc0);
}
void ADvoiceUI::cb_UnisonInvert(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_UnisonInvert_i(o,v);
}

void ADvoiceUI::cb_UnisonFreqSpread_i(mwheel_slider_rev* o, void*) {
  //
                  if (Fl::event_button() == 3)
                      o->value(60);
                  unisonspreadoutput->do_callback();
                  send_data(48, o->value(), 0xd8);
}
void ADvoiceUI::cb_UnisonFreqSpread(mwheel_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_UnisonFreqSpread_i(o,v);
}

void ADvoiceUI::cb_unisonspreadoutput_i(Fl_Value_Output* o, void*) {
  o->value(pars->getUnisonFrequencySpreadCents(nvoice));
}
void ADvoiceUI::cb_unisonspreadoutput(Fl_Value_Output* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_unisonspreadoutput_i(o,v);
}

void ADvoiceUI::cb_UnisonVspeed_i(WidgetPDial* o, void*) {
  //
send_data(52, o->value(), 0xc8);
}
void ADvoiceUI::cb_UnisonVspeed(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_UnisonVspeed_i(o,v);
}

void ADvoiceUI::cb_UnisonPhRnd_i(WidgetPDial* o, void*) {
  //
send_data(49, o->value(), 0xc8);
}
void ADvoiceUI::cb_UnisonPhRnd(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_UnisonPhRnd_i(o,v);
}

void ADvoiceUI::cb_voicevolume1_i(WidgetPDial* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(100);
    int vol = lrint(o->value());
    synth->getGuiMaster()->partui->adnoteui->voicelistitem[nvoice]->voicevolume->value(vol);
    send_data(0, vol, 0xc8);
}
void ADvoiceUI::cb_voicevolume1(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicevolume1_i(o,v);
}

void ADvoiceUI::cb_voicevsns_i(WidgetPDial* o, void*) {
  //
send_data(1, o->value(), 0xc8);
}
void ADvoiceUI::cb_voicevsns(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicevsns_i(o,v);
}

void ADvoiceUI::cb_voicepan_i(WidgetPDial* o, void*) {
  //
    int pan = lrint(o->value());
    send_data(2, pan, 0xd8);
}
void ADvoiceUI::cb_voicepan(WidgetPDial* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicepan_i(o,v);
}

void ADvoiceUI::cb_voicerandompan_i(Fl_Light_Button* o, void*) {
  //
    voicepan->value(0);
    o->value(1);
    send_data(2, 0, 0xd0);
}
void ADvoiceUI::cb_voicerandompan(Fl_Light_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_voicerandompan_i(o,v);
}

void ADvoiceUI::cb_AmpEnvEn_i(Fl_Check_Button* o, void*) {
  //
                if (o->value() == 0)
                    voiceampenvgroup->deactivate();
                else
                    voiceampenvgroup->activate();
                o->redraw();
                send_data(8, o->value(), 0xc8);
}
void ADvoiceUI::cb_AmpEnvEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_AmpEnvEn_i(o,v);
}

void ADvoiceUI::cb_AmpLfoEn_i(Fl_Check_Button* o, void*) {
  //
                if (o->value() == 0)
                    voiceamplfogroup->deactivate();
                else
                    voiceamplfogroup->activate();
                o->redraw();
                send_data(9, o->value(), 0xc8);
}
void ADvoiceUI::cb_AmpLfoEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_AmpLfoEn_i(o,v);
}

void ADvoiceUI::cb_VolumeMinus_i(Fl_Check_Button* o, void*) {
  //
send_data(4, o->value(), 0xc0);
}
void ADvoiceUI::cb_VolumeMinus(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_VolumeMinus_i(o,v);
}

void ADvoiceUI::cb_FilterEnvEn_i(Fl_Check_Button* o, void*) {
  //
                send_data(72, o->value(), 0xd8);
}
void ADvoiceUI::cb_FilterEnvEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_FilterEnvEn_i(o,v);
}

void ADvoiceUI::cb_FilterLfoEn_i(Fl_Check_Button* o, void*) {
  //
                send_data(73, o->value(), 0xc8);
}
void ADvoiceUI::cb_FilterLfoEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_FilterLfoEn_i(o,v);
}

void ADvoiceUI::cb_SoundType_i(Fl_Choice* o, void*) {
  //
              int x = lrint(o->value());
              send_data(138, x, 0xd0);
}
void ADvoiceUI::cb_SoundType(Fl_Choice* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_SoundType_i(o,v);
}

Fl_Menu_Item ADvoiceUI::menu_SoundType[] = {
 {"Sound", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 2},
 {"Noise", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Noise", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 5},
 {0,0,0,0,0,0,0,0,0}
};

void ADvoiceUI::cb_Delay_i(mwheel_val_slider_rev* o, void*) {
  if (Fl::event_button() == 3)
    o->value(0);

send_data(128, o->value(), 0xc8);
}
void ADvoiceUI::cb_Delay(mwheel_val_slider_rev* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->parent()->user_data()))->cb_Delay_i(o,v);
}

void ADvoiceUI::cb_bypassfiltercheckbutton_i(Fl_Check_Button* o, void*) {
  //
send_data(64, o->value(), 0xc0);
}
void ADvoiceUI::cb_bypassfiltercheckbutton(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_bypassfiltercheckbutton_i(o,v);
}

void ADvoiceUI::cb_FilterEn_i(Fl_Check_Button* o, void*) {
  //
              bypassfiltercheckbutton->redraw();
              send_data(68, o->value(), 0xd8);
}
void ADvoiceUI::cb_FilterEn(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_FilterEn_i(o,v);
}

void ADvoiceUI::cb_noiselabel1_i(Fl_Box* o, void*) {
  switch (pars->VoicePar[nvoice].Type)
{
    case 1:
        o->copy_label("White Noise");
        o->labelcolor(7);
        break;
    case 2:
        o->copy_label("Pink Noise");
        o->labelcolor(5);
        break;
    default:
        o->hide();
        return;
}
o->show();
}
void ADvoiceUI::cb_noiselabel1(Fl_Box* o, void* v) {
  ((ADvoiceUI*)(o->parent()->parent()->user_data()))->cb_noiselabel1_i(o,v);
}

void ADvoiceUI::cb_voiceonbutton_i(Fl_Check_Button* o, void*) {
  //
    send_data(129, o->value(), 0xd8);
}
void ADvoiceUI::cb_voiceonbutton(Fl_Check_Button* o, void* v) {
  ((ADvoiceUI*)(o->parent()->user_data()))->cb_voiceonbutton_i(o,v);
}

Fl_Group* ADvoiceUI::make_window() {
  { Fl_Group* o = ADnoteVoiceParameters = new Fl_Group(0, 0, 770, 580, "Voice");
    ADnoteVoiceParameters->box(FL_FLAT_BOX);
    ADnoteVoiceParameters->color(FL_BACKGROUND_COLOR);
    ADnoteVoiceParameters->selection_color(FL_BACKGROUND_COLOR);
    ADnoteVoiceParameters->labeltype(FL_NO_LABEL);
    ADnoteVoiceParameters->labelfont(0);
    ADnoteVoiceParameters->labelsize(14);
    ADnoteVoiceParameters->labelcolor(FL_FOREGROUND_COLOR);
    ADnoteVoiceParameters->user_data((void*)(this));
    ADnoteVoiceParameters->align(Fl_Align(FL_ALIGN_TOP));
    ADnoteVoiceParameters->when(FL_WHEN_RELEASE);
    { Fl_Group* o = voiceparametersgroup = new Fl_Group(0, 0, 765, 580);
      voiceparametersgroup->box(FL_THIN_UP_BOX);
      voiceparametersgroup->color((Fl_Color)48);
      { voicemodegroup = new Fl_Group(0, 5, 760, 575);
        { Fl_Group* o = voiceFMparametersgroup = new Fl_Group(530, 5, 230, 565, "MODULATOR");
          voiceFMparametersgroup->box(FL_THIN_UP_FRAME);
          voiceFMparametersgroup->color((Fl_Color)48);
          voiceFMparametersgroup->labelfont(1);
          voiceFMparametersgroup->labelsize(12);
          voiceFMparametersgroup->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
          { modfrequency = new Fl_Group(535, 204, 220, 161, "Mod FREQUENCY");
            modfrequency->box(FL_THIN_UP_BOX);
            modfrequency->labelfont(1);
            modfrequency->labelsize(11);
            modfrequency->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
            { EnvelopeUI* o = voiceFMfreqenvgroup = new EnvelopeUI(540, 290, 205, 70, "ADSynth Modulator - Frequency Envelope");
              voiceFMfreqenvgroup->box(FL_FLAT_BOX);
              voiceFMfreqenvgroup->color((Fl_Color)51);
              voiceFMfreqenvgroup->selection_color(FL_BACKGROUND_COLOR);
              voiceFMfreqenvgroup->labeltype(FL_NORMAL_LABEL);
              voiceFMfreqenvgroup->labelfont(0);
              voiceFMfreqenvgroup->labelsize(14);
              voiceFMfreqenvgroup->labelcolor(FL_FOREGROUND_COLOR);
              voiceFMfreqenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
              voiceFMfreqenvgroup->when(FL_WHEN_RELEASE);
              o->init(pars->VoicePar[nvoice].FMFreqEnvelope, npart, kititem, nvoice | 0xc0, 1);
              if (pars->VoicePar[nvoice].PFMFreqEnvelopeEnabled==0) o->deactivate();
              voiceFMfreqenvgroup->end();
            } // EnvelopeUI* voiceFMfreqenvgroup
            { Fl_Check_Button* o = ModFreqEn = new Fl_Check_Button(545, 295, 34, 12, "On");
              ModFreqEn->tooltip("Enable Frequency Envelope");
              ModFreqEn->box(FL_THIN_UP_BOX);
              ModFreqEn->down_box(FL_DOWN_BOX);
              ModFreqEn->color((Fl_Color)237);
              ModFreqEn->labelfont(1);
              ModFreqEn->labelsize(10);
              ModFreqEn->callback((Fl_Callback*)cb_ModFreqEn);
              o->value(pars->VoicePar[nvoice].PFMFreqEnvelopeEnabled);
            } // Fl_Check_Button* ModFreqEn
            { Fl_Counter* o = ModCoarseDetune = new Fl_Counter(685, 270, 60, 15, "Coarse Det.");
              ModCoarseDetune->tooltip("Coarse Detune");
              ModCoarseDetune->labelsize(10);
              ModCoarseDetune->minimum(-64);
              ModCoarseDetune->maximum(63);
              ModCoarseDetune->step(1);
              ModCoarseDetune->textfont(1);
              ModCoarseDetune->textsize(11);
              ModCoarseDetune->callback((Fl_Callback*)cb_ModCoarseDetune);
              ModCoarseDetune->align(Fl_Align(FL_ALIGN_TOP));
              int k = pars->VoicePar[nvoice].PFMCoarseDetune % 1024;
              if (k >= 512) k-= 1024;
              o->value(k);
              o->lstep(10);
            } // Fl_Counter* ModCoarseDetune
            { Fl_Counter* o = ModOctave = new Fl_Counter(625, 270, 45, 15, "Octave");
              ModOctave->tooltip("Octave");
              ModOctave->type(1);
              ModOctave->color((Fl_Color)237);
              ModOctave->selection_color(FL_FOREGROUND_COLOR);
              ModOctave->labelsize(10);
              ModOctave->minimum(-8);
              ModOctave->maximum(7);
              ModOctave->step(1);
              ModOctave->textfont(1);
              ModOctave->textsize(11);
              ModOctave->callback((Fl_Callback*)cb_ModOctave);
              ModOctave->align(Fl_Align(FL_ALIGN_TOP));
              int k = pars->VoicePar[nvoice].PFMCoarseDetune / 1024;
              if (k >= 8) k -= 16;
              o->value(k);
            } // Fl_Counter* ModOctave
            { Fl_Value_Output* o = fmdetunevalueoutput = new Fl_Value_Output(542, 224, 36, 16, "Detune");
              fmdetunevalueoutput->box(FL_THIN_DOWN_BOX);
              fmdetunevalueoutput->labelsize(8);
              fmdetunevalueoutput->minimum(-5000);
              fmdetunevalueoutput->maximum(5000);
              fmdetunevalueoutput->textfont(1);
              fmdetunevalueoutput->textsize(8);
              fmdetunevalueoutput->callback((Fl_Callback*)cb_fmdetunevalueoutput);
              fmdetunevalueoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
              o->step(0.01, 1);
              o->value(getDetune((pars->VoicePar[nvoice].PFMDetuneType == 0) ? (pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PFMDetuneType), 0, pars->VoicePar[nvoice].PFMDetune));
            } // Fl_Value_Output* fmdetunevalueoutput
            { mwheel_slider_rev* o = ModDetune = new mwheel_slider_rev(578, 224, 168, 16);
              ModDetune->tooltip("Fine Detune (cents)");
              ModDetune->type(5);
              ModDetune->box(FL_THIN_DOWN_BOX);
              ModDetune->color(FL_BACKGROUND_COLOR);
              ModDetune->selection_color(FL_BACKGROUND_COLOR);
              ModDetune->labeltype(FL_NORMAL_LABEL);
              ModDetune->labelfont(0);
              ModDetune->labelsize(14);
              ModDetune->labelcolor(FL_FOREGROUND_COLOR);
              ModDetune->minimum(-8192);
              ModDetune->maximum(8191);
              ModDetune->step(1);
              ModDetune->callback((Fl_Callback*)cb_ModDetune);
              ModDetune->align(Fl_Align(FL_ALIGN_BOTTOM));
              ModDetune->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMDetune-8192);
            } // mwheel_slider_rev* ModDetune
            { Fl_Choice* o = ModDetuneType = new Fl_Choice(540, 270, 75, 15, "Detune Type");
              ModDetuneType->down_box(FL_BORDER_BOX);
              ModDetuneType->selection_color(FL_BACKGROUND_COLOR);
              ModDetuneType->labelsize(10);
              ModDetuneType->textfont(1);
              ModDetuneType->textsize(10);
              ModDetuneType->callback((Fl_Callback*)cb_ModDetuneType);
              ModDetuneType->align(Fl_Align(FL_ALIGN_TOP_LEFT));
              //
                    o->add("Default");
                    o->add("L35cents");
                    o->add("L10cents");
                    o->add("E100cents");
                    o->add("E1200cents");
              o->value(pars->VoicePar[nvoice].PFMDetuneType);
            } // Fl_Choice* ModDetuneType
            { Fl_Check_Button* o = Mod440 = new Fl_Check_Button(683, 242, 55, 15, "440Hz");
              Mod440->tooltip("Set the modulator base frequency to 440Hz");
              Mod440->down_box(FL_DOWN_BOX);
              Mod440->labelfont(1);
              Mod440->labelsize(11);
              Mod440->callback((Fl_Callback*)cb_Mod440);
              o->value(pars->VoicePar[nvoice].PFMFixedFreq);
            } // Fl_Check_Button* Mod440
            modfrequency->end();
          } // Fl_Group* modfrequency
          { Fl_Group* o = new Fl_Group(535, 55, 220, 149, "Mod AMPLITUDE");
            o->box(FL_THIN_UP_BOX);
            o->labelfont(1);
            o->labelsize(11);
            o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
            { mwheel_val_slider_rev* o = ModVolume = new mwheel_val_slider_rev(540, 70, 160, 15, "Vol");
              ModVolume->tooltip("Volume");
              ModVolume->type(5);
              ModVolume->box(FL_THIN_DOWN_BOX);
              ModVolume->color(FL_BACKGROUND_COLOR);
              ModVolume->selection_color(FL_BACKGROUND_COLOR);
              ModVolume->labeltype(FL_NORMAL_LABEL);
              ModVolume->labelfont(0);
              ModVolume->labelsize(11);
              ModVolume->labelcolor(FL_FOREGROUND_COLOR);
              ModVolume->maximum(127);
              ModVolume->step(1);
              ModVolume->callback((Fl_Callback*)cb_ModVolume);
              ModVolume->align(Fl_Align(FL_ALIGN_RIGHT));
              ModVolume->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMVolume);
            } // mwheel_val_slider_rev* ModVolume
            { mwheel_val_slider_rev* o = ModVsense = new mwheel_val_slider_rev(540, 90, 160, 15, "V.Sns");
              ModVsense->tooltip("Velocity Sensing Function - rightmost/max to disable)");
              ModVsense->type(5);
              ModVsense->box(FL_THIN_DOWN_BOX);
              ModVsense->color(FL_BACKGROUND_COLOR);
              ModVsense->selection_color(FL_BACKGROUND_COLOR);
              ModVsense->labeltype(FL_NORMAL_LABEL);
              ModVsense->labelfont(0);
              ModVsense->labelsize(11);
              ModVsense->labelcolor(FL_FOREGROUND_COLOR);
              ModVsense->maximum(127);
              ModVsense->step(1);
              ModVsense->callback((Fl_Callback*)cb_ModVsense);
              ModVsense->align(Fl_Align(FL_ALIGN_RIGHT));
              ModVsense->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMVelocityScaleFunction);
            } // mwheel_val_slider_rev* ModVsense
            { EnvelopeUI* o = voiceFMampenvgroup = new EnvelopeUI(542, 129, 205, 70, "ADSynth Modulator - Amplitude Envelope");
              voiceFMampenvgroup->box(FL_FLAT_BOX);
              voiceFMampenvgroup->color((Fl_Color)51);
              voiceFMampenvgroup->selection_color(FL_BACKGROUND_COLOR);
              voiceFMampenvgroup->labeltype(FL_NORMAL_LABEL);
              voiceFMampenvgroup->labelfont(0);
              voiceFMampenvgroup->labelsize(14);
              voiceFMampenvgroup->labelcolor(FL_FOREGROUND_COLOR);
              voiceFMampenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
              voiceFMampenvgroup->when(FL_WHEN_RELEASE);
              o->init(pars->VoicePar[nvoice].FMAmpEnvelope, npart, kititem, nvoice | 0xc0, 0);
              if (pars->VoicePar[nvoice].PFMAmpEnvelopeEnabled==0) o->deactivate();
              voiceFMampenvgroup->end();
            } // EnvelopeUI* voiceFMampenvgroup
            { Fl_Check_Button* o = ModAmpEn = new Fl_Check_Button(546, 134, 34, 12, "On");
              ModAmpEn->tooltip("Enable Amplitude Envelope");
              ModAmpEn->box(FL_THIN_UP_BOX);
              ModAmpEn->down_box(FL_DOWN_BOX);
              ModAmpEn->color((Fl_Color)237);
              ModAmpEn->labelfont(1);
              ModAmpEn->labelsize(10);
              ModAmpEn->callback((Fl_Callback*)cb_ModAmpEn);
              o->value(pars->VoicePar[nvoice].PFMAmpEnvelopeEnabled);
            } // Fl_Check_Button* ModAmpEn
            { mwheel_val_slider_rev* o = ModFdamp = new mwheel_val_slider_rev(540, 110, 160, 15, "F.Damp");
              ModFdamp->tooltip("Modulator Damp at Higher frequency");
              ModFdamp->type(5);
              ModFdamp->box(FL_THIN_DOWN_BOX);
              ModFdamp->color(FL_BACKGROUND_COLOR);
              ModFdamp->selection_color(FL_BACKGROUND_COLOR);
              ModFdamp->labeltype(FL_NORMAL_LABEL);
              ModFdamp->labelfont(0);
              ModFdamp->labelsize(11);
              ModFdamp->labelcolor(FL_FOREGROUND_COLOR);
              ModFdamp->minimum(-64);
              ModFdamp->maximum(63);
              ModFdamp->step(1);
              ModFdamp->callback((Fl_Callback*)cb_ModFdamp);
              ModFdamp->align(Fl_Align(FL_ALIGN_RIGHT));
              ModFdamp->when(FL_WHEN_CHANGED);
              o->value(pars->VoicePar[nvoice].PFMVolumeDamp-64);
            } // mwheel_val_slider_rev* ModFdamp
            o->end();
          } // Fl_Group* o
          { modoscil = new Fl_Group(535, 365, 220, 200, "Mod Oscilator");
            modoscil->box(FL_THIN_UP_BOX);
            modoscil->labelfont(1);
            modoscil->labelsize(11);
            modoscil->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
            { Fl_Group* o = fmoscil = new Fl_Group(535, 425, 220, 140);
              fmoscil->box(FL_THIN_DOWN_BOX);
              fmoscil->color(FL_GRAY0);
              fmoscil->selection_color((Fl_Color)71);
              fmoscil->labelcolor((Fl_Color)179);
              oscFM = new Oscilloscope(o->x(),o->y(),o->w(),o->h(),"");
              int nv=nvoice; if (pars->VoicePar[nvoice].PextFMoscil>=0) nv=pars->VoicePar[nvoice].PextFMoscil;
              oscFM->init(pars->VoicePar[nv].FMSmp,0,pars->VoicePar[nvoice].PFMoscilphase, synth);
              fmoscil->end();
            } // Fl_Group* fmoscil
            { Fl_Box* o = new Fl_Box(535, 365, 155, 20, "Mod.Oscillator");
              o->labelfont(1);
              o->labelsize(12);
              o->align(Fl_Align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE));
              o->hide();
              o->deactivate();
            } // Fl_Box* o
            { Fl_Button* o = changeFMoscilbutton = new Fl_Button(704, 368, 43, 12, "Change");
              changeFMoscilbutton->box(FL_THIN_UP_BOX);
              changeFMoscilbutton->labelfont(1);
              changeFMoscilbutton->labelsize(9);
              changeFMoscilbutton->callback((Fl_Callback*)cb_changeFMoscilbutton);
              if (pars->VoicePar[nvoice].PextFMoscil>=0) o->labelcolor(FL_BLUE);
            } // Fl_Button* changeFMoscilbutton
            { mwheel_slider_rev* o = ModPhase = new mwheel_slider_rev(665, 396, 65, 12, "Phase");
              ModPhase->type(5);
              ModPhase->box(FL_THIN_DOWN_BOX);
              ModPhase->color(FL_BACKGROUND_COLOR);
              ModPhase->selection_color(FL_BACKGROUND_COLOR);
              ModPhase->labeltype(FL_NORMAL_LABEL);
              ModPhase->labelfont(0);
              ModPhase->labelsize(10);
              ModPhase->labelcolor(FL_FOREGROUND_COLOR);
              ModPhase->minimum(-64);
              ModPhase->maximum(63);
              ModPhase->step(1);
              ModPhase->callback((Fl_Callback*)cb_ModPhase);
              ModPhase->align(Fl_Align(FL_ALIGN_TOP));
              ModPhase->when(FL_WHEN_CHANGED);
              o->value(64-pars->VoicePar[nvoice].PFMoscilphase);
            } // mwheel_slider_rev* ModPhase
            { Fl_Choice* o = ExtModOsc = new Fl_Choice(560, 395, 75, 15, "Use");
              ExtModOsc->down_box(FL_BORDER_BOX);
              ExtModOsc->selection_color(FL_BACKGROUND_COLOR);
              ExtModOsc->labelsize(10);
              ExtModOsc->textfont(1);
              ExtModOsc->textsize(10);
              ExtModOsc->callback((Fl_Callback*)cb_ExtModOsc);
              o->add("Internal");
              char tmp[50]; for (int i = 0; i < nvoice; ++i) {sprintf(tmp, "ExtM.%2d", i + 1); o->add(tmp);};
              o->value(pars->VoicePar[nvoice].PextFMoscil + 1);
            } // Fl_Choice* ExtModOsc
            modoscil->end();
          } // Fl_Group* modoscil
          { Fl_Choice* o = ExtMod = new Fl_Choice(670, 32, 85, 20, "External Mod.");
            ExtMod->down_box(FL_BORDER_BOX);
            ExtMod->selection_color(FL_BACKGROUND_COLOR);
            ExtMod->labelsize(10);
            ExtMod->textfont(1);
            ExtMod->textsize(10);
            ExtMod->callback((Fl_Callback*)cb_ExtMod);
            ExtMod->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->add("OFF");
            char tmp[50]; for (int i = 0; i < nvoice; ++i) {sprintf(tmp, "ExtMod.%2d", i + 1); o->add(tmp);};
            o->value(pars->VoicePar[nvoice].PFMVoice + 1);
            if (lrint(o->value())) {modoscil->deactivate(); modfrequency->deactivate();}
          } // Fl_Choice* ExtMod
          if (pars->VoicePar[nvoice].PFMEnabled==0) o->deactivate();
          voiceFMparametersgroup->end();
        } // Fl_Group* voiceFMparametersgroup
        { Fl_Choice* o = ModType = new Fl_Choice(535, 32, 90, 20, "Type:");
          ModType->down_box(FL_BORDER_BOX);
          ModType->color((Fl_Color)237);
          ModType->selection_color(FL_BACKGROUND_COLOR);
          ModType->labelsize(11);
          ModType->textsize(11);
          ModType->callback((Fl_Callback*)cb_ModType);
          ModType->align(Fl_Align(FL_ALIGN_TOP_LEFT));
          ModType->menu(menu_ModType);
          o->value(pars->VoicePar[nvoice].PFMEnabled);
        } // Fl_Choice* ModType
        { Fl_Group* o = new Fl_Group(5, 250, 525, 120, "FREQUENCY");
          o->box(FL_THIN_UP_BOX);
          o->labelfont(1);
          o->labelsize(12);
          o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
          { EnvelopeUI* o = voicefreqenvgroup = new EnvelopeUI(10, 295, 205, 70, "ADSynth Voice - Frequency Envelope");
            voicefreqenvgroup->box(FL_FLAT_BOX);
            voicefreqenvgroup->color((Fl_Color)51);
            voicefreqenvgroup->selection_color(FL_BACKGROUND_COLOR);
            voicefreqenvgroup->labeltype(FL_NORMAL_LABEL);
            voicefreqenvgroup->labelfont(0);
            voicefreqenvgroup->labelsize(14);
            voicefreqenvgroup->labelcolor(FL_FOREGROUND_COLOR);
            voicefreqenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
            voicefreqenvgroup->when(FL_WHEN_RELEASE);
            o->init(pars->VoicePar[nvoice].FreqEnvelope, npart, kititem, nvoice | 0x80, 1);
            if (pars->VoicePar[nvoice].PFreqEnvelopeEnabled==0) o->deactivate();
            voicefreqenvgroup->end();
          } // EnvelopeUI* voicefreqenvgroup
          { Fl_Check_Button* o = FreqEn = new Fl_Check_Button(15, 300, 34, 12, "On");
            FreqEn->tooltip("Enable Frequency Envelope");
            FreqEn->box(FL_THIN_UP_BOX);
            FreqEn->down_box(FL_DOWN_BOX);
            FreqEn->color((Fl_Color)237);
            FreqEn->labelfont(1);
            FreqEn->labelsize(10);
            FreqEn->callback((Fl_Callback*)cb_FreqEn);
            o->value(pars->VoicePar[nvoice].PFreqEnvelopeEnabled);
          } // Fl_Check_Button* FreqEn
          { LFOUI* o = voicefreqlfogroup = new LFOUI(215, 295, 230, 70, "Frequency LFO     ");
            voicefreqlfogroup->box(FL_FLAT_BOX);
            voicefreqlfogroup->color(FL_DARK1);
            voicefreqlfogroup->selection_color(FL_BACKGROUND_COLOR);
            voicefreqlfogroup->labeltype(FL_NORMAL_LABEL);
            voicefreqlfogroup->labelfont(0);
            voicefreqlfogroup->labelsize(14);
            voicefreqlfogroup->labelcolor(FL_FOREGROUND_COLOR);
            voicefreqlfogroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
            voicefreqlfogroup->when(FL_WHEN_RELEASE);
            o->init(pars->VoicePar[nvoice].FreqLfo, npart, kititem, 128 + nvoice, 1);
            if (pars->VoicePar[nvoice].PFreqLfoEnabled==0) o->deactivate();
            voicefreqlfogroup->end();
          } // LFOUI* voicefreqlfogroup
          { Fl_Check_Button* o = FreqLfoEn = new Fl_Check_Button(220, 300, 34, 12, "On");
            FreqLfoEn->tooltip("Enable Frequency LFO");
            FreqLfoEn->box(FL_THIN_UP_BOX);
            FreqLfoEn->down_box(FL_DOWN_BOX);
            FreqLfoEn->color((Fl_Color)237);
            FreqLfoEn->labelfont(1);
            FreqLfoEn->labelsize(10);
            FreqLfoEn->callback((Fl_Callback*)cb_FreqLfoEn);
            o->value(pars->VoicePar[nvoice].PFreqLfoEnabled);
          } // Fl_Check_Button* FreqLfoEn
          { Fl_Counter* o = Octave = new Fl_Counter(464, 276, 45, 15, "Octave");
            Octave->tooltip("Octave");
            Octave->type(1);
            Octave->color((Fl_Color)237);
            Octave->selection_color(FL_FOREGROUND_COLOR);
            Octave->labelsize(10);
            Octave->minimum(-8);
            Octave->maximum(7);
            Octave->step(1);
            Octave->value(4);
            Octave->textfont(1);
            Octave->textsize(11);
            Octave->callback((Fl_Callback*)cb_Octave);
            Octave->align(Fl_Align(FL_ALIGN_TOP));
            int k = pars->VoicePar[nvoice].PCoarseDetune / 1024;
            if (k >= 8) k -= 16;
            o->value(k);
          } // Fl_Counter* Octave
          { Fl_Counter* o = CoarseDetune = new Fl_Counter(455, 345, 60, 20, "Coarse Det.");
            CoarseDetune->tooltip("Coarse Detune");
            CoarseDetune->labelsize(10);
            CoarseDetune->minimum(-64);
            CoarseDetune->maximum(63);
            CoarseDetune->step(1);
            CoarseDetune->textfont(1);
            CoarseDetune->textsize(11);
            CoarseDetune->callback((Fl_Callback*)cb_CoarseDetune);
            CoarseDetune->align(Fl_Align(FL_ALIGN_TOP));
            int k = pars->VoicePar[nvoice].PCoarseDetune % 1024;
            if (k >= 512) k -= 1024;
            o->value(k);
            o->lstep(10);
          } // Fl_Counter* CoarseDetune
          { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(10, 276, 38, 16, "Detune");
            detunevalueoutput->box(FL_THIN_DOWN_BOX);
            detunevalueoutput->labelsize(10);
            detunevalueoutput->minimum(-5000);
            detunevalueoutput->maximum(5000);
            detunevalueoutput->textfont(1);
            detunevalueoutput->textsize(10);
            detunevalueoutput->callback((Fl_Callback*)cb_detunevalueoutput1);
            detunevalueoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->step(0.01, 1);
            o->value(getDetune((pars->VoicePar[nvoice].PDetuneType==0)?(pars->GlobalPar.PDetuneType) : (pars->VoicePar[nvoice].PDetuneType),0,pars->VoicePar[nvoice].PDetune)*pars->getBandwidthDetuneMultiplier());
          } // Fl_Value_Output* detunevalueoutput
          { mwheel_slider_rev* o = Detune = new mwheel_slider_rev(48, 276, 397, 16);
            Detune->tooltip("Fine Detune (cents)");
            Detune->type(5);
            Detune->box(FL_THIN_DOWN_BOX);
            Detune->color(FL_BACKGROUND_COLOR);
            Detune->selection_color(FL_BACKGROUND_COLOR);
            Detune->labeltype(FL_NORMAL_LABEL);
            Detune->labelfont(0);
            Detune->labelsize(14);
            Detune->labelcolor(FL_FOREGROUND_COLOR);
            Detune->minimum(-8192);
            Detune->maximum(8191);
            Detune->step(1);
            Detune->callback((Fl_Callback*)cb_Detune);
            Detune->align(Fl_Align(FL_ALIGN_BOTTOM));
            Detune->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].PDetune-8192);
          } // mwheel_slider_rev* Detune
          { Fl_Check_Button* o = Freq440 = new Fl_Check_Button(340, 256, 55, 15, "440Hz");
            Freq440->tooltip("Set the voice base frequency to 440Hz");
            Freq440->down_box(FL_DOWN_BOX);
            Freq440->labelfont(1);
            Freq440->labelsize(11);
            Freq440->callback((Fl_Callback*)cb_Freq440);
            o->value(pars->VoicePar[nvoice].Pfixedfreq);
          } // Fl_Check_Button* Freq440
          { WidgetPDial* o = fixedfreqetdial = new WidgetPDial(400, 254, 20, 20, "Eq.T.");
            fixedfreqetdial->tooltip("How the frequency varies according to the keyboard (leftmost for fixed freque\
ncy)");
            fixedfreqetdial->box(FL_ROUND_UP_BOX);
            fixedfreqetdial->color(FL_BACKGROUND_COLOR);
            fixedfreqetdial->selection_color(FL_INACTIVE_COLOR);
            fixedfreqetdial->labeltype(FL_NORMAL_LABEL);
            fixedfreqetdial->labelfont(0);
            fixedfreqetdial->labelsize(10);
            fixedfreqetdial->labelcolor(FL_FOREGROUND_COLOR);
            fixedfreqetdial->maximum(127);
            fixedfreqetdial->step(1);
            fixedfreqetdial->callback((Fl_Callback*)cb_fixedfreqetdial);
            fixedfreqetdial->align(Fl_Align(FL_ALIGN_RIGHT));
            fixedfreqetdial->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].PfixedfreqET);
            if (pars->VoicePar[nvoice].Pfixedfreq==0) o->deactivate();
            o->init(0);
            o->setValueType(VC_FixedFreqET);
          } // WidgetPDial* fixedfreqetdial
          { Fl_Choice* o = FreqDetunetype = new Fl_Choice(450, 310, 75, 15, "Detune Type");
            FreqDetunetype->down_box(FL_BORDER_BOX);
            FreqDetunetype->labelsize(10);
            FreqDetunetype->textfont(1);
            FreqDetunetype->textsize(10);
            FreqDetunetype->callback((Fl_Callback*)cb_FreqDetunetype);
            FreqDetunetype->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->add("Default");o->add("L35cents");o->add("L10cents");o->add("E100cents");o->add("E1200cents");
            o->value(pars->VoicePar[nvoice].PDetuneType);
          } // Fl_Choice* FreqDetunetype
          { WidgetPDial* o = bend = new WidgetPDial(70, 254, 20, 20, "Bend");
            bend->tooltip("Pitch bend scaling for this voice");
            bend->box(FL_ROUND_UP_BOX);
            bend->color(FL_BACKGROUND_COLOR);
            bend->selection_color(FL_INACTIVE_COLOR);
            bend->labeltype(FL_NORMAL_LABEL);
            bend->labelfont(0);
            bend->labelsize(10);
            bend->labelcolor(FL_FOREGROUND_COLOR);
            bend->maximum(127);
            bend->step(1);
            bend->callback((Fl_Callback*)cb_bend);
            bend->align(Fl_Align(FL_ALIGN_RIGHT));
            bend->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].PBendAdjust);
            o->init(88);
            o->setValueType(VC_PitchBend);
          } // WidgetPDial* bend
          { WidgetPDial* o = offset = new WidgetPDial(130, 254, 20, 20, "Offset");
            offset->tooltip("Offset of the frequency in Hz.");
            offset->box(FL_ROUND_UP_BOX);
            offset->color(FL_BACKGROUND_COLOR);
            offset->selection_color(FL_INACTIVE_COLOR);
            offset->labeltype(FL_NORMAL_LABEL);
            offset->labelfont(0);
            offset->labelsize(10);
            offset->labelcolor(FL_FOREGROUND_COLOR);
            offset->maximum(127);
            offset->step(1);
            offset->callback((Fl_Callback*)cb_offset);
            offset->align(Fl_Align(FL_ALIGN_RIGHT));
            offset->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].POffsetHz);
            o->init(64);
            o->setValueType(VC_FreqOffsetHz);
          } // WidgetPDial* offset
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = voiceoscil = new Fl_Group(80, 375, 445, 145);
          voiceoscil->box(FL_THIN_DOWN_BOX);
          voiceoscil->color(FL_GRAY0);
          voiceoscil->selection_color((Fl_Color)71);
          voiceoscil->labelcolor((Fl_Color)179);
          osc = new Oscilloscope(o->x(),o->y(),o->w(),o->h(), "");
          //
                int nv = nvoice;
                if (pars->VoicePar[nvoice].Pextoscil >= 0)
                    nv = pars->VoicePar[nvoice].Pextoscil;
          //
                osc->init(pars->VoicePar[nv].OscilSmp, 0,
                          pars->VoicePar[nvoice].Poscilphase, synth);
          voiceoscil->end();
        } // Fl_Group* voiceoscil
        { Fl_Button* o = changevoiceoscilbutton = new Fl_Button(5, 475, 65, 20, "Change");
          changevoiceoscilbutton->box(FL_THIN_UP_BOX);
          changevoiceoscilbutton->labelfont(1);
          changevoiceoscilbutton->labelsize(11);
          changevoiceoscilbutton->callback((Fl_Callback*)cb_changevoiceoscilbutton);
          if (pars->VoicePar[nvoice].Pextoscil>=0) o->labelcolor(FL_BLUE);
        } // Fl_Button* changevoiceoscilbutton
        { Fl_Box* o = new Fl_Box(5, 375, 75, 35, "Voice Oscillator");
          o->labelfont(1);
          o->labelsize(12);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        { mwheel_slider_rev* o = VoiceOscPhase = new mwheel_slider_rev(9, 420, 65, 12, "Phase");
          VoiceOscPhase->type(5);
          VoiceOscPhase->box(FL_THIN_DOWN_BOX);
          VoiceOscPhase->color(FL_BACKGROUND_COLOR);
          VoiceOscPhase->selection_color(FL_BACKGROUND_COLOR);
          VoiceOscPhase->labeltype(FL_NORMAL_LABEL);
          VoiceOscPhase->labelfont(0);
          VoiceOscPhase->labelsize(10);
          VoiceOscPhase->labelcolor(FL_FOREGROUND_COLOR);
          VoiceOscPhase->minimum(-64);
          VoiceOscPhase->maximum(63);
          VoiceOscPhase->step(1);
          VoiceOscPhase->callback((Fl_Callback*)cb_VoiceOscPhase);
          VoiceOscPhase->align(Fl_Align(FL_ALIGN_TOP));
          VoiceOscPhase->when(FL_WHEN_CHANGED);
          o->value(64-pars->VoicePar[nvoice].Poscilphase);
        } // mwheel_slider_rev* VoiceOscPhase
        { Fl_Box* o = new Fl_Box(189, 5, 54, 35);
          o->box(FL_THIN_UP_BOX);
        } // Fl_Box* o
        { Fl_Check_Button* o = ResonanceEn = new Fl_Check_Button(209, 20, 17, 19, "Reson");
          ResonanceEn->tooltip("Resonance On/Off");
          ResonanceEn->down_box(FL_DOWN_BOX);
          ResonanceEn->labelfont(1);
          ResonanceEn->labelsize(11);
          ResonanceEn->callback((Fl_Callback*)cb_ResonanceEn);
          ResonanceEn->align(Fl_Align(FL_ALIGN_TOP));
          o->value(pars->VoicePar[nvoice].Presonance);
        } // Fl_Check_Button* ResonanceEn
        { Fl_Choice* o = UseOsc = new Fl_Choice(5, 455, 65, 15, "Use Oscil.");
          UseOsc->down_box(FL_BORDER_BOX);
          UseOsc->selection_color(FL_BACKGROUND_COLOR);
          UseOsc->labelsize(10);
          UseOsc->textfont(1);
          UseOsc->textsize(10);
          UseOsc->callback((Fl_Callback*)cb_UseOsc);
          UseOsc->align(Fl_Align(FL_ALIGN_TOP));
          o->add("Internal");
          char tmp[50]; for (int i = 0; i < nvoice; ++i) {sprintf(tmp, "Ext.%2d", i + 1); o->add(tmp);};
          o->value(pars->VoicePar[nvoice].Pextoscil + 1);
        } // Fl_Choice* UseOsc
        { Fl_Check_Button* o = UnisonEn = new Fl_Check_Button(31, 543, 19, 15, "Unison");
          UnisonEn->tooltip("Enable/Disable");
          UnisonEn->down_box(FL_DOWN_BOX);
          UnisonEn->labelfont(1);
          UnisonEn->labelsize(12);
          UnisonEn->callback((Fl_Callback*)cb_UnisonEn);
          UnisonEn->align(Fl_Align(FL_ALIGN_TOP));
          int tmp = (pars->VoicePar[nvoice].Unison_size);
          o->value(tmp > 1);
        } // Fl_Check_Button* UnisonEn
        { Fl_Group* o = unisongroup = new Fl_Group(80, 524, 445, 48);
          unisongroup->box(FL_PLASTIC_UP_BOX);
          unisongroup->color((Fl_Color)231);
          unisongroup->deactivate();
          { Fl_Spinner* o = unisonsize = new Fl_Spinner(90, 544, 40, 16, "Size");
            unisonsize->tooltip("Number of unison sub-voices");
            unisonsize->box(FL_THIN_UP_BOX);
            unisonsize->color(FL_BACKGROUND2_COLOR);
            unisonsize->labelfont(1);
            unisonsize->labelsize(11);
            unisonsize->minimum(2);
            unisonsize->maximum(50);
            unisonsize->value(2);
            unisonsize->textsize(12);
            unisonsize->callback((Fl_Callback*)cb_unisonsize);
            unisonsize->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            int tmp = pars->VoicePar[nvoice].Unison_size;
            if (tmp < 2) tmp = 2;
            o->value(tmp);
          } // Fl_Spinner* unisonsize
          { WidgetPDial* o = UnisonStereo = new WidgetPDial(349, 540, 25, 25, "Stereo");
            UnisonStereo->tooltip("Stereo Spread");
            UnisonStereo->box(FL_ROUND_UP_BOX);
            UnisonStereo->color(FL_BACKGROUND_COLOR);
            UnisonStereo->selection_color(FL_INACTIVE_COLOR);
            UnisonStereo->labeltype(FL_NORMAL_LABEL);
            UnisonStereo->labelfont(0);
            UnisonStereo->labelsize(10);
            UnisonStereo->labelcolor(FL_FOREGROUND_COLOR);
            UnisonStereo->maximum(127);
            UnisonStereo->step(1);
            UnisonStereo->callback((Fl_Callback*)cb_UnisonStereo);
            UnisonStereo->align(Fl_Align(FL_ALIGN_TOP));
            UnisonStereo->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_stereo_spread);
            o->init(64);
          } // WidgetPDial* UnisonStereo
          { WidgetPDial* o = UnisonVib = new WidgetPDial(384, 540, 25, 25, "Vib.");
            UnisonVib->tooltip("Vibratto");
            UnisonVib->box(FL_ROUND_UP_BOX);
            UnisonVib->color(FL_BACKGROUND_COLOR);
            UnisonVib->selection_color(FL_INACTIVE_COLOR);
            UnisonVib->labeltype(FL_NORMAL_LABEL);
            UnisonVib->labelfont(0);
            UnisonVib->labelsize(10);
            UnisonVib->labelcolor(FL_FOREGROUND_COLOR);
            UnisonVib->maximum(127);
            UnisonVib->step(1);
            UnisonVib->callback((Fl_Callback*)cb_UnisonVib);
            UnisonVib->align(Fl_Align(FL_ALIGN_TOP));
            UnisonVib->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_vibratto);
            o->init(64);
          } // WidgetPDial* UnisonVib
          { Fl_Choice* o = UnisonInvert = new Fl_Choice(451, 545, 67, 15, "Invert");
            UnisonInvert->tooltip("Phase Invert");
            UnisonInvert->down_box(FL_BORDER_BOX);
            UnisonInvert->labelsize(11);
            UnisonInvert->textfont(1);
            UnisonInvert->textsize(10);
            UnisonInvert->callback((Fl_Callback*)cb_UnisonInvert);
            UnisonInvert->align(Fl_Align(FL_ALIGN_TOP));
            //
                  o->add("None");
                  o->add("Random");
                  for (int i = 2; i <= 5; ++i)
                  {
                      string tmp = asString(100 / i) + string(" %");
                      o->add(tmp.c_str());
                  }
            o->value(pars->VoicePar[nvoice].Unison_invert_phase);
          } // Fl_Choice* UnisonInvert
          { mwheel_slider_rev* o = UnisonFreqSpread = new mwheel_slider_rev(185, 545, 120, 16, "Frequency Spread");
            UnisonFreqSpread->tooltip("Frequency Spread of the Unison");
            UnisonFreqSpread->type(5);
            UnisonFreqSpread->box(FL_THIN_DOWN_BOX);
            UnisonFreqSpread->color(FL_BACKGROUND_COLOR);
            UnisonFreqSpread->selection_color(FL_BACKGROUND_COLOR);
            UnisonFreqSpread->labeltype(FL_NORMAL_LABEL);
            UnisonFreqSpread->labelfont(0);
            UnisonFreqSpread->labelsize(12);
            UnisonFreqSpread->labelcolor(FL_FOREGROUND_COLOR);
            UnisonFreqSpread->maximum(127);
            UnisonFreqSpread->step(1);
            UnisonFreqSpread->value(64);
            UnisonFreqSpread->callback((Fl_Callback*)cb_UnisonFreqSpread);
            UnisonFreqSpread->align(Fl_Align(FL_ALIGN_TOP_RIGHT));
            UnisonFreqSpread->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_frequency_spread);
          } // mwheel_slider_rev* UnisonFreqSpread
          { Fl_Value_Output* o = unisonspreadoutput = new Fl_Value_Output(150, 545, 38, 16, "(cents)");
            unisonspreadoutput->box(FL_THIN_DOWN_BOX);
            unisonspreadoutput->labelsize(10);
            unisonspreadoutput->maximum(1000);
            unisonspreadoutput->textfont(1);
            unisonspreadoutput->textsize(10);
            unisonspreadoutput->callback((Fl_Callback*)cb_unisonspreadoutput);
            unisonspreadoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->step(0.1, 1);
            o->value(pars->getUnisonFrequencySpreadCents(nvoice));
          } // Fl_Value_Output* unisonspreadoutput
          { WidgetPDial* o = UnisonVspeed = new WidgetPDial(420, 540, 25, 25, "V.speed");
            UnisonVspeed->tooltip("Vibratto Average Speed");
            UnisonVspeed->box(FL_ROUND_UP_BOX);
            UnisonVspeed->color(FL_BACKGROUND_COLOR);
            UnisonVspeed->selection_color(FL_INACTIVE_COLOR);
            UnisonVspeed->labeltype(FL_NORMAL_LABEL);
            UnisonVspeed->labelfont(0);
            UnisonVspeed->labelsize(10);
            UnisonVspeed->labelcolor(FL_FOREGROUND_COLOR);
            UnisonVspeed->maximum(127);
            UnisonVspeed->step(1);
            UnisonVspeed->callback((Fl_Callback*)cb_UnisonVspeed);
            UnisonVspeed->align(Fl_Align(FL_ALIGN_TOP));
            UnisonVspeed->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_vibratto_speed);
            o->init(64);
          } // WidgetPDial* UnisonVspeed
          { WidgetPDial* o = UnisonPhRnd = new WidgetPDial(315, 540, 25, 25, "Ph.rnd");
            UnisonPhRnd->tooltip("Phase randomness");
            UnisonPhRnd->box(FL_ROUND_UP_BOX);
            UnisonPhRnd->color(FL_BACKGROUND_COLOR);
            UnisonPhRnd->selection_color(FL_INACTIVE_COLOR);
            UnisonPhRnd->labeltype(FL_NORMAL_LABEL);
            UnisonPhRnd->labelfont(0);
            UnisonPhRnd->labelsize(10);
            UnisonPhRnd->labelcolor(FL_FOREGROUND_COLOR);
            UnisonPhRnd->maximum(127);
            UnisonPhRnd->step(1);
            UnisonPhRnd->callback((Fl_Callback*)cb_UnisonPhRnd);
            UnisonPhRnd->align(Fl_Align(FL_ALIGN_TOP_RIGHT));
            UnisonPhRnd->when(FL_WHEN_CHANGED);
            o->value(pars->VoicePar[nvoice].Unison_phase_randomness);
            o->init(127);
          } // WidgetPDial* UnisonPhRnd
          int tmp = pars->VoicePar[nvoice].Unison_size; if (tmp > 1) o->activate();
          unisonsize->labelcolor(FL_BLACK);int i = -1; while (true){ i++; if(pars->ADnote_unison_sizes[i] == 0) break; if (pars->ADnote_unison_sizes[i] == tmp){ unisonsize->labelcolor(FL_RED); break;}}
          unisongroup->end();
        } // Fl_Group* unisongroup
        voicemodegroup->end();
      } // Fl_Group* voicemodegroup
      { amplitudegroup = new Fl_Group(5, 40, 240, 210, "AMPLITUDE");
        amplitudegroup->box(FL_THIN_UP_BOX);
        amplitudegroup->labelfont(1);
        amplitudegroup->labelsize(12);
        amplitudegroup->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
        { WidgetPDial* o = voicevolume = new WidgetPDial(42, 57, 34, 34, "Volume");
          voicevolume->tooltip("Volume");
          voicevolume->box(FL_ROUND_UP_BOX);
          voicevolume->color(FL_BACKGROUND_COLOR);
          voicevolume->selection_color(FL_INACTIVE_COLOR);
          voicevolume->labeltype(FL_NORMAL_LABEL);
          voicevolume->labelfont(0);
          voicevolume->labelsize(10);
          voicevolume->labelcolor(FL_FOREGROUND_COLOR);
          voicevolume->maximum(127);
          voicevolume->step(1);
          voicevolume->callback((Fl_Callback*)cb_voicevolume1);
          voicevolume->align(Fl_Align(FL_ALIGN_BOTTOM));
          voicevolume->when(FL_WHEN_CHANGED);
          o->setValueType(VC_ADDVoiceVolume);
          o->value(pars->VoicePar[nvoice].PVolume);
        } // WidgetPDial* voicevolume
        { WidgetPDial* o = voicevsns = new WidgetPDial(107, 57, 34, 34, "Vel Sens");
          voicevsns->tooltip("Velocity Sensing Function - rightmost/max disables)");
          voicevsns->box(FL_ROUND_UP_BOX);
          voicevsns->color(FL_BACKGROUND_COLOR);
          voicevsns->selection_color(FL_INACTIVE_COLOR);
          voicevsns->labeltype(FL_NORMAL_LABEL);
          voicevsns->labelfont(0);
          voicevsns->labelsize(10);
          voicevsns->labelcolor(FL_FOREGROUND_COLOR);
          voicevsns->maximum(127);
          voicevsns->step(1);
          voicevsns->callback((Fl_Callback*)cb_voicevsns);
          voicevsns->align(Fl_Align(FL_ALIGN_BOTTOM));
          voicevsns->when(FL_WHEN_CHANGED);
          o->value(pars->VoicePar[nvoice].PAmpVelocityScaleFunction);
          o->init(127);
          o->setValueType(VC_AmpVelocitySense);
        } // WidgetPDial* voicevsns
        { EnvelopeUI* o = voiceampenvgroup = new EnvelopeUI(10, 105, 205, 70, "ADSynth Voice - Amplitude Envelope");
          voiceampenvgroup->box(FL_FLAT_BOX);
          voiceampenvgroup->color((Fl_Color)51);
          voiceampenvgroup->selection_color(FL_BACKGROUND_COLOR);
          voiceampenvgroup->labeltype(FL_NORMAL_LABEL);
          voiceampenvgroup->labelfont(0);
          voiceampenvgroup->labelsize(14);
          voiceampenvgroup->labelcolor(FL_FOREGROUND_COLOR);
          voiceampenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voiceampenvgroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].AmpEnvelope, npart, kititem, nvoice | 0x80, 0);
          if (!pars->VoicePar[nvoice].PAmpEnvelopeEnabled) o->deactivate();
          voiceampenvgroup->end();
        } // EnvelopeUI* voiceampenvgroup
        { WidgetPDial* o = voicepan = new WidgetPDial(174, 57, 34, 34, "Pan");
          voicepan->tooltip("Voice panning - leftmost/zero gives random panning");
          voicepan->box(FL_ROUND_UP_BOX);
          voicepan->color(FL_BACKGROUND_COLOR);
          voicepan->selection_color(FL_INACTIVE_COLOR);
          voicepan->labeltype(FL_NORMAL_LABEL);
          voicepan->labelfont(0);
          voicepan->labelsize(10);
          voicepan->labelcolor(FL_FOREGROUND_COLOR);
          voicepan->maximum(127);
          voicepan->step(1);
          voicepan->callback((Fl_Callback*)cb_voicepan);
          voicepan->align(Fl_Align(FL_ALIGN_BOTTOM_LEFT));
          voicepan->when(FL_WHEN_CHANGED);
          o->setValueType(VC_PanningRandom);
          o->value(pars->VoicePar[nvoice].PPanning);
          o->init(64);
        } // WidgetPDial* voicepan
        { Fl_Light_Button* o = voicerandompan = new Fl_Light_Button(196, 92, 7, 13, "Rand");
          voicerandompan->tooltip("Voice random panning On/Off");
          voicerandompan->box(FL_NO_BOX);
          voicerandompan->color((Fl_Color)35);
          voicerandompan->selection_color(FL_RED);
          voicerandompan->labelsize(10);
          voicerandompan->callback((Fl_Callback*)cb_voicerandompan);
          voicerandompan->align(Fl_Align(72));
          o->value(pars->randomVoicePan(nvoice));
        } // Fl_Light_Button* voicerandompan
        { Fl_Check_Button* o = AmpEnvEn = new Fl_Check_Button(15, 109, 34, 12, "On");
          AmpEnvEn->tooltip("Enable Amplitude Envelope");
          AmpEnvEn->box(FL_THIN_UP_BOX);
          AmpEnvEn->down_box(FL_DOWN_BOX);
          AmpEnvEn->color((Fl_Color)237);
          AmpEnvEn->labelfont(1);
          AmpEnvEn->labelsize(10);
          AmpEnvEn->callback((Fl_Callback*)cb_AmpEnvEn);
          o->value(pars->VoicePar[nvoice].PAmpEnvelopeEnabled);
        } // Fl_Check_Button* AmpEnvEn
        { LFOUI* o = voiceamplfogroup = new LFOUI(10, 175, 230, 70, "Amplitude LFO     ");
          voiceamplfogroup->box(FL_FLAT_BOX);
          voiceamplfogroup->color(FL_DARK1);
          voiceamplfogroup->selection_color(FL_BACKGROUND_COLOR);
          voiceamplfogroup->labeltype(FL_NORMAL_LABEL);
          voiceamplfogroup->labelfont(0);
          voiceamplfogroup->labelsize(14);
          voiceamplfogroup->labelcolor(FL_FOREGROUND_COLOR);
          voiceamplfogroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voiceamplfogroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].AmpLfo, npart, kititem, 128 + nvoice, 0);
          if (pars->VoicePar[nvoice].PAmpLfoEnabled==0) o->deactivate();
          voiceamplfogroup->end();
        } // LFOUI* voiceamplfogroup
        { Fl_Check_Button* o = AmpLfoEn = new Fl_Check_Button(15, 180, 34, 12, "On");
          AmpLfoEn->tooltip("Enable Amplitude LFO");
          AmpLfoEn->box(FL_THIN_UP_BOX);
          AmpLfoEn->down_box(FL_DOWN_BOX);
          AmpLfoEn->color((Fl_Color)237);
          AmpLfoEn->labelfont(1);
          AmpLfoEn->labelsize(10);
          AmpLfoEn->callback((Fl_Callback*)cb_AmpLfoEn);
          o->value(pars->VoicePar[nvoice].PAmpLfoEnabled);
        } // Fl_Check_Button* AmpLfoEn
        { Fl_Check_Button* o = VolumeMinus = new Fl_Check_Button(10, 45, 50, 10, "Minus");
          VolumeMinus->tooltip("Reverse phase relative to other voices");
          VolumeMinus->down_box(FL_DOWN_BOX);
          VolumeMinus->labelfont(1);
          VolumeMinus->labelsize(10);
          VolumeMinus->callback((Fl_Callback*)cb_VolumeMinus);
          o->value(pars->VoicePar[nvoice].PVolumeminus);
        } // Fl_Check_Button* VolumeMinus
        amplitudegroup->end();
      } // Fl_Group* amplitudegroup
      { Fl_Group* o = voicefiltergroup = new Fl_Group(245, 5, 285, 245, "FILTER      ");
        voicefiltergroup->box(FL_THIN_UP_FRAME);
        voicefiltergroup->labelfont(1);
        voicefiltergroup->labelsize(12);
        voicefiltergroup->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
        { FilterUI* o = voicefilter = new FilterUI(250, 30, 275, 75, "ADsynth Voice - Filter");
          voicefilter->box(FL_FLAT_BOX);
          voicefilter->color(FL_LIGHT1);
          voicefilter->selection_color(FL_BACKGROUND_COLOR);
          voicefilter->labeltype(FL_NORMAL_LABEL);
          voicefilter->labelfont(0);
          voicefilter->labelsize(14);
          voicefilter->labelcolor(FL_FOREGROUND_COLOR);
          voicefilter->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voicefilter->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].VoiceFilter,&pars->VoicePar[nvoice].PFilterVelocityScale, &pars->VoicePar[nvoice].PFilterVelocityScaleFunction, npart, kititem, 128 + nvoice);
          voicefilter->end();
        } // FilterUI* voicefilter
        { EnvelopeUI* o = voicefilterenvgroup = new EnvelopeUI(250, 105, 275, 70, "ADSynth Voice - Filter Envelope");
          voicefilterenvgroup->box(FL_FLAT_BOX);
          voicefilterenvgroup->color((Fl_Color)51);
          voicefilterenvgroup->selection_color(FL_BACKGROUND_COLOR);
          voicefilterenvgroup->labeltype(FL_NORMAL_LABEL);
          voicefilterenvgroup->labelfont(0);
          voicefilterenvgroup->labelsize(14);
          voicefilterenvgroup->labelcolor(FL_FOREGROUND_COLOR);
          voicefilterenvgroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voicefilterenvgroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].FilterEnvelope, npart, kititem, nvoice | 0x80, 2);
          if (pars->VoicePar[nvoice].PFilterEnvelopeEnabled==0) o->deactivate();
          voicefilterenvgroup->end();
        } // EnvelopeUI* voicefilterenvgroup
        { Fl_Check_Button* o = FilterEnvEn = new Fl_Check_Button(255, 110, 34, 12, "On");
          FilterEnvEn->tooltip("Enable Filter Envelope");
          FilterEnvEn->box(FL_THIN_UP_BOX);
          FilterEnvEn->down_box(FL_DOWN_BOX);
          FilterEnvEn->color((Fl_Color)237);
          FilterEnvEn->labelfont(1);
          FilterEnvEn->labelsize(10);
          FilterEnvEn->callback((Fl_Callback*)cb_FilterEnvEn);
          o->value(pars->VoicePar[nvoice].PFilterEnvelopeEnabled);
        } // Fl_Check_Button* FilterEnvEn
        { LFOUI* o = voicefilterlfogroup = new LFOUI(250, 175, 230, 70, "Filter LFO     ");
          voicefilterlfogroup->box(FL_FLAT_BOX);
          voicefilterlfogroup->color(FL_DARK1);
          voicefilterlfogroup->selection_color(FL_BACKGROUND_COLOR);
          voicefilterlfogroup->labeltype(FL_NORMAL_LABEL);
          voicefilterlfogroup->labelfont(0);
          voicefilterlfogroup->labelsize(14);
          voicefilterlfogroup->labelcolor(FL_FOREGROUND_COLOR);
          voicefilterlfogroup->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
          voicefilterlfogroup->when(FL_WHEN_RELEASE);
          o->init(pars->VoicePar[nvoice].FilterLfo, npart, kititem, 128 + nvoice, 2);
          if (pars->VoicePar[nvoice].PFilterLfoEnabled==0) o->deactivate();
          voicefilterlfogroup->end();
        } // LFOUI* voicefilterlfogroup
        { Fl_Check_Button* o = FilterLfoEn = new Fl_Check_Button(255, 180, 34, 12, "On");
          FilterLfoEn->tooltip("Enable Filter LFO");
          FilterLfoEn->box(FL_THIN_UP_BOX);
          FilterLfoEn->down_box(FL_DOWN_BOX);
          FilterLfoEn->color((Fl_Color)237);
          FilterLfoEn->labelfont(1);
          FilterLfoEn->labelsize(10);
          FilterLfoEn->callback((Fl_Callback*)cb_FilterLfoEn);
          o->value(pars->VoicePar[nvoice].PFilterLfoEnabled);
        } // Fl_Check_Button* FilterLfoEn
        if (pars->VoicePar[nvoice].PFilterEnabled==0) o->deactivate();
        voicefiltergroup->end();
      } // Fl_Group* voicefiltergroup
      { Fl_Box* o = new Fl_Box(5, 5, 89, 35);
        o->box(FL_THIN_UP_FRAME);
      } // Fl_Box* o
      { Fl_Group* o = new Fl_Group(10, 10, 31, 26, "1");
        o->labeltype(FL_EMBOSSED_LABEL);
        o->labelfont(1);
        o->labelsize(22);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
        //
              char tmp[2]; tmp[0] = nvoice + 49; tmp[1] = 0; o->copy_label(tmp);
        o->end();
      } // Fl_Group* o
      { Fl_Choice* o = SoundType = new Fl_Choice(5, 500, 65, 20);
        SoundType->tooltip("Oscillator Type (sound/noise)");
        SoundType->down_box(FL_BORDER_BOX);
        SoundType->selection_color(FL_BACKGROUND_COLOR);
        SoundType->labelsize(10);
        SoundType->textfont(1);
        SoundType->textsize(10);
        SoundType->callback((Fl_Callback*)cb_SoundType);
        SoundType->when(FL_WHEN_RELEASE_ALWAYS);
        SoundType->menu(menu_SoundType);
        o->value(pars->VoicePar[nvoice].Type);
        if (pars->VoicePar[nvoice].Type!=0) voicemodegroup->deactivate();
      } // Fl_Choice* SoundType
      { Fl_Group* o = new Fl_Group(94, 5, 95, 35);
        o->box(FL_THIN_UP_BOX);
        { mwheel_val_slider_rev* o = Delay = new mwheel_val_slider_rev(99, 21, 84, 12, "Delay");
          Delay->tooltip("Time before the voice activates");
          Delay->type(5);
          Delay->box(FL_THIN_DOWN_BOX);
          Delay->color(FL_BACKGROUND_COLOR);
          Delay->selection_color(FL_BACKGROUND_COLOR);
          Delay->labeltype(FL_NORMAL_LABEL);
          Delay->labelfont(0);
          Delay->labelsize(11);
          Delay->labelcolor(FL_FOREGROUND_COLOR);
          Delay->maximum(127);
          Delay->step(1);
          Delay->callback((Fl_Callback*)cb_Delay);
          Delay->align(Fl_Align(FL_ALIGN_TOP));
          Delay->when(FL_WHEN_CHANGED);
          o->value(pars->VoicePar[nvoice].PDelay);
          o->setValueType(VC_ADDVoiceDelay);o->useCustomTip(true);
        } // mwheel_val_slider_rev* Delay
        o->end();
      } // Fl_Group* o
      { Fl_Check_Button* o = bypassfiltercheckbutton = new Fl_Check_Button(415, 11, 14, 14, "Bypass Global F.");
        bypassfiltercheckbutton->down_box(FL_DOWN_BOX);
        bypassfiltercheckbutton->labelfont(1);
        bypassfiltercheckbutton->labelsize(10);
        bypassfiltercheckbutton->callback((Fl_Callback*)cb_bypassfiltercheckbutton);
        bypassfiltercheckbutton->align(Fl_Align(FL_ALIGN_RIGHT));
        o->value(pars->VoicePar[nvoice].Pfilterbypass);
      } // Fl_Check_Button* bypassfiltercheckbutton
      { Fl_Check_Button* o = FilterEn = new Fl_Check_Button(250, 11, 34, 12, "On");
        FilterEn->tooltip("Enable Filter");
        FilterEn->box(FL_THIN_UP_BOX);
        FilterEn->down_box(FL_DOWN_BOX);
        FilterEn->color((Fl_Color)237);
        FilterEn->labelfont(1);
        FilterEn->labelsize(10);
        FilterEn->callback((Fl_Callback*)cb_FilterEn);
        o->value(pars->VoicePar[nvoice].PFilterEnabled);
      } // Fl_Check_Button* FilterEn
      { Fl_Box* o = noiselabel = new Fl_Box(105, 415, 400, 65, "Noise");
        noiselabel->labelfont(1);
        noiselabel->labelsize(50);
        noiselabel->labelcolor(FL_BACKGROUND2_COLOR);
        noiselabel->callback((Fl_Callback*)cb_noiselabel1);
        o->hide(); int tmp = pars->VoicePar[nvoice].Type;
        if (tmp == 1) {o->copy_label("White Noise"); o->labelcolor(7);} else if (tmp > 1) {o->copy_label("Pink Noise"); o->labelcolor(5);}
        if (tmp > 0) o->show();
      } // Fl_Box* noiselabel
      if (pars->VoicePar[nvoice].Enabled==0) o->deactivate();
      voiceparametersgroup->end();
    } // Fl_Group* voiceparametersgroup
    { Fl_Check_Button* o = voiceonbutton = new Fl_Check_Button(44, 15, 41, 15, "On");
      voiceonbutton->box(FL_THIN_UP_BOX);
      voiceonbutton->down_box(FL_DOWN_BOX);
      voiceonbutton->color((Fl_Color)237);
      voiceonbutton->labelfont(1);
      voiceonbutton->labelsize(13);
      voiceonbutton->callback((Fl_Callback*)cb_voiceonbutton);
      o->value(pars->VoicePar[nvoice].Enabled);
    } // Fl_Check_Button* voiceonbutton
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Voice Oscillator").c_str());
    ADnoteVoiceParameters->end();
  } // Fl_Group* ADnoteVoiceParameters
  return ADnoteVoiceParameters;
}

ADvoiceUI::ADvoiceUI(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  //
          nvoice = 0;
          pars = NULL;
          oscedit = NULL;
}

void ADvoiceUI::send_data(int control, float value, int type) {
  //
  collect_data(synth, value, (Fl::event_button() | type), control, npart, kititem, nvoice | 0x80);
}

void ADvoiceUI::returns_update(CommandBlock *getData) {
  //
      float value = getData->data.value;
      unsigned char control = getData->data.control;
      unsigned char voice = getData->data.engine & 0x1f;
      int tmp;
      bool val_bool = (value > 0.5f);
  
      if (voice != nvoice)
          return;
  
      switch(control)
      {
          case 0:
              voicevolume->value(value);
              synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voicevolume->value(value);
              break;
  
          case 1:
              voicevsns->value(value);
              break;
  
          case 2:
              voicepan->value(value);
              voicerandompan->value(value == 0);
              synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voicepanning->value(value);
              break;
  
          case 4:
              VolumeMinus->value(val_bool);
              break;
  
          case 8:
              AmpEnvEn->value(val_bool);
              if (value == 0)
                      voiceampenvgroup->deactivate();
                  else
                      voiceampenvgroup->activate();
              break;
  
          case 9:
              AmpLfoEn->value(val_bool);
              if (value == 0)
                      voiceamplfogroup->deactivate();
                  else
                      voiceamplfogroup->activate();
              break;
  
          case 16:
              ModType->value((int)value);
              if (value == 0)
                      voiceFMparametersgroup->deactivate();
                  else
                      voiceFMparametersgroup->activate();
              break;
  
          case 17:
              tmp = (int) value;
              ExtMod->value(tmp + 1);
              if (tmp >= 0)
                    {
                        modoscil->deactivate();
                        modfrequency->deactivate();
                    }
                    else
                    {
                        modoscil->activate();
                        modfrequency->activate();
                    }
                    voiceFMparametersgroup->redraw();
              break;
  
          case 32:
              Detune->value(value);
              detunevalueoutput->do_callback();
              synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voicedetune->value(value);
              synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->detunevalueoutput->do_callback();
              break;
  
          case 33:
              fixedfreqetdial->value(value);
              break;
  
          case 34:
              Freq440->value(val_bool);
              if (value == 0 && Mod440->value() == 0)
                  fixedfreqetdial->deactivate();
              else
                  fixedfreqetdial->activate();
              break;
  
          case 35:
              Octave->value((int) value);
              break;
  
          case 36:
              FreqDetunetype->value((int) value);
              detunevalueoutput->do_callback();
              break;
  
          case 37:
              CoarseDetune->value((int) value);
              break;
  
          case 38:
              bend->value(value);
              break;
  
          case 39:
              offset->value(value);
              break;
  
          case 40:
              FreqEn->value(val_bool);
              if (value == 0)
                  voicefreqenvgroup->deactivate();
              else
                  voicefreqenvgroup->activate();
              break;
  
          case 41:
              FreqLfoEn->value(val_bool);
               if (value == 0)
                   voicefreqlfogroup->deactivate();
               else
                   voicefreqlfogroup->activate();
              break;
  
          case 48:
              UnisonFreqSpread->value(value);
              unisonspreadoutput->do_callback();
              break;
  
          case 49:
              UnisonPhRnd->value(value);
              break;
  
          case 50:
              UnisonStereo->value(value);
              break;
  
          case 51:
              UnisonVib->value(value);
              break;
  
          case 52:
              UnisonVspeed->value(value);
              break;
  
          case 53:
              {
                  tmp = (int) value;
                  unisonsize->value(tmp);
                  int colr = FL_BLACK;
                  int i = 0;
                  while(pars->ADnote_unison_sizes[i] != 0)
                  {
                      if (pars->ADnote_unison_sizes[i] == tmp)
                      {
                          colr = FL_RED;
                          break;
                      }
                      ++ i;
                  }
                  unisonsize->labelcolor(colr);
                  unisongroup->redraw();
              }
              break;
  
          case 54:
              UnisonInvert->value(value);
              break;
  
          case 56:
              tmp = (int) value;
              UnisonEn->value(tmp);
              if (tmp == 0)
              {
                  unisonsize->value(2);
                  unisongroup->deactivate();
              }
              else
              {
                  tmp = lrint(unisonsize->value());
                  unisongroup->activate();
                  int colr = FL_BLACK;
                  int i = -1;
                  while (true)
                  {
                      ++i;
                      if (pars->ADnote_unison_sizes[i] == 0)
                          break;
                      if (pars->ADnote_unison_sizes[i] == tmp)
                      {
                          colr = FL_RED;
                          break;
                      }
                  }
                  unisonsize->labelcolor(colr);
                  unisongroup->redraw();
              }
              break;
  
          case 68:
              FilterEn->value(val_bool);
              if (val_bool)
                    voicefiltergroup->activate();
                else
                    voicefiltergroup->deactivate();
                bypassfiltercheckbutton->redraw(); // yes it's needed!
              break;
  
          case 72:
              FilterEnvEn->value(val_bool);
              if (val_bool)
                  voicefilterenvgroup->activate();
              else
                  voicefilterenvgroup->deactivate();
              FilterEnvEn->redraw(); // yes it's needed!
              break;
  
          case 73:
              FilterLfoEn->value(val_bool);
              if (val_bool)
                  voicefilterlfogroup->activate();
              else
                  voicefilterlfogroup->deactivate();
              FilterLfoEn->redraw(); // yes it's needed!
              break;
  
          case 80:
              ModVolume->value(value);
              break;
  
          case 81:
              ModVsense->value(value);
              break;
  
          case 82:
              ModFdamp->value(value);
              break;
  
          case 88:
              ModAmpEn->value(val_bool);
              if (val_bool)
                  voiceFMampenvgroup->activate();
              else
                  voiceFMampenvgroup->deactivate();
              break;
  
          case 96:
              ModDetune->value(value);
              fmdetunevalueoutput->do_callback();
              break;
  
          case 98:
              tmp = (val_bool);
              Mod440->value(tmp);
              if (tmp == 0 && lrint(Freq440->value() == 0))
                  fixedfreqetdial->deactivate();
              else
                  fixedfreqetdial->activate();
              break;
          case 99:
              ModOctave->value((int) value);
              break;
  
          case 100:
              ModDetuneType->value((int) value);
              fmdetunevalueoutput->do_callback();
              break;
  
          case 101:
              ModCoarseDetune->value((int) value);
              break;
  
          case 104:
              ModFreqEn->value(val_bool);
              if (value == 0)
                  voiceFMfreqenvgroup->deactivate();
              else
                  voiceFMfreqenvgroup->activate();
              break;
  
          case 112:
              ModPhase->value(value);
              oscFM->phase = 64 - lrint(value);
              fmoscil->redraw();
              break;
  
          case 113:
              tmp = int(value);
              ExtModOsc->value(tmp + 1);
              if (tmp < 0)
              {
                  tmp = voice;
                  changeFMoscilbutton->labelcolor(FL_BLACK);
              }
              else
                  changeFMoscilbutton->labelcolor(FL_BLUE);
              oscFM->init(pars->VoicePar[tmp].FMSmp, synth);
              voiceFMparametersgroup->redraw();
              break;
  
          case 128:
              Delay->value(value);
              break;
  
          case 129:
              tmp = (val_bool);
              voiceonbutton->value(tmp);
              synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voiceenabled->value(tmp);
              if (tmp)
              {
                  voiceparametersgroup->activate();
                  synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voicelistitemgroup->activate();
              }
              else
              {
                  voiceparametersgroup->deactivate();
                  synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voicelistitemgroup->deactivate();
              }
              voiceonbutton->redraw();
              break;
  
          case 130:
              tmp = (val_bool);
              ResonanceEn->value(tmp);
              synth->getGuiMaster()->partui->adnoteui->voicelistitem[voice]->voiceresonanceenabled->value(tmp);
              break;
  
          case 136:
              tmp = (int)value;
              VoiceOscPhase->value(tmp);
              osc->phase = 64 - tmp;
              voiceoscil->redraw();
              break;
  
          case 137:
              tmp = int(value);
              UseOsc->value(tmp + 1);
              if (tmp < 0)
              {
                  tmp = voice;
                  changevoiceoscilbutton->labelcolor(FL_BLACK);
              }
              else
                  changevoiceoscilbutton->labelcolor(FL_BLUE);
              osc->init(pars->VoicePar[tmp].OscilSmp, synth);
              osc->redraw();
              break;
  
          case 138:
              tmp = lrint(value);
              SoundType->value(tmp);
              if (tmp)
                  voicemodegroup->deactivate();
              else
                  voicemodegroup->activate();
              noiselabel->do_callback();
              break;
      }
}

void ADvoiceUI::init(ADnoteParameters *parameters,int npart_, int kititem_, int nvoice_) {
  //
      synth = parameters->getSynthEngine();
          pars = parameters;
          npart = npart_;
          kititem = kititem_;
          nvoice = nvoice_;
          make_window();
          end();
          ADnoteVoiceParameters->show();
}

ADvoiceUI::~ADvoiceUI() {
  //
          ADnoteVoiceParameters->hide();
          hide();
          if (oscedit)
          {
              delete oscedit;
          }
}

void ADnoteUI::cb_octave_i(Fl_Counter* o, void*) {
  //
    send_data(35, o->value(), 0xc8);
}
void ADnoteUI::cb_octave(Fl_Counter* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_octave_i(o,v);
}

void ADnoteUI::cb_coarsedet_i(Fl_Counter* o, void*) {
  //
    send_data(37, o->value(), 0xc0);
}
void ADnoteUI::cb_coarsedet(Fl_Counter* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_coarsedet_i(o,v);
}

void ADnoteUI::cb_freq_i(mwheel_slider_rev* o, void*) {
  //
    if (Fl::event_button() == 3)
        o->value(0);
    detunevalueoutput->do_callback();
    send_data(32, o->value(), 0xc8);
}
void ADnoteUI::cb_freq(mwheel_slider_rev* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_freq_i(o,v);
}

void ADnoteUI::cb_detunevalueoutput2_i(Fl_Value_Output* o, void*) {
  o->value(getDetune(pars->GlobalPar.PDetuneType,0,pars->GlobalPar.PDetune));
}
void ADnoteUI::cb_detunevalueoutput2(Fl_Value_Output* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_detunevalueoutput2_i(o,v);
}

void ADnoteUI::cb_detunetype_i(Fl_Choice* o, void*) {
  //
    send_data(36, o->value() + 1, 0xc0);
}
void ADnoteUI::cb_detunetype(Fl_Choice* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_detunetype_i(o,v);
}

void ADnoteUI::cb_relBwidth_i(WidgetPDial* o, void*) {
  //
    send_data(39, o->value(), 0xc8);
}
void ADnoteUI::cb_relBwidth(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_relBwidth_i(o,v);
}

void ADnoteUI::cb_globalvolume_i(WidgetPDial* o, void*) {
  //
send_data(0, o->value(), 0xc8);
}
void ADnoteUI::cb_globalvolume(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_globalvolume_i(o,v);
}

void ADnoteUI::cb_vsns_i(WidgetPDial* o, void*) {
  send_data(1, o->value(), 0xc8);
}
void ADnoteUI::cb_vsns(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_vsns_i(o,v);
}

void ADnoteUI::cb_globalpan_i(WidgetPDial* o, void*) {
  //
    globalrandompan->value(o->value() < 0.1f);
    send_data(2, o->value(), 0xc8);
}
void ADnoteUI::cb_globalpan(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_globalpan_i(o,v);
}

void ADnoteUI::cb_globalrandompan_i(Fl_Light_Button* o, void*) {
  //
    globalpan->value(0);
    o->value(1);
    send_data(2, 0, 0xc0);
}
void ADnoteUI::cb_globalrandompan(Fl_Light_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_globalrandompan_i(o,v);
}

void ADnoteUI::cb_depop_i(WidgetPDial* o, void*) {
  //
send_data(120, o->value(), 0xc8);
}
void ADnoteUI::cb_depop(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_depop_i(o,v);
}

void ADnoteUI::cb_pstr_i(WidgetPDial* o, void*) {
  //
send_data(121, o->value(), 0xc8);
}
void ADnoteUI::cb_pstr(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pstr_i(o,v);
}

void ADnoteUI::cb_pt_i(WidgetPDial* o, void*) {
  //
send_data(122, o->value(), 0xc8);
}
void ADnoteUI::cb_pt(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pt_i(o,v);
}

void ADnoteUI::cb_pstc_i(WidgetPDial* o, void*) {
  //
send_data(123, o->value(), 0xc8);
}
void ADnoteUI::cb_pstc(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pstc_i(o,v);
}

void ADnoteUI::cb_pvel_i(WidgetPDial* o, void*) {
  //
send_data(124, o->value(), 0xc8);
}
void ADnoteUI::cb_pvel(WidgetPDial* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_pvel_i(o,v);
}

void ADnoteUI::cb_rndgrp_i(Fl_Check_Button* o, void*) {
  pars->GlobalPar.Hrandgrouping = lrint(o->value());
send_data(113, o->value(), 0xc0);
}
void ADnoteUI::cb_rndgrp(Fl_Check_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->parent()->user_data()))->cb_rndgrp_i(o,v);
}

void ADnoteUI::cb_stereo_i(Fl_Check_Button* o, void*) {
  //
send_data(112, o->value(), 0xc8);
}
void ADnoteUI::cb_stereo(Fl_Check_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_stereo_i(o,v);
}

void ADnoteUI::cb_Show_i(Fl_Button*, void*) {
  //
    for (int i = 0; i < NUM_VOICES; ++i)
        voicelistitem[i]->refreshlist();
    ADnoteVoiceList->show();
    if (Fl::event_button() == 3)
        ADnoteGlobalParameters->hide();
}
void ADnoteUI::cb_Show(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Show_i(o,v);
}

void ADnoteUI::cb_Show1_i(Fl_Button*, void*) {
  //
    voicelistitem[nvoice]->refreshlist();
    ADnoteVoice->show();
    ADnoteVoice->redraw();
    synth->getGuiMaster()->partui->adnoteui->fromVoiceList = false;
    if ((Fl::event_button() == 3))
        ADnoteGlobalParameters->hide();
}
void ADnoteUI::cb_Show1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Show1_i(o,v);
}

void ADnoteUI::cb_Close_i(Fl_Button*, void*) {
  synth->getGuiMaster()->addNoteX = ADnoteGlobalParameters->x();
synth->getGuiMaster()->addNoteY = ADnoteGlobalParameters->y();
ADnoteGlobalParameters->hide();
if (Fl::event_button() == 3)
{
    if (synth->getGuiMaster()->partui->partKitOn)
        synth->getGuiMaster()->partui->instrumentkitlist->show();
    else
        synth->getGuiMaster()->partui->instrumenteditwindow->show();
};
}
void ADnoteUI::cb_Close(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void ADnoteUI::cb_Resonance_i(Fl_Button*, void*) {
  //
    resui->resonancewindow->redraw();
    resui->Show(true);
    if ((Fl::event_button() == 3))
        ADnoteGlobalParameters->hide();
}
void ADnoteUI::cb_Resonance(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Resonance_i(o,v);
}

void ADnoteUI::cb_C_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->copy(pars);
}
void ADnoteUI::cb_C(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_C_i(o,v);
}

void ADnoteUI::cb_P_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->paste(pars,this);
}
void ADnoteUI::cb_P(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_P_i(o,v);
}

void ADnoteUI::cb_currentvoicecounter_i(Fl_Spinner* o, void*) {
  //
            editVoice(lrint(o->value()) - 1);
}
void ADnoteUI::cb_currentvoicecounter(Fl_Spinner* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_currentvoicecounter_i(o,v);
}

void ADnoteUI::cb_Close1_i(Fl_Button*, void*) {
  ADnoteVoice->hide();
if (Fl::event_button() == 3)
{
    if (fromVoiceList)
        ADnoteVoiceList->show();
    else
        ADnoteGlobalParameters->show();
};
}
void ADnoteUI::cb_Close1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

void ADnoteUI::cb_C1_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->copy(pars,nvoice);
}
void ADnoteUI::cb_C1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_C1_i(o,v);
}

void ADnoteUI::cb_P1_i(Fl_Button*, void*) {
  synth->getGuiMaster()->getPresetsUi()->paste(pars,this,nvoice);
}
void ADnoteUI::cb_P1(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_P1_i(o,v);
}

void ADnoteUI::cb_Close2_i(Fl_Button*, void*) {
  ADnoteVoiceList->hide();
if (Fl::event_button() == 3)
    ADnoteGlobalParameters->show();
}
void ADnoteUI::cb_Close2(Fl_Button* o, void* v) {
  ((ADnoteUI*)(o->parent()->user_data()))->cb_Close2_i(o,v);
}

Fl_Double_Window* ADnoteUI::make_window() {
  { Fl_Double_Window* o = ADnoteGlobalParameters = new Fl_Double_Window(535, 405, "ADsynth Global Parameters of the Instrument");
    ADnoteGlobalParameters->user_data((void*)(this));
    { Fl_Group* o = new Fl_Group(5, 255, 525, 115, "FREQUENCY");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
      { EnvelopeUI* o = freqenv = new EnvelopeUI(10, 295, 205, 70, "ADSynth Global - Frequency Envelope");
        freqenv->box(FL_FLAT_BOX);
        freqenv->color((Fl_Color)51);
        freqenv->selection_color(FL_BACKGROUND_COLOR);
        freqenv->labeltype(FL_NORMAL_LABEL);
        freqenv->labelfont(0);
        freqenv->labelsize(12);
        freqenv->labelcolor(FL_FOREGROUND_COLOR);
        freqenv->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        freqenv->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FreqEnvelope, npart, kititem, 0, 1);
        freqenv->end();
      } // EnvelopeUI* freqenv
      { Fl_Counter* o = octave = new Fl_Counter(450, 275, 45, 15, "Octave");
        octave->tooltip("Octave");
        octave->type(1);
        octave->color((Fl_Color)237);
        octave->selection_color(FL_FOREGROUND_COLOR);
        octave->labelsize(10);
        octave->minimum(-8);
        octave->maximum(7);
        octave->step(1);
        octave->textfont(1);
        octave->textsize(11);
        octave->callback((Fl_Callback*)cb_octave);
        octave->align(Fl_Align(FL_ALIGN_TOP));
        int k = pars->GlobalPar.PCoarseDetune / 1024; if (k >= 8) k -= 16;
        o->value(k);
      } // Fl_Counter* octave
      { Fl_Counter* o = coarsedet = new Fl_Counter(455, 345, 60, 20, "Coarse det.");
        coarsedet->tooltip("Coarse Detune");
        coarsedet->labelsize(10);
        coarsedet->minimum(-64);
        coarsedet->maximum(63);
        coarsedet->step(1);
        coarsedet->textfont(1);
        coarsedet->textsize(11);
        coarsedet->callback((Fl_Callback*)cb_coarsedet);
        coarsedet->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        int k = pars->GlobalPar.PCoarseDetune % 1024; if (k >= 512) k -= 1024;
        o->value(k);
        o->lstep(10);
      } // Fl_Counter* coarsedet
      { LFOUI* o = freqlfo = new LFOUI(215, 295, 230, 70, "Frequency LFO     ");
        freqlfo->box(FL_FLAT_BOX);
        freqlfo->color(FL_DARK1);
        freqlfo->selection_color(FL_BACKGROUND_COLOR);
        freqlfo->labeltype(FL_NORMAL_LABEL);
        freqlfo->labelfont(0);
        freqlfo->labelsize(12);
        freqlfo->labelcolor(FL_FOREGROUND_COLOR);
        freqlfo->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        freqlfo->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FreqLfo, npart, kititem, 0, 1);
        freqlfo->end();
      } // LFOUI* freqlfo
      { mwheel_slider_rev* o = freq = new mwheel_slider_rev(57, 275, 385, 15);
        freq->tooltip("Fine Detune (cents)");
        freq->type(5);
        freq->box(FL_THIN_DOWN_BOX);
        freq->color(FL_BACKGROUND_COLOR);
        freq->selection_color(FL_BACKGROUND_COLOR);
        freq->labeltype(FL_NORMAL_LABEL);
        freq->labelfont(0);
        freq->labelsize(14);
        freq->labelcolor(FL_FOREGROUND_COLOR);
        freq->minimum(-8192);
        freq->maximum(8191);
        freq->step(1);
        freq->callback((Fl_Callback*)cb_freq);
        freq->align(Fl_Align(FL_ALIGN_BOTTOM));
        freq->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PDetune - 8192);
      } // mwheel_slider_rev* freq
      { Fl_Value_Output* o = detunevalueoutput = new Fl_Value_Output(12, 275, 45, 15, "Detune");
        detunevalueoutput->labelsize(10);
        detunevalueoutput->minimum(-5000);
        detunevalueoutput->maximum(5000);
        detunevalueoutput->textfont(1);
        detunevalueoutput->textsize(10);
        detunevalueoutput->callback((Fl_Callback*)cb_detunevalueoutput2);
        detunevalueoutput->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        o->step(0.01, 1);
        o->value(getDetune(pars->GlobalPar.PDetuneType, 0, pars->GlobalPar.PDetune));
      } // Fl_Value_Output* detunevalueoutput
      { Fl_Choice* o = detunetype = new Fl_Choice(450, 315, 75, 15, "Detune Type");
        detunetype->down_box(FL_BORDER_BOX);
        detunetype->labelsize(10);
        detunetype->textfont(1);
        detunetype->textsize(10);
        detunetype->callback((Fl_Callback*)cb_detunetype);
        detunetype->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        //
              o->add("L35cents");
              o->add("L10cents");
              o->add("E100cents");
              o->add("E1200cents");
        o->value(pars->GlobalPar.PDetuneType-1);
      } // Fl_Choice* detunetype
      { WidgetPDial* o = relBwidth = new WidgetPDial(500, 270, 25, 25, "relBW");
        relBwidth->tooltip("Bandwidth - how the relative fine detune of the voice are changed");
        relBwidth->box(FL_ROUND_UP_BOX);
        relBwidth->color(FL_BACKGROUND_COLOR);
        relBwidth->selection_color(FL_INACTIVE_COLOR);
        relBwidth->labeltype(FL_NORMAL_LABEL);
        relBwidth->labelfont(0);
        relBwidth->labelsize(10);
        relBwidth->labelcolor(FL_FOREGROUND_COLOR);
        relBwidth->maximum(127);
        relBwidth->step(1);
        relBwidth->callback((Fl_Callback*)cb_relBwidth);
        relBwidth->align(Fl_Align(FL_ALIGN_TOP));
        relBwidth->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PBandwidth);
        o->init(64);
      } // WidgetPDial* relBwidth
      o->end();
    } // Fl_Group* o
    { amplitudegrp = new Fl_Group(5, 5, 240, 250, "AMPLITUDE");
      amplitudegrp->box(FL_THIN_UP_FRAME);
      amplitudegrp->labelfont(1);
      amplitudegrp->labelsize(12);
      amplitudegrp->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
      { WidgetPDial* o = globalvolume = new WidgetPDial(39, 22, 35, 35, "Volume");
        globalvolume->tooltip("Volume");
        globalvolume->box(FL_ROUND_UP_BOX);
        globalvolume->color(FL_BACKGROUND_COLOR);
        globalvolume->selection_color(FL_INACTIVE_COLOR);
        globalvolume->labeltype(FL_NORMAL_LABEL);
        globalvolume->labelfont(0);
        globalvolume->labelsize(10);
        globalvolume->labelcolor(FL_FOREGROUND_COLOR);
        globalvolume->maximum(127);
        globalvolume->step(1);
        globalvolume->callback((Fl_Callback*)cb_globalvolume);
        globalvolume->align(Fl_Align(FL_ALIGN_BOTTOM));
        globalvolume->when(FL_WHEN_CHANGED);
        o->setValueType(VC_InstrumentVolume);
        o->value(pars->GlobalPar.PVolume);
        o->init(90);
      } // WidgetPDial* globalvolume
      { WidgetPDial* o = vsns = new WidgetPDial(106, 22, 35, 35, "Vel Sens");
        vsns->tooltip("Velocity Sensing Function - rightmost/max to disable");
        vsns->box(FL_ROUND_UP_BOX);
        vsns->color(FL_BACKGROUND_COLOR);
        vsns->selection_color(FL_INACTIVE_COLOR);
        vsns->labeltype(FL_NORMAL_LABEL);
        vsns->labelfont(0);
        vsns->labelsize(10);
        vsns->labelcolor(FL_FOREGROUND_COLOR);
        vsns->maximum(127);
        vsns->step(1);
        vsns->callback((Fl_Callback*)cb_vsns);
        vsns->align(Fl_Align(FL_ALIGN_BOTTOM));
        vsns->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PAmpVelocityScaleFunction);
        o->init(64);
        o->setValueType(VC_AmpVelocitySense);
      } // WidgetPDial* vsns
      { WidgetPDial* o = globalpan = new WidgetPDial(173, 22, 35, 35, "Pan");
        globalpan->tooltip("Global panning - leftmost/zero gives random panning");
        globalpan->box(FL_ROUND_UP_BOX);
        globalpan->color(FL_BACKGROUND_COLOR);
        globalpan->selection_color(FL_INACTIVE_COLOR);
        globalpan->labeltype(FL_NORMAL_LABEL);
        globalpan->labelfont(0);
        globalpan->labelsize(10);
        globalpan->labelcolor(FL_FOREGROUND_COLOR);
        globalpan->maximum(127);
        globalpan->step(1);
        globalpan->callback((Fl_Callback*)cb_globalpan);
        globalpan->align(Fl_Align(FL_ALIGN_BOTTOM_LEFT));
        globalpan->when(FL_WHEN_CHANGED);
        o->setValueType(VC_PanningRandom);
        o->value(pars->GlobalPar.PPanning);
        o->init(64);
      } // WidgetPDial* globalpan
      { Fl_Light_Button* o = globalrandompan = new Fl_Light_Button(196, 57, 7, 13, "Rand");
        globalrandompan->box(FL_NO_BOX);
        globalrandompan->color((Fl_Color)35);
        globalrandompan->selection_color(FL_RED);
        globalrandompan->labelsize(10);
        globalrandompan->callback((Fl_Callback*)cb_globalrandompan);
        globalrandompan->align(Fl_Align(FL_ALIGN_RIGHT));
        o->value(pars->randomGlobalPan());
      } // Fl_Light_Button* globalrandompan
      { WidgetPDial* o = depop = new WidgetPDial(85, 227, 25, 25, "D.Pop");
        depop->tooltip("Pop Suppression");
        depop->box(FL_ROUND_UP_BOX);
        depop->color(FL_BACKGROUND_COLOR);
        depop->selection_color(FL_INACTIVE_COLOR);
        depop->labeltype(FL_NORMAL_LABEL);
        depop->labelfont(0);
        depop->labelsize(10);
        depop->labelcolor(FL_FOREGROUND_COLOR);
        depop->maximum(127);
        depop->step(1);
        depop->callback((Fl_Callback*)cb_depop);
        depop->align(Fl_Align(FL_ALIGN_TOP));
        depop->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.Fadein_adjustment);
        o->init(20);
      } // WidgetPDial* depop
      { WidgetPDial* o = pstr = new WidgetPDial(125, 227, 25, 25, "P.Str.");
        pstr->tooltip("Punch Strength");
        pstr->box(FL_ROUND_UP_BOX);
        pstr->color(FL_BACKGROUND_COLOR);
        pstr->selection_color(FL_INACTIVE_COLOR);
        pstr->labeltype(FL_NORMAL_LABEL);
        pstr->labelfont(0);
        pstr->labelsize(10);
        pstr->labelcolor(FL_FOREGROUND_COLOR);
        pstr->maximum(127);
        pstr->step(1);
        pstr->callback((Fl_Callback*)cb_pstr);
        pstr->align(Fl_Align(FL_ALIGN_TOP));
        pstr->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchStrength);
        o->init(0);
      } // WidgetPDial* pstr
      { WidgetPDial* o = pt = new WidgetPDial(155, 227, 25, 25, "P.t.");
        pt->tooltip("Punch Time (duration)");
        pt->box(FL_ROUND_UP_BOX);
        pt->color(FL_BACKGROUND_COLOR);
        pt->selection_color(FL_INACTIVE_COLOR);
        pt->labeltype(FL_NORMAL_LABEL);
        pt->labelfont(0);
        pt->labelsize(10);
        pt->labelcolor(FL_FOREGROUND_COLOR);
        pt->maximum(127);
        pt->step(1);
        pt->callback((Fl_Callback*)cb_pt);
        pt->align(Fl_Align(FL_ALIGN_TOP));
        pt->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchTime);
        o->init(60);
      } // WidgetPDial* pt
      { WidgetPDial* o = pstc = new WidgetPDial(185, 227, 25, 25, "P.Stc.");
        pstc->tooltip("Punch Stretch");
        pstc->box(FL_ROUND_UP_BOX);
        pstc->color(FL_BACKGROUND_COLOR);
        pstc->selection_color(FL_INACTIVE_COLOR);
        pstc->labeltype(FL_NORMAL_LABEL);
        pstc->labelfont(0);
        pstc->labelsize(10);
        pstc->labelcolor(FL_FOREGROUND_COLOR);
        pstc->maximum(127);
        pstc->step(1);
        pstc->callback((Fl_Callback*)cb_pstc);
        pstc->align(Fl_Align(FL_ALIGN_TOP));
        pstc->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchStretch);
        o->init(64);
      } // WidgetPDial* pstc
      { WidgetPDial* o = pvel = new WidgetPDial(215, 227, 25, 25, "P.Vel.");
        pvel->tooltip("Punch Velocity Sensing");
        pvel->box(FL_ROUND_UP_BOX);
        pvel->color(FL_BACKGROUND_COLOR);
        pvel->selection_color(FL_INACTIVE_COLOR);
        pvel->labeltype(FL_NORMAL_LABEL);
        pvel->labelfont(0);
        pvel->labelsize(10);
        pvel->labelcolor(FL_FOREGROUND_COLOR);
        pvel->maximum(127);
        pvel->step(1);
        pvel->callback((Fl_Callback*)cb_pvel);
        pvel->align(Fl_Align(FL_ALIGN_TOP));
        pvel->when(FL_WHEN_CHANGED);
        o->value(pars->GlobalPar.PPunchVelocitySensing);
        o->init(72);
      } // WidgetPDial* pvel
      { EnvelopeUI* o = ampenv = new EnvelopeUI(10, 75, 205, 70, "ADSynth Global - Amplitude Envelope");
        ampenv->box(FL_FLAT_BOX);
        ampenv->color((Fl_Color)51);
        ampenv->selection_color(FL_BACKGROUND_COLOR);
        ampenv->labeltype(FL_NORMAL_LABEL);
        ampenv->labelfont(0);
        ampenv->labelsize(12);
        ampenv->labelcolor(FL_FOREGROUND_COLOR);
        ampenv->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        ampenv->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.AmpEnvelope, npart, kititem, 0, 0);
        ampenv->end();
      } // EnvelopeUI* ampenv
      { LFOUI* o = amplfo = new LFOUI(10, 145, 230, 70, "Amplitude LFO          ");
        amplfo->box(FL_FLAT_BOX);
        amplfo->color(FL_DARK1);
        amplfo->selection_color(FL_BACKGROUND_COLOR);
        amplfo->labeltype(FL_NORMAL_LABEL);
        amplfo->labelfont(0);
        amplfo->labelsize(12);
        amplfo->labelcolor(FL_FOREGROUND_COLOR);
        amplfo->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        amplfo->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.AmpLfo, npart, kititem, 0, 0);
        amplfo->end();
      } // LFOUI* amplfo
      { Fl_Check_Button* o = rndgrp = new Fl_Check_Button(8, 234, 63, 18, "Rnd Grp");
        rndgrp->tooltip("How the Harmonic Amplitude is applied to voices that use the same oscillator");
        rndgrp->down_box(FL_DOWN_BOX);
        rndgrp->labelsize(11);
        rndgrp->callback((Fl_Callback*)cb_rndgrp);
        o->value(pars->GlobalPar.Hrandgrouping);
      } // Fl_Check_Button* rndgrp
      amplitudegrp->end();
    } // Fl_Group* amplitudegrp
    { Fl_Group* o = new Fl_Group(245, 5, 285, 250, "FILTER");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->align(Fl_Align(FL_ALIGN_TOP|FL_ALIGN_INSIDE));
      { EnvelopeUI* o = filterenv = new EnvelopeUI(250, 110, 275, 70, "ADSynth Global - Filter Envelope");
        filterenv->box(FL_FLAT_BOX);
        filterenv->color((Fl_Color)51);
        filterenv->selection_color(FL_BACKGROUND_COLOR);
        filterenv->labeltype(FL_NORMAL_LABEL);
        filterenv->labelfont(0);
        filterenv->labelsize(12);
        filterenv->labelcolor(FL_FOREGROUND_COLOR);
        filterenv->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        filterenv->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FilterEnvelope, npart, kititem, 0, 2);
        filterenv->end();
      } // EnvelopeUI* filterenv
      { LFOUI* o = filterlfo = new LFOUI(250, 180, 230, 70, "Filter LFO");
        filterlfo->box(FL_FLAT_BOX);
        filterlfo->color(FL_DARK1);
        filterlfo->selection_color(FL_BACKGROUND_COLOR);
        filterlfo->labeltype(FL_NORMAL_LABEL);
        filterlfo->labelfont(0);
        filterlfo->labelsize(12);
        filterlfo->labelcolor(FL_FOREGROUND_COLOR);
        filterlfo->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        filterlfo->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.FilterLfo, npart, kititem, 0, 2);
        filterlfo->end();
      } // LFOUI* filterlfo
      { FilterUI* o = filterui = new FilterUI(250, 35, 275, 75, "ADsynth Global - Filter");
        filterui->box(FL_FLAT_BOX);
        filterui->color(FL_LIGHT1);
        filterui->selection_color(FL_BACKGROUND_COLOR);
        filterui->labeltype(FL_NORMAL_LABEL);
        filterui->labelfont(0);
        filterui->labelsize(12);
        filterui->labelcolor(FL_FOREGROUND_COLOR);
        filterui->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
        filterui->when(FL_WHEN_RELEASE);
        o->init(pars->GlobalPar.GlobalFilter, &pars->GlobalPar.PFilterVelocityScale, &pars->GlobalPar.PFilterVelocityScaleFunction, npart, kititem, 0);
        filterui->end();
      } // FilterUI* filterui
      o->end();
    } // Fl_Group* o
    { Fl_Check_Button* o = stereo = new Fl_Check_Button(8, 220, 17, 15, " Stereo");
      stereo->box(FL_THIN_UP_BOX);
      stereo->down_box(FL_DOWN_BOX);
      stereo->color((Fl_Color)237);
      stereo->labelsize(11);
      stereo->callback((Fl_Callback*)cb_stereo);
      o->value(pars->GlobalPar.PStereo);
    } // Fl_Check_Button* stereo
    { Fl_Button* o = new Fl_Button(191, 375, 121, 25, "Show Voice List");
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Show);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(5, 375, 180, 25, "Show Voice Parameters");
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Show1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(476, 375, 54, 25, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(318, 375, 90, 25, "Resonance");
      o->tooltip("Resonance");
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Resonance);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(414, 380, 25, 15, "C");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_C);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(444, 380, 25, 15, "P");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_P);
    } // Fl_Button* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Global").c_str());
    o->position(synth->getGuiMaster()->addNoteX, synth->getGuiMaster()->addNoteY);
    ADnoteGlobalParameters->end();
  } // Fl_Double_Window* ADnoteGlobalParameters
  { Fl_Double_Window* o = ADnoteVoice = new Fl_Double_Window(765, 615, "ADsynth Voice Parameters");
    ADnoteVoice->user_data((void*)(this));
    { ADvoiceUI* o = advoice = new ADvoiceUI(0, 0, 760, 575);
      advoice->box(FL_BORDER_BOX);
      advoice->color(FL_BACKGROUND_COLOR);
      advoice->selection_color(FL_BACKGROUND_COLOR);
      advoice->labeltype(FL_NORMAL_LABEL);
      advoice->labelfont(0);
      advoice->labelsize(14);
      advoice->labelcolor(FL_FOREGROUND_COLOR);
      advoice->align(Fl_Align(FL_ALIGN_TOP));
      advoice->when(FL_WHEN_RELEASE);
      o->init(pars, npart, kititem, nvoice);
      o->show();
      advoice->end();
    } // ADvoiceUI* advoice
    { currentvoicecounter = new Fl_Spinner(35, 584, 40, 24, "Current Voice");
      currentvoicecounter->labelfont(1);
      currentvoicecounter->labelsize(12);
      currentvoicecounter->maximum(8);
      currentvoicecounter->textfont(1);
      currentvoicecounter->callback((Fl_Callback*)cb_currentvoicecounter);
      currentvoicecounter->align(Fl_Align(FL_ALIGN_RIGHT));
    } // Fl_Spinner* currentvoicecounter
    { Fl_Button* o = new Fl_Button(655, 584, 90, 25, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(575, 589, 25, 15, "C");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_C1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(605, 589, 25, 15, "P");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_P1);
    } // Fl_Button* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Voice").c_str());
    ADnoteVoice->end();
  } // Fl_Double_Window* ADnoteVoice
  { Fl_Double_Window* o = ADnoteVoiceList = new Fl_Double_Window(650, 260, "ADsynth Voices list");
    ADnoteVoiceList->user_data((void*)(this));
    { Fl_Text_Display* o = new Fl_Text_Display(24, 15, 30, 10, "No.");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(182, 15, 30, 10, "Volume");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(410, 15, 25, 10, "Detune");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(250, 15, 30, 10, "Pan");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(570, 15, 30, 10, "Vibrato Depth");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Text_Display* o = new Fl_Text_Display(281, 15, 25, 10, "Res");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    { Fl_Button* o = new Fl_Button(582, 235, 62, 20, "Close");
      o->labelfont(1);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close2);
    } // Fl_Button* o
    { Fl_Scroll* o = new Fl_Scroll(5, 15, 640, 214);
      o->type(2);
      o->box(FL_THIN_UP_BOX);
      { Fl_Pack* o = new Fl_Pack(17, 27, 620, 200);
        //
              for (int i = 0; i < NUM_VOICES; ++i)
              {
                  voicelistitem[i] = new ADvoicelistitem(4, 8, 620, 25, "");
                  voicelistitem[i]->init(pars, npart, kititem, i);
              }
        o->end();
      } // Fl_Pack* o
      o->end();
    } // Fl_Scroll* o
    { Fl_Text_Display* o = new Fl_Text_Display(105, 15, 30, 10, "Wave");
      o->box(FL_NO_BOX);
      o->labelfont(1);
      o->labelsize(11);
    } // Fl_Text_Display* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("AddSynth Voice List").c_str());
    ADnoteVoiceList->end();
  } // Fl_Double_Window* ADnoteVoiceList
  return ADnoteVoiceList;
}

void ADnoteUI::send_data(int control, float value, int type) {
  //
  collect_data(synth, value, (Fl::event_button() | type), control, npart, kititem, 0);
}

void ADnoteUI::returns_update(CommandBlock *getData) {
  //
      float value = getData->data.value;
      unsigned char control = getData->data.control;
      bool val_bool = (value > 0.5f);
      switch(control)
      {
          case 0:
              globalvolume->value(value);
              break;
  
          case 1:
              vsns->value(value);
              break;
  
          case 2:
              globalpan->value(value);
              globalrandompan->value(value < 0.1f);
              amplitudegrp->changed();
              break;
  
          case 32:
              freq->value(value);
              detunevalueoutput->do_callback();
              break;
  
          case 35:
              octave->value((int) value);
              break;
  
          case 36:
              detunetype->value((int) value);
              break;
  
          case 37:
              coarsedet->value((int) value);
              break;
  
          case 39:
              relBwidth->value(value);
              break;
  
          case 112:
              stereo->value(val_bool);
              break;
  
          case 113:
              rndgrp->value(val_bool);
              break;
  
          case 120:
              depop->value(value);
              break;
  
          case 121:
              pstr->value(value);
              break;
  
          case 122:
              pt->value(value);
              break;
  
          case 123:
              pstc->value(value);
              break;
  
          case 124:
              pvel->value(value);
              break;
  
      }
}

ADnoteUI::ADnoteUI(ADnoteParameters *parameters, int npart_, int kititem_) {
  //
          synth = parameters->getSynthEngine();
          pars = parameters;
          npart = npart_;
          kititem = kititem_;
          nvoice = 0;
          resui = new ResonanceUI(pars->GlobalPar.Reson, npart, kititem, 0);
          make_window();
}

ADnoteUI::~ADnoteUI() {
  //
          ADnoteVoiceList->hide();
          ADnoteGlobalParameters->hide();
          ADnoteVoice->hide();
          delete ADnoteVoiceList;
          delete ADnoteGlobalParameters;
          delete ADnoteVoice;
          delete resui;
}

void ADnoteUI::refresh() {
  //
          globalvolume->value(pars->GlobalPar.PVolume);
          vsns->value(pars->GlobalPar.PAmpVelocityScaleFunction);
          globalpan->value(pars->GlobalPar.PPanning);
  
          stereo->value(pars->GlobalPar.PStereo);
          rndgrp->value(pars->GlobalPar.Hrandgrouping);
          pstr->value(pars->GlobalPar.PPunchStrength);
          pt->value(pars->GlobalPar.PPunchTime);
          pstc->value(pars->GlobalPar.PPunchStretch);
          pvel->value(pars->GlobalPar.PPunchVelocitySensing);
          detunevalueoutput->value(getDetune(pars->GlobalPar.PDetuneType, 0, pars->GlobalPar.PDetune));
          freq->value(pars->GlobalPar.PDetune - 8192);
  
          int k = pars->GlobalPar.PCoarseDetune / 1024;
          if (k >= 8)
              k -= 16;
          octave->value(k);
  
          detunetype->value(pars->GlobalPar.PDetuneType - 1);
          k = pars->GlobalPar.PCoarseDetune % 1024;
          if (k >= 512)
              k -= 1024;
          coarsedet->value(k);
          amplfo->refresh();
          freqlfo->refresh();
          filterlfo->refresh();
  
          ampenv->refresh();
          freqenv->refresh();
          filterenv->refresh();
          filterui->refresh();
          for (int i = 0; i < NUM_VOICES; ++i)
              voicelistitem[i]->refreshlist();
  
          resui->refresh();
          currentvoicecounter->do_callback();
}

void ADnoteUI::editVoice(int nvoice_) {
  //
          nvoice = nvoice_;
          advoice->hide();
          ADnoteVoice->remove(advoice);
          delete advoice;
          advoice = new ADvoiceUI(0, 0, 765, 585);
          ADnoteVoice->add(advoice);
          currentvoicecounter->value(nvoice + 1);
          advoice->init(pars, npart, kititem, nvoice);
          advoice->show();
          ADnoteVoice->redraw();
          ADnoteVoice->show();
}
