// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014 -2017, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code.

// Modified July 2017

// generated by Fast Light User Interface Designer (fluid) version 1.0304

#include "ConfigUI.h"
#include "Misc/SynthEngine.h"
#include "Misc/Bank.h"
#include "MasterUI.h"

void ConfigUI::cb_configwindow_i(Fl_Double_Window* o, void*) {
  o->hide();
}
void ConfigUI::cb_configwindow(Fl_Double_Window* o, void* v) {
  ((ConfigUI*)(o->user_data()))->cb_configwindow_i(o,v);
}

void ConfigUI::cb_osc_size_i(Fl_Choice* o, void*) {
  //
                        send_data(0, 256 << o->value(), 0xc0);
}
void ConfigUI::cb_osc_size(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_osc_size_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_osc_size[] = {
 {"256", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"512", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"1024", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"2048", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"4096", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"8192", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"16384", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_buff_size_i(Fl_Choice* o, void*) {
  //
                        send_data(1, 16 << o->value(), 0xc0);
}
void ConfigUI::cb_buff_size(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_buff_size_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_buff_size[] = {
 {"16", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"32", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"64", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"128", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"256", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"512", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"1024", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"2048", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {"4096", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_pad_interpol_i(Fl_Choice* o, void*) {
  //
                        send_data(2, o->value(), 0xc0);
}
void ConfigUI::cb_pad_interpol(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_pad_interpol_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_pad_interpol[] = {
 {"Linear(fast)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Cubic(slow)", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_v_keyboard_i(Fl_Choice* o, void*) {
  //
                        send_data(3, o->value(), 0xc0);
}
void ConfigUI::cb_v_keyboard(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_v_keyboard_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_v_keyboard[] = {
 {"QWERTY", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Dvorak", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"QWERTZ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"AZERTY", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_compression_i(Fl_Counter* o, void*) {
  //
                        send_data(4, o->value(), 0xc0);
}
void ConfigUI::cb_compression(Fl_Counter* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_compression_i(o,v);
}

void ConfigUI::cb_reports_i(Fl_Choice* o, void*) {
  //
                        send_data(5, o->value(), 0xf0);
}
void ConfigUI::cb_reports(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_reports_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_reports[] = {
 {"stdout", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Console Window", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void ConfigUI::cb_setDefaultState_i(Fl_Check_Button* o, void*) {
  //
                        send_data(16, o->value(), 0xc0);
}
void ConfigUI::cb_setDefaultState(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_setDefaultState_i(o,v);
}

void ConfigUI::cb_nonFatal_i(Fl_Check_Button* o, void*) {
  //
                        send_data(17, o->value(), 0xc0);
}
void ConfigUI::cb_nonFatal(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_nonFatal_i(o,v);
}

void ConfigUI::cb_showSplash_i(Fl_Check_Button* o, void*) {
  //
                        send_data(18, o->value(), 0xc0);
}
void ConfigUI::cb_showSplash(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_showSplash_i(o,v);
}

void ConfigUI::cb_logTimes_i(Fl_Check_Button* o, void*) {
  //
                        send_data(19, o->value(), 0xc0);
}
void ConfigUI::cb_logTimes(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_logTimes_i(o,v);
}

void ConfigUI::cb_logXML_i(Fl_Check_Button* o, void*) {
  //
                        send_data(20, o->value(), 0xc0);
}
void ConfigUI::cb_logXML(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_logXML_i(o,v);
}

void ConfigUI::cb_saveAllXML_i(Fl_Check_Button* o, void*) {
  //
                        send_data(21, o->value(), 0xc0);
}
void ConfigUI::cb_saveAllXML(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_saveAllXML_i(o,v);
}

void ConfigUI::cb_enableGUI_i(Fl_Check_Button* o, void*) {
  //
                        int tmp = o->value();
                        int doit = true;
                        if (tmp == 0)
                            doit = fl_choice("Are you sure you want to disable?\nThis can only be restored via the command line.", NULL, "No", "Yes") > 1;
                        if (doit)
                            send_data(22, o->value(), 0xc0);
                        else
                            o->value(1);
}
void ConfigUI::cb_enableGUI(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_enableGUI_i(o,v);
}

void ConfigUI::cb_enableCLI_i(Fl_Check_Button* o, void*) {
  //
                        send_data(23, o->value(), 0xc0);
}
void ConfigUI::cb_enableCLI(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_enableCLI_i(o,v);
}

void ConfigUI::cb_jackSource_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(32, 0, 0xc0, 0x80, miscMsgPush(tmp));
}
void ConfigUI::cb_jackSource(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackSource_i(o,v);
}

void ConfigUI::cb_jackMidi_i(Fl_Check_Button* o, void*) {
  //
                        send_data(33, o->value(), 0xc0);
}
void ConfigUI::cb_jackMidi(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackMidi_i(o,v);
}

void ConfigUI::cb_jackServer_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(34, 0, 0xc0, 0x80, miscMsgPush(tmp));
}
void ConfigUI::cb_jackServer(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackServer_i(o,v);
}

void ConfigUI::cb_jackAudio_i(Fl_Check_Button* o, void*) {
  //
                        send_data(35, o->value(), 0xc0);
}
void ConfigUI::cb_jackAudio(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_jackAudio_i(o,v);
}

void ConfigUI::cb_connectJackAudio_i(Fl_Check_Button* o, void*) {
  //
                        send_data(36, o->value(), 0xc0);
}
void ConfigUI::cb_connectJackAudio(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_connectJackAudio_i(o,v);
}

void ConfigUI::cb_alsaSource_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(48, 0, 0xc0, 0x80, miscMsgPush(tmp));
}
void ConfigUI::cb_alsaSource(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaSource_i(o,v);
}

void ConfigUI::cb_alsaMidi_i(Fl_Check_Button* o, void*) {
  //
                        send_data(49, o->value(), 0xc0);
}
void ConfigUI::cb_alsaMidi(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaMidi_i(o,v);
}

void ConfigUI::cb_alsaDevice_i(Fl_Input* o, void*) {
  //
                        string tmp = string(o->value());
                        send_data(50, 0, 0xc0, 0x80, miscMsgPush(tmp));
}
void ConfigUI::cb_alsaDevice(Fl_Input* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaDevice_i(o,v);
}

void ConfigUI::cb_alsaAudio_i(Fl_Check_Button* o, void*) {
  //
                        send_data(51, o->value(), 0xc0);
}
void ConfigUI::cb_alsaAudio(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaAudio_i(o,v);
}

void ConfigUI::cb_alsaRate_i(Fl_Check_Browser* o, void*) {
  //
                        int chk = o->value();
                        o->check_none();
                        o->set_checked(chk);
                        if (chk > 4)
                            chk = 4;
                        send_data(52, chk - 1, 0xc0);
}
void ConfigUI::cb_alsaRate(Fl_Check_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_alsaRate_i(o,v);
}

void ConfigUI::cb_MIDI_i(Fl_Group*, void*) {
  //
                        EPCvalue = synth->getRuntime().midi_upper_voice_C;
                        if (EPCvalue >= 128)
                        {
                            EPCspinner->value(110);
                            EPCspinner->deactivate();
                        }
                        else
                        {
                            EPCspinner->value(EPCvalue);
                            EPCspinner->activate();
                        }
                        BankRootvalue = synth->getRuntime().midi_bank_root;
                        if (BankRootvalue >= 128)
                        {
                            BankRoot->value(0);
                            BankRoot->deactivate();
                        }
                        else
                        {
                            BankRoot->value(BankRootvalue);
                            BankRoot->activate();
                        };
}
void ConfigUI::cb_MIDI(Fl_Group* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->user_data()))->cb_MIDI_i(o,v);
}

void ConfigUI::cb_BankRoot_i(Fl_Spinner*, void*) {
  Rpend->show();
}
void ConfigUI::cb_BankRoot(Fl_Spinner* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_BankRoot_i(o,v);
}

void ConfigUI::cb_Rpend_i(Fl_Button* o, void*) {
  //
                        int candidate = BankRoot->value();
                        if (candidate == BankRootvalue)
                        {
                            o->hide();
                            return;
                        }
                        string name = testCC(candidate, 65);
                        if (!name.empty())
                        {
                            fl_alert("In use for %s",name.c_str());
                            if (BankRootvalue < 128)
                            {
                                BankRoot->value(BankRootvalue);
                                BankRoot->redraw();
                            }
                            return;
                        }
                        BankRootvalue = candidate;
                        o->hide();
                        send_data(65, BankRootvalue, 0xc0);
}
void ConfigUI::cb_Rpend(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Rpend_i(o,v);
}

void ConfigUI::cb_rootcheck_i(Fl_Check_Button* o, void*) {
  //
                        if (o->value() == 0)
                        {
                            BankRoot->value(0);
                            BankRoot->deactivate();
                            Rpend->hide();
                            send_data(65, 128, 0xc0);
                        }
                        else
                        {
                            BankRoot->activate();
                            BankRoot->value(0);
                            BankRootvalue = 128;
                            Rpend->show();
                        }
                        BankRoot->redraw();
}
void ConfigUI::cb_rootcheck(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_rootcheck_i(o,v);
}

void ConfigUI::cb_bankchange_i(Fl_Choice* o, void*) {
  //
                        int candidate;
                        switch (o->value())
                        {
                            case 0:
                                candidate = 32;
                                break;
                            case 1:
                                candidate = 0;
                                break;
                            default:
                                candidate = 128;
                                break;
                        }
                        string name = testCC(candidate, 67);
                        if (!name.empty())
                        {
                            o->value(oldBank);
                            o->redraw();
                            switch(oldBank)
                            {
                                case 0:
                                    candidate = 32;
                                    break;
                                case 1:
                                    candidate = 0;
                                    break;
                                default:
                                    candidate = 128;
                                    break;
                            }
                            fl_alert("In use for %s",name.c_str());
                        }
                        send_data(67, candidate, 0xc0);
}
void ConfigUI::cb_bankchange(Fl_Choice* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_bankchange_i(o,v);
}

Fl_Menu_Item ConfigUI::menu_bankchange[] = {
 {"LSB", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"MSB", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Off", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* ConfigUI::banklsb = ConfigUI::menu_bankchange + 0;
Fl_Menu_Item* ConfigUI::bankusb = ConfigUI::menu_bankchange + 1;
Fl_Menu_Item* ConfigUI::bankoff = ConfigUI::menu_bankchange + 2;

void ConfigUI::cb_progenable_i(Fl_Check_Button* o, void*) {
  //
                        send_data(68, o->value(), 0xc0);
}
void ConfigUI::cb_progenable(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_progenable_i(o,v);
}

void ConfigUI::cb_progpartenable_i(Fl_Check_Button* o, void*) {
  //
                        send_data(69, o->value(), 0xc0);
}
void ConfigUI::cb_progpartenable(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_progpartenable_i(o,v);
}

void ConfigUI::cb_EPCspinner_i(Fl_Spinner*, void*) {
  //
                        Epend->show();
}
void ConfigUI::cb_EPCspinner(Fl_Spinner* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_EPCspinner_i(o,v);
}

void ConfigUI::cb_Epend_i(Fl_Button* o, void*) {
  //
                        int candidate = EPCspinner->value();
                        if (candidate == EPCvalue)
                        {
                            o->hide();
                            return;
                        }
                        string name = testCC(candidate, 71);
                        if (!name.empty())
                        {
                            fl_alert("In use for %s",name.c_str());
                            if (EPCvalue < 128)
                            {
                                EPCspinner->value(EPCvalue);
                                EPCspinner->redraw();
                            }
                            return;
                        }
                        EPCvalue = candidate;
                        o->hide();
                        send_data(71, EPCvalue, 0xc0);
}
void ConfigUI::cb_Epend(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Epend_i(o,v);
}

void ConfigUI::cb_Epcheck_i(Fl_Check_Button* o, void*) {
  // for some weird reason this *must* be the last item in the group
                        if (o->value() == 0)
                        {
                            EPCspinner->value(110);
                            EPCspinner->deactivate();
                            Epend->hide();
                            send_data(71, 128, 0xc0);
                        }
                        else
                        {
                            EPCspinner->activate();
                            Epend->show();
                            EPCspinner->value(110);
                            EPCvalue = 128;
                        }
                        EPCspinner->redraw();
}
void ConfigUI::cb_Epcheck(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_Epcheck_i(o,v);
}

void ConfigUI::cb_ignoreReset_i(Fl_Check_Button* o, void*) {
  //
                        send_data(72, o->value(), 0xc0);
}
void ConfigUI::cb_ignoreReset(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_ignoreReset_i(o,v);
}

void ConfigUI::cb_midiMon_i(Fl_Check_Button* o, void*) {
  //
                        send_data(73, o->value(), 0xc0);
}
void ConfigUI::cb_midiMon(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_midiMon_i(o,v);
}

void ConfigUI::cb_midiLearned_i(Fl_Check_Button* o, void*) {
  //
                        send_data(74, o->value(), 0xc0);
}
void ConfigUI::cb_midiLearned(Fl_Check_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->parent()->parent()->user_data()))->cb_midiLearned_i(o,v);
}

void ConfigUI::cb_Close_i(Fl_Button*, void*) {
  //
                    configwindow->do_callback();
}
void ConfigUI::cb_Close(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void ConfigUI::cb_Save_i(Fl_Button* o, void*) {
  //
                    send_data(80, o->value(), 0xf0, 0x80, miscMsgPush("DUMMY"));
                    configwindow->do_callback();
}
void ConfigUI::cb_Save(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

void ConfigUI::cb_presetbrowse_i(Fl_Browser* o, void*) {
  //
                    activatebutton_presetdir(o->value() != 0);
}
void ConfigUI::cb_presetbrowse(Fl_Browser* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_presetbrowse_i(o,v);
}

void ConfigUI::cb_addpreset_i(Fl_Button* o, void*) {
  //
                    const char *dirname;
                    dirname = fl_dir_chooser("Add a preset directory :", NULL, 0);
                    if (!dirname)
                        return;
                    presetbrowse->add(dirname);
                    synth->getRuntime().configChanged = true;
                    writepresetcfg();
                    if (presetbrowse->size() >= MAX_PRESET_DIRS)
                        o->deactivate();
}
void ConfigUI::cb_addpreset(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_addpreset_i(o,v);
}

void ConfigUI::cb_removepresetbutton_i(Fl_Button*, void*) {
  //
                    if (presetbrowse->value() != 0)
                    {
                        presetbrowse->remove(presetbrowse->value());
                        addpreset->activate();
                    }
                    activatebutton_presetdir(false);
                    synth->getRuntime().configChanged = true;
                    writepresetcfg();
}
void ConfigUI::cb_removepresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_removepresetbutton_i(o,v);
}

void ConfigUI::cb_makedefaultpresetbutton_i(Fl_Button*, void*) {
  //
                    int n = presetbrowse->value();
                    if (n != 0)
                    {
                        presetbrowse->move(1, n);
                        presetbrowse->value(1);
                        presetbrowse->redraw();
                        writepresetcfg();
                    }
                    activatebutton_presetdir(true);
                    synth->getRuntime().configChanged = true;
}
void ConfigUI::cb_makedefaultpresetbutton(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_makedefaultpresetbutton_i(o,v);
}

void ConfigUI::cb_Save1_i(Fl_Button*, void*) {
  //
                    synth->getRuntime().saveConfig();
                    presets->hide();
}
void ConfigUI::cb_Save1(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Save1_i(o,v);
}

void ConfigUI::cb_Close1_i(Fl_Button*, void*) {
  //
                    presets->hide();
}
void ConfigUI::cb_Close1(Fl_Button* o, void* v) {
  ((ConfigUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

Fl_Double_Window* ConfigUI::make_window() {
  { Fl_Double_Window* o = configwindow = new Fl_Double_Window(390, 330, "Yoshimi Settings");
    configwindow->callback((Fl_Callback*)cb_configwindow, (void*)(this));
    { Fl_Tabs* o = new Fl_Tabs(5, 5, 385, 298);
      { Fl_Group* o = new Fl_Group(5, 25, 382, 277, "Main settings");
        o->labelsize(12);
        { Fl_Choice* o = osc_size = new Fl_Choice(250, 45, 100, 20, "* AddSynth Oscillator Size");
          osc_size->tooltip("ADSynth Oscillator Size (samples)");
          osc_size->down_box(FL_BORDER_BOX);
          osc_size->labelsize(12);
          osc_size->textsize(11);
          osc_size->callback((Fl_Callback*)cb_osc_size);
          osc_size->menu(menu_osc_size);
          o->value( (int)(logf(synth->getRuntime().Oscilsize / 256.0f - 1.0f) / logf(2.0f)) + 1);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Choice* osc_size
        { Fl_Choice* o = buff_size = new Fl_Choice(249, 75, 100, 20, "* Internal Buffer Size");
          buff_size->tooltip("Number of samples");
          buff_size->down_box(FL_BORDER_BOX);
          buff_size->labelsize(12);
          buff_size->textsize(11);
          buff_size->callback((Fl_Callback*)cb_buff_size);
          buff_size->menu(menu_buff_size);
          o->value( (int)(logf(synth->getRuntime().Buffersize / 16.0f - 1.0f) / logf(2.0f)) + 1);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Choice* buff_size
        { Fl_Choice* o = pad_interpol = new Fl_Choice(250, 105, 100, 20, "PADsynth Interpolation");
          pad_interpol->down_box(FL_BORDER_BOX);
          pad_interpol->labelsize(12);
          pad_interpol->textsize(12);
          pad_interpol->callback((Fl_Callback*)cb_pad_interpol);
          pad_interpol->menu(menu_pad_interpol);
          o->value(synth->getRuntime().Interpolation);
        } // Fl_Choice* pad_interpol
        { Fl_Choice* o = v_keyboard = new Fl_Choice(250, 135, 100, 20, "Virtual Keyboard Layout");
          v_keyboard->down_box(FL_BORDER_BOX);
          v_keyboard->labelsize(12);
          v_keyboard->textfont(1);
          v_keyboard->textsize(13);
          v_keyboard->callback((Fl_Callback*)cb_v_keyboard);
          v_keyboard->menu(menu_v_keyboard);
          o->value(synth->getRuntime().VirKeybLayout);
        } // Fl_Choice* v_keyboard
        { Fl_Counter* o = compression = new Fl_Counter(284, 165, 65, 20, "XML Compression Level");
          compression->tooltip("gzip compression level (0 - uncompressed)");
          compression->type(1);
          compression->labelsize(12);
          compression->minimum(0);
          compression->maximum(9);
          compression->step(1);
          compression->textsize(12);
          compression->callback((Fl_Callback*)cb_compression);
          compression->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().GzipCompression);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Counter* compression
        { Fl_Choice* o = reports = new Fl_Choice(200, 195, 150, 20, "Send reports to:");
          reports->tooltip("Some system errors always go to stdout");
          reports->down_box(FL_BORDER_BOX);
          reports->labelsize(11);
          reports->textsize(13);
          reports->callback((Fl_Callback*)cb_reports);
          reports->menu(menu_reports);
          o->value(synth->getRuntime().toConsole);
        } // Fl_Choice* reports
        { Fl_Box* o = settingsNote = new Fl_Box(50, 276, 287, 17, "* Changing these settings requires a restart");
          settingsNote->labelfont(1);
          settingsNote->labelsize(11);
          settingsNote->labelcolor((Fl_Color)38);
          settingsNote->align(Fl_Align(FL_ALIGN_WRAP));
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Box* settingsNote
        o->end();
      } // Fl_Group* o
      { Fl_Group* o = new Fl_Group(5, 25, 382, 277, "Switches");
        o->labelsize(12);
        o->hide();
        { Fl_Check_Button* o = setDefaultState = new Fl_Check_Button(270, 60, 27, 25, "* Start With Default State");
          setDefaultState->down_box(FL_DOWN_BOX);
          setDefaultState->labelsize(12);
          setDefaultState->callback((Fl_Callback*)cb_setDefaultState);
          setDefaultState->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().loadDefaultState);
        } // Fl_Check_Button* setDefaultState
        { Fl_Check_Button* o = nonFatal = new Fl_Check_Button(270, 80, 27, 25, "Hide Non Fatal Errors");
          nonFatal->down_box(FL_DOWN_BOX);
          nonFatal->labelsize(12);
          nonFatal->callback((Fl_Callback*)cb_nonFatal);
          nonFatal->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().hideErrors);
        } // Fl_Check_Button* nonFatal
        { Fl_Check_Button* o = showSplash = new Fl_Check_Button(270, 100, 27, 25, "Show Splash Screen");
          showSplash->down_box(FL_DOWN_BOX);
          showSplash->labelsize(12);
          showSplash->callback((Fl_Callback*)cb_showSplash);
          showSplash->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showSplash);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Check_Button* showSplash
        { Fl_Check_Button* o = logTimes = new Fl_Check_Button(270, 120, 27, 25, "Log Load times");
          logTimes->down_box(FL_DOWN_BOX);
          logTimes->labelsize(12);
          logTimes->callback((Fl_Callback*)cb_logTimes);
          logTimes->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showTimes);
        } // Fl_Check_Button* logTimes
        { Fl_Check_Button* o = logXML = new Fl_Check_Button(270, 140, 27, 25, "Log XML Headers");
          logXML->down_box(FL_DOWN_BOX);
          logXML->labelsize(12);
          logXML->callback((Fl_Callback*)cb_logXML);
          logXML->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().logXMLheaders);
        } // Fl_Check_Button* logXML
        { Fl_Check_Button* o = saveAllXML = new Fl_Check_Button(270, 160, 27, 25, "Include disabled data in XML files");
          saveAllXML->down_box(FL_DOWN_BOX);
          saveAllXML->labelsize(12);
          saveAllXML->callback((Fl_Callback*)cb_saveAllXML);
          saveAllXML->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().xmlmax);
        } // Fl_Check_Button* saveAllXML
        { Fl_Check_Button* o = enableGUI = new Fl_Check_Button(270, 200, 27, 25, "* Enable GUI");
          enableGUI->tooltip("Enable starting with this graphical  interface");
          enableGUI->down_box(FL_DOWN_BOX);
          enableGUI->labelsize(12);
          enableGUI->callback((Fl_Callback*)cb_enableGUI);
          enableGUI->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showGui);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Check_Button* enableGUI
        { Fl_Check_Button* o = enableCLI = new Fl_Check_Button(270, 220, 27, 25, "* Enable CLI");
          enableCLI->tooltip("Enable starting with interactive command line interface");
          enableCLI->down_box(FL_DOWN_BOX);
          enableCLI->labelsize(12);
          enableCLI->callback((Fl_Callback*)cb_enableCLI);
          enableCLI->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showCLI);
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Check_Button* enableCLI
        { Fl_Box* o = new Fl_Box(50, 276, 287, 17, "* Changing these settings requires a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        o->end();
      } // Fl_Group* o
      { jackTab = new Fl_Group(5, 25, 385, 277, "Jack");
        jackTab->labelsize(12);
        jackTab->hide();
        { Fl_Input* o = jackSource = new Fl_Input(195, 62, 120, 22, "Jack MIDI Source");
          jackSource->tooltip("Device Jack tries to connect to for input.");
          jackSource->labelsize(12);
          jackSource->textsize(12);
          jackSource->callback((Fl_Callback*)cb_jackSource);
          o->value(synth->getRuntime().jackMidiDevice.c_str());
        } // Fl_Input* jackSource
        { Fl_Check_Button* o = jackMidi = new Fl_Check_Button(195, 88, 37, 26, "Set as preferred MIDI");
          jackMidi->down_box(FL_DOWN_BOX);
          jackMidi->labelsize(12);
          jackMidi->callback((Fl_Callback*)cb_jackMidi);
          jackMidi->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().midiEngine == jack_midi) o->value(1);
        } // Fl_Check_Button* jackMidi
        { Fl_Input* o = jackServer = new Fl_Input(195, 182, 120, 22, "Jack Server");
          jackServer->tooltip("Name of the jack server to connect to - default, ...");
          jackServer->labelsize(12);
          jackServer->textsize(12);
          jackServer->callback((Fl_Callback*)cb_jackServer);
          o->value(synth->getRuntime().jackServer.c_str());
        } // Fl_Input* jackServer
        { Fl_Check_Button* o = jackAudio = new Fl_Check_Button(195, 209, 37, 26, "Set as preferred audio");
          jackAudio->down_box(FL_DOWN_BOX);
          jackAudio->labelsize(12);
          jackAudio->callback((Fl_Callback*)cb_jackAudio);
          jackAudio->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().audioEngine == jack_audio) o->value(1);
        } // Fl_Check_Button* jackAudio
        { Fl_Check_Button* o = connectJackAudio = new Fl_Check_Button(195, 233, 37, 26, "Autoconnect audio");
          connectJackAudio->down_box(FL_DOWN_BOX);
          connectJackAudio->labelsize(12);
          connectJackAudio->callback((Fl_Callback*)cb_connectJackAudio);
          connectJackAudio->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().connectJackaudio);
        } // Fl_Check_Button* connectJackAudio
        { Fl_Box* o = new Fl_Box(60, 276, 267, 17, "Changing settings requires a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        jackTab->end();
      } // Fl_Group* jackTab
      { alsaTab = new Fl_Group(5, 25, 384, 277, "Alsa");
        alsaTab->labelsize(12);
        alsaTab->hide();
        { Fl_Input* o = alsaSource = new Fl_Input(195, 52, 120, 22, "Alsa MIDI Source");
          alsaSource->tooltip("Device Alsa tries to connect to for input.");
          alsaSource->labelsize(12);
          alsaSource->textsize(12);
          alsaSource->callback((Fl_Callback*)cb_alsaSource);
          o->value(synth->getRuntime().alsaMidiDevice.c_str());
        } // Fl_Input* alsaSource
        { Fl_Check_Button* o = alsaMidi = new Fl_Check_Button(195, 80, 37, 26, "Set as preferred MIDI");
          alsaMidi->down_box(FL_DOWN_BOX);
          alsaMidi->labelsize(12);
          alsaMidi->callback((Fl_Callback*)cb_alsaMidi);
          alsaMidi->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().midiEngine == alsa_midi) o->value(1);
        } // Fl_Check_Button* alsaMidi
        { Fl_Input* o = alsaDevice = new Fl_Input(195, 143, 120, 22, "Alsa Audio Device");
          alsaDevice->tooltip("Alsa audio device - default, hw:0, ...");
          alsaDevice->labelsize(12);
          alsaDevice->textsize(12);
          alsaDevice->callback((Fl_Callback*)cb_alsaDevice);
          o->value(synth->getRuntime().alsaAudioDevice.c_str());
        } // Fl_Input* alsaDevice
        { Fl_Check_Button* o = alsaAudio = new Fl_Check_Button(195, 169, 37, 26, "Set as preferred audio");
          alsaAudio->down_box(FL_DOWN_BOX);
          alsaAudio->labelsize(12);
          alsaAudio->callback((Fl_Callback*)cb_alsaAudio);
          alsaAudio->align(Fl_Align(FL_ALIGN_LEFT));
          if (synth->getRuntime().audioEngine == alsa_audio) o->value(1);
        } // Fl_Check_Button* alsaAudio
        { Fl_Check_Browser* o = alsaRate = new Fl_Check_Browser(195, 199, 121, 66, "Samplerate");
          alsaRate->labelsize(12);
          alsaRate->textsize(12);
          alsaRate->callback((Fl_Callback*)cb_alsaRate);
          alsaRate->align(Fl_Align(FL_ALIGN_LEFT));
          alsaRate->when(FL_WHEN_CHANGED);
          //
                    o->add("192000");
                    o->add("96000");
                    o->add("48000");
                    o->add("44100");
                    switch (synth->getRuntime().Samplerate)
                    {
                        case 192000: o->set_checked(1); break;
                        case 96000: o->set_checked(2); break;
                        case 44100: o->set_checked(4); break;
                        case 48000:
                        default: o->set_checked(3); break;
                    }
          if (synth->getUniqueId() != 0) o->hide();
        } // Fl_Check_Browser* alsaRate
        { Fl_Box* o = new Fl_Box(60, 276, 267, 17, "Changing settings requires a restart");
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)38);
          o->align(Fl_Align(FL_ALIGN_WRAP));
        } // Fl_Box* o
        alsaTab->end();
      } // Fl_Group* alsaTab
      { Fl_Group* o = new Fl_Group(5, 25, 381, 275, "MIDI");
        o->tooltip("MIDI CC preferences");
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_MIDI);
        o->hide();
        { Fl_Spinner* o = BankRoot = new Fl_Spinner(235, 50, 50, 18, "Bank Root Change");
          BankRoot->labelsize(12);
          BankRoot->minimum(0);
          BankRoot->maximum(127);
          BankRoot->value(0);
          BankRoot->textsize(12);
          BankRoot->callback((Fl_Callback*)cb_BankRoot);
          BankRootvalue = synth->getRuntime().midi_bank_root;
          if (BankRootvalue < 128) o->value(BankRootvalue); else o->value(0);
        } // Fl_Spinner* BankRoot
        { Rpend = new Fl_Button(300, 50, 70, 20, "Pending");
          Rpend->tooltip("Click to set");
          Rpend->box(FL_PLASTIC_UP_BOX);
          Rpend->color((Fl_Color)90);
          Rpend->labelsize(12);
          Rpend->callback((Fl_Callback*)cb_Rpend);
          Rpend->hide();
        } // Fl_Button* Rpend
        { Fl_Check_Button* o = rootcheck = new Fl_Check_Button(234, 30, 18, 18, "Enable Bank Root Change");
          rootcheck->down_box(FL_DOWN_BOX);
          rootcheck->labelsize(12);
          rootcheck->callback((Fl_Callback*)cb_rootcheck);
          rootcheck->align(Fl_Align(FL_ALIGN_LEFT));
          o->value((synth->getRuntime().midi_bank_root < 128));
          if (o->value() == 0) BankRoot->deactivate();
        } // Fl_Check_Button* rootcheck
        { Fl_Choice* o = bankchange = new Fl_Choice(235, 80, 53, 18, "Bank Change");
          bankchange->tooltip("CC0 = msb, CC32 = lsb");
          bankchange->down_box(FL_BORDER_BOX);
          bankchange->labelsize(12);
          bankchange->textsize(12);
          bankchange->callback((Fl_Callback*)cb_bankchange);
          bankchange->align(Fl_Align(132));
          bankchange->menu(menu_bankchange);
          if (synth->getRuntime().midi_bank_C == 32) o->value(0); else if (synth->getRuntime().midi_bank_C == 0) o->value(1); else o->value(2);
          oldBank = o->value();
        } // Fl_Choice* bankchange
        { Fl_Check_Button* o = progenable = new Fl_Check_Button(234, 110, 18, 18, "Enable Program Change");
          progenable->tooltip("MIDI program change enable/disable");
          progenable->down_box(FL_DOWN_BOX);
          progenable->value(1);
          progenable->labelsize(12);
          progenable->callback((Fl_Callback*)cb_progenable);
          progenable->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().EnableProgChange);
        } // Fl_Check_Button* progenable
        { Fl_Check_Button* o = progpartenable = new Fl_Check_Button(234, 130, 18, 18, "Enable Part On Program Change");
          progpartenable->tooltip("Part enabled if MIDI program changed");
          progpartenable->down_box(FL_DOWN_BOX);
          progpartenable->labelsize(12);
          progpartenable->callback((Fl_Callback*)cb_progpartenable);
          progpartenable->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().enable_part_on_voice_load);
        } // Fl_Check_Button* progpartenable
        { Fl_Spinner* o = EPCspinner = new Fl_Spinner(235, 180, 50, 18, "Extended Program Change");
          EPCspinner->labelsize(12);
          EPCspinner->minimum(0);
          EPCspinner->maximum(127);
          EPCspinner->value(110);
          EPCspinner->textsize(12);
          EPCspinner->callback((Fl_Callback*)cb_EPCspinner);
          EPCvalue = synth->getRuntime().midi_upper_voice_C;
          if (EPCvalue < 128) o->value(EPCvalue); else o->value(110);
        } // Fl_Spinner* EPCspinner
        { Epend = new Fl_Button(300, 180, 70, 20, "Pending");
          Epend->tooltip("Click to set");
          Epend->box(FL_PLASTIC_UP_BOX);
          Epend->color((Fl_Color)90);
          Epend->labelsize(12);
          Epend->callback((Fl_Callback*)cb_Epend);
          Epend->hide();
        } // Fl_Button* Epend
        { Fl_Check_Button* o = Epcheck = new Fl_Check_Button(234, 160, 18, 18, "Enable Extended Program Change");
          Epcheck->down_box(FL_DOWN_BOX);
          Epcheck->labelsize(12);
          Epcheck->callback((Fl_Callback*)cb_Epcheck);
          Epcheck->align(Fl_Align(FL_ALIGN_LEFT));
          o->value((synth->getRuntime().midi_upper_voice_C < 128));
          if (o->value() == 0) EPCspinner->deactivate();
        } // Fl_Check_Button* Epcheck
        { Fl_Check_Button* o = ignoreReset = new Fl_Check_Button(234, 230, 18, 18, "Ignore Reset all CCs");
          ignoreReset->down_box(FL_DOWN_BOX);
          ignoreReset->labelsize(12);
          ignoreReset->callback((Fl_Callback*)cb_ignoreReset);
          ignoreReset->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().ignoreResetCCs);
        } // Fl_Check_Button* ignoreReset
        { Fl_Check_Button* o = midiMon = new Fl_Check_Button(234, 250, 18, 18, "Log Incoming CCs");
          midiMon->down_box(FL_DOWN_BOX);
          midiMon->labelsize(12);
          midiMon->callback((Fl_Callback*)cb_midiMon);
          midiMon->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().monitorCCin);
        } // Fl_Check_Button* midiMon
        { Fl_Check_Button* o = midiLearned = new Fl_Check_Button(234, 270, 18, 18, "Show Learn Editor");
          midiLearned->tooltip("Open the MIDI learn window for editing when a new CC has been learned");
          midiLearned->down_box(FL_DOWN_BOX);
          midiLearned->labelsize(12);
          midiLearned->callback((Fl_Callback*)cb_midiLearned);
          midiLearned->align(Fl_Align(FL_ALIGN_LEFT));
          o->value(synth->getRuntime().showLearnedCC);
        } // Fl_Check_Button* midiLearned
        EPCvalue = synth->getRuntime().midi_upper_voice_C;
        BankRootvalue = synth->getRuntime().midi_bank_root;
        o->end();
      } // Fl_Group* o
      o->end();
    } // Fl_Tabs* o
    { Fl_Button* o = new Fl_Button(275, 305, 105, 20, "Close Unsaved");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(155, 305, 105, 20, "Save and Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Save);
    } // Fl_Button* o
    o->copy_label(synth->makeUniqueName("Settings").c_str());
    if (synth->getIsLV2Plugin()){jackTab->deactivate();alsaTab->deactivate();}
    configwindow->end();
  } // Fl_Double_Window* configwindow
  { Fl_Double_Window* o = presets = new Fl_Double_Window(460, 295, "Presets");
    presets->user_data((void*)(this));
    { presetbrowse = new Fl_Browser(5, 5, 450, 200);
      presetbrowse->type(2);
      presetbrowse->labelsize(12);
      presetbrowse->textsize(12);
      presetbrowse->callback((Fl_Callback*)cb_presetbrowse);
    } // Fl_Browser* presetbrowse
    { addpreset = new Fl_Button(10, 220, 80, 35, "Add preset directory...");
      addpreset->box(FL_THIN_UP_BOX);
      addpreset->labelsize(12);
      addpreset->callback((Fl_Callback*)cb_addpreset);
      addpreset->align(Fl_Align(FL_ALIGN_WRAP));
    } // Fl_Button* addpreset
    { Fl_Button* o = removepresetbutton = new Fl_Button(110, 220, 80, 35, "Remove preset dir...");
      removepresetbutton->box(FL_THIN_UP_BOX);
      removepresetbutton->labelsize(12);
      removepresetbutton->callback((Fl_Callback*)cb_removepresetbutton);
      removepresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
      o->deactivate();
    } // Fl_Button* removepresetbutton
    { Fl_Button* o = makedefaultpresetbutton = new Fl_Button(210, 220, 80, 35, "Make default");
      makedefaultpresetbutton->box(FL_THIN_UP_BOX);
      makedefaultpresetbutton->labelsize(12);
      makedefaultpresetbutton->callback((Fl_Callback*)cb_makedefaultpresetbutton);
      makedefaultpresetbutton->align(Fl_Align(FL_ALIGN_WRAP));
      o->deactivate();
    } // Fl_Button* makedefaultpresetbutton
    { Fl_Button* o = new Fl_Button(225, 268, 105, 20, "Save and Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Save1);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(345, 268, 105, 20, "Close Unsaved");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    o->copy_label(synth->makeUniqueName("Presets").c_str());
    presets->end();
  } // Fl_Double_Window* presets
  return presets;
}

void ConfigUI::send_data(int control, float value, int type, int par , int par2 ) {
  //
              collect_data(synth, value, (Fl::event_button() | type), control, 0xf8, 0xff, 0xff, 0xff, par, par2);
}

void ConfigUI::returns_update(CommandBlock *getData) {
  //
              int value_int = lrint(getData->data.value);
              bool wasFromHere = getData->data.type & 0x20;
              unsigned char control = getData->data.control;
              unsigned char par2 = getData->data.par2;
  
              bool value_bool = value_int > 0;
              int tmp;
              string name;
              switch (control)
              {
                  case 0:
                      tmp = 0;
                      while (value_int > 256)
                      {
                          value_int = value_int >> 1;
                          ++ tmp;
                      }
                      osc_size->value(tmp);
                      break;
                  case 1:
                      tmp = 0;
                      while (value_int > 16)
                      {
                          value_int = value_int >> 1;
                          ++ tmp;
                      }
                      buff_size->value(tmp);
                      break;
                  case 2:
                      pad_interpol->value(value_int);
                      break;
                  case 3:
                      v_keyboard->value(value_int);
                      break;
                  case 4:
                      compression->value(value_int);
                      break;
                  case 5:
                      reports->value(value_bool);
                      synth->getGuiMaster()->setLogging(value_bool);
                      break;
  
                  case 16:
                      setDefaultState->value(value_bool);
                      break;
                  case 17:
                      nonFatal->value(value_bool);
                      break;
                  case 18:
                      showSplash->value(value_bool);
                      break;
                  case 19:
                      logTimes->value(value_bool);
                      break;
                  case 20:
                      logXML->value(value_bool);
                      break;
                  case 21:
                      saveAllXML->value(value_bool);
                      break;
                  case 22:
                      enableGUI->value(value_bool);
                      break;
                  case 23:
                      enableCLI->value(value_bool);
                      break;
  
                  case 32:
                      jackSource->value(miscMsgPop(par2).c_str());
                      break;
                  case 33:
                      jackMidi->value(value_bool);
                      alsaMidi->value(!value_bool);
                      break;
                  case 34:
                      jackServer->value(miscMsgPop(par2).c_str());
                      break;
                  case 35:
                      jackAudio->value(value_bool);
                      alsaAudio->value(!value_bool);
                      break;
                  case 36:
                      connectJackAudio->value(value_bool);
                      break;
  
                  case 48:
                      alsaSource->value(miscMsgPop(par2).c_str());
                      break;
                  case 49:
                      alsaMidi->value(value_bool);
                      jackMidi->value(!value_bool);
                      break;
                  case 50:
                      alsaDevice->value(miscMsgPop(par2).c_str());
                      break;
                  case 51:
                      alsaAudio->value(value_bool);
                      jackAudio->value(!value_bool);
                      break;
                  case 52:
                      alsaRate->check_none();
                      switch(value_int)
                      {
                          case 192000:
                              alsaRate->set_checked(1);
                              break;
                          case 96000:
                              alsaRate->set_checked(2);
                              break;
                          case 48000:
                              alsaRate->set_checked(3);
                              break;
                          case 44100:
                              alsaRate->set_checked(4);
                              break;
                      }
                      break;
  
                  case 64:
                      break;
                  case 65:
                      if (value_int >= 119)
                      {
                          BankRoot->value(0);
                          BankRoot->deactivate();
                          rootcheck->value(0);
                      }
                      else
                      {
                          BankRoot->value(value_int);
                          BankRoot->activate();
                          rootcheck->value(1);
                      }
                      break;
  
                  case 67:
                      switch (value_int)
                      {
                          case 0:
                              bankchange->value(1);
                              break;
                          case 32:
                              bankchange->value(0);
                              break;
                          default:
                              bankchange->value(2);
                              break;
                      }
                      break;
                  case 68:
                      progenable->value(value_bool);
                      break;
                  case 69:
                      progpartenable->value(value_bool);
                      break;
                  case 70:
                      break;
                  case 71:
                      if (value_int > 119)
                      {
                          EPCspinner->value(110);
                          EPCspinner->deactivate();
                          Epcheck->value(0);
                      }
                      else
                      {
                          EPCspinner->value(value_int);
                          EPCspinner->activate();
                          Epcheck->value(1);
                      }
                      break;
                  case 72:
                      ignoreReset->value(value_bool);
                      break;
                  case 73:
                      midiMon->value(value_bool);
                      break;
                  case 74:
                      midiLearned->value(value_bool);
                      break;
  
                  case 80:
                      name = miscMsgPop(par2);
                      if (wasFromHere && name.find("FAILED") == 1)
                          fl_alert("%s",name.c_str());
                      break;
      }
}

ConfigUI::ConfigUI(SynthEngine *_synth) {
  //
              synth = _synth;
              make_window();
              readpresetcfg();
              selectedRootID = -1;
}

void ConfigUI::activatebutton_presetdir(bool active) {
  //
              if (active)
              {
                  removepresetbutton->activate();
                  makedefaultpresetbutton->activate();
              }
              else
              {
                  removepresetbutton->deactivate();
                  makedefaultpresetbutton->deactivate();
              }
}

int ConfigUI::recoverID() {
  //
              if (selectedRootID >= 0)
              {
                  return selectedRootID;
              }
              return 0;
}

void ConfigUI::readpresetcfg() {
  //
              presetbrowse->clear();
              for (int i = 0; i < MAX_PRESET_DIRS; ++i)
                  if (synth->getRuntime().presetsDirlist[i].size())
                      presetbrowse->add(synth->getRuntime().presetsDirlist[i].c_str());
}

void ConfigUI::writepresetcfg() {
  //
              synth->getRuntime().clearPresetsDirlist();
              for (int n = 0; n < presetbrowse->size(); ++n)
                  synth->getRuntime().presetsDirlist[n] = string(presetbrowse->text(n + 1));
}

void ConfigUI::update_config(int tabnumber) {
  //
              int tmp;
              switch (tabnumber)
              {
                  case 1 : //Main
                      reports->value(synth->getRuntime().toConsole);
                      break;
  
                  case 2 : // Jack
                      jackSource->value(synth->getRuntime().jackMidiDevice.c_str());
                      if (synth->getRuntime().midiEngine == jack_midi)
                      {
                          jackMidi->value(1);
                          alsaMidi->value(0);
                      }
                      jackServer->value(synth->getRuntime().jackServer.c_str());
                      if (synth->getRuntime().audioEngine == jack_audio)
                      {
                          jackAudio->value(1);
                          alsaAudio->value(0);
                      }
                      break;
  
                  case 3 : // Alsa
                      {
                          alsaSource->value(synth->getRuntime().alsaMidiDevice.c_str());
                          if (synth->getRuntime().midiEngine == alsa_midi)
                          {
                              alsaMidi->value(1);
                              jackMidi->value(0);
                          }
                          alsaDevice->value(synth->getRuntime().alsaAudioDevice.c_str());
                          if (synth->getRuntime().audioEngine == alsa_audio)
                          {
                              alsaAudio->value(1);
                              jackAudio->value(0);
                          }
                          switch (synth->getRuntime().Samplerate)
                          {
                              case 192000:
                                  alsaRate->set_checked(1);
                                  break;
                              case 96000:
                                  alsaRate->set_checked(2);
                                  break;
                              case 44100:
                                  alsaRate->set_checked(4);
                                  break;
                              case 48000:
                              default:
                                  alsaRate->set_checked(3);
                                  break;
                          }
                      }
                      break;
  
                  case 4 : // MIDI
                      tmp = synth->getRuntime().midi_bank_root;
                      if (tmp == 128)
                      {
                          BankRoot->value(0);
                          BankRoot->deactivate();
                          rootcheck->value(0);
                      }
                      else
                      {
                          BankRoot->value(tmp);
                          BankRoot->activate();
                          rootcheck->value(1);
                      }
                      Rpend->hide();
  
                      switch (synth->getRuntime().midi_bank_C)
                      {
                          case 32:
                              bankchange->value(0);
                              break;
                          case 0:
                              bankchange->value(1);
                              break;
                          default:
                              bankchange->value(2);
                              break;
                      }
                      progenable->value(synth->getRuntime().EnableProgChange);
                      progpartenable->value(synth->getRuntime().enable_part_on_voice_load);
  
                      tmp = synth->getRuntime().midi_upper_voice_C;
                      if (tmp == 128)
                      {
                          EPCspinner->value(110);
                          EPCspinner->deactivate();
                          Epcheck->value(0);
                      }
                      else
                      {
                          EPCspinner->value(tmp);
                          EPCspinner->activate();
                          Epcheck->value(1);
                      }
                      Epend->hide();
                      break;
  
                  case 5 : // Switches
                      setDefaultState->value(synth->getRuntime().loadDefaultState > 0);
                      logTimes->value(synth->getRuntime().showTimes > 0);
                      nonFatal->value(synth->getRuntime().hideErrors);
                      break;
      }
}

void ConfigUI::Show() {
  //
                      configwindow->show();
}

void ConfigUI::Hide() {
  //
                      configwindow->hide();
}

string ConfigUI::testCC(int value, int control) {
  //
              CommandBlock getData;
              getData.data.value = value;
              getData.data.control = control;
              getData.data.part = 248;
              synth->interchange.testLimits(&getData);
              return miscMsgPop(getData.data.par2);
}
