// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014 -2017, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code.

// Modified July 2017

// generated by Fast Light User Interface Designer (fluid) version 1.0304

#ifndef ConfigUI_h
#define ConfigUI_h
#include <FL/Fl.H>
#include <cmath>
#include <FL/Fl_File_Chooser.H>
#include "Misc/Config.h"
#include "Misc/MiscFuncs.h"
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Check_Browser.H>
#include <FL/Fl_Spinner.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Browser.H>

class ConfigUI : private MiscFuncs {
public:
  Fl_Double_Window* make_window();
  Fl_Double_Window *configwindow;
private:
  inline void cb_configwindow_i(Fl_Double_Window*, void*);
  static void cb_configwindow(Fl_Double_Window*, void*);
public:
  Fl_Choice *osc_size;
private:
  inline void cb_osc_size_i(Fl_Choice*, void*);
  static void cb_osc_size(Fl_Choice*, void*);
  static Fl_Menu_Item menu_osc_size[];
public:
  Fl_Choice *buff_size;
private:
  inline void cb_buff_size_i(Fl_Choice*, void*);
  static void cb_buff_size(Fl_Choice*, void*);
  static Fl_Menu_Item menu_buff_size[];
public:
  Fl_Choice *pad_interpol;
private:
  inline void cb_pad_interpol_i(Fl_Choice*, void*);
  static void cb_pad_interpol(Fl_Choice*, void*);
  static Fl_Menu_Item menu_pad_interpol[];
public:
  Fl_Choice *v_keyboard;
private:
  inline void cb_v_keyboard_i(Fl_Choice*, void*);
  static void cb_v_keyboard(Fl_Choice*, void*);
  static Fl_Menu_Item menu_v_keyboard[];
public:
  Fl_Counter *compression;
private:
  inline void cb_compression_i(Fl_Counter*, void*);
  static void cb_compression(Fl_Counter*, void*);
public:
  Fl_Choice *reports;
private:
  inline void cb_reports_i(Fl_Choice*, void*);
  static void cb_reports(Fl_Choice*, void*);
  static Fl_Menu_Item menu_reports[];
public:
  Fl_Box *settingsNote;
  Fl_Check_Button *setDefaultState;
private:
  inline void cb_setDefaultState_i(Fl_Check_Button*, void*);
  static void cb_setDefaultState(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *nonFatal;
private:
  inline void cb_nonFatal_i(Fl_Check_Button*, void*);
  static void cb_nonFatal(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *showSplash;
private:
  inline void cb_showSplash_i(Fl_Check_Button*, void*);
  static void cb_showSplash(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *logTimes;
private:
  inline void cb_logTimes_i(Fl_Check_Button*, void*);
  static void cb_logTimes(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *logXML;
private:
  inline void cb_logXML_i(Fl_Check_Button*, void*);
  static void cb_logXML(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *saveAllXML;
private:
  inline void cb_saveAllXML_i(Fl_Check_Button*, void*);
  static void cb_saveAllXML(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *enableGUI;
private:
  inline void cb_enableGUI_i(Fl_Check_Button*, void*);
  static void cb_enableGUI(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *enableCLI;
private:
  inline void cb_enableCLI_i(Fl_Check_Button*, void*);
  static void cb_enableCLI(Fl_Check_Button*, void*);
public:
  Fl_Group *jackTab;
  Fl_Input *jackSource;
private:
  inline void cb_jackSource_i(Fl_Input*, void*);
  static void cb_jackSource(Fl_Input*, void*);
public:
  Fl_Check_Button *jackMidi;
private:
  inline void cb_jackMidi_i(Fl_Check_Button*, void*);
  static void cb_jackMidi(Fl_Check_Button*, void*);
public:
  Fl_Input *jackServer;
private:
  inline void cb_jackServer_i(Fl_Input*, void*);
  static void cb_jackServer(Fl_Input*, void*);
public:
  Fl_Check_Button *jackAudio;
private:
  inline void cb_jackAudio_i(Fl_Check_Button*, void*);
  static void cb_jackAudio(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *connectJackAudio;
private:
  inline void cb_connectJackAudio_i(Fl_Check_Button*, void*);
  static void cb_connectJackAudio(Fl_Check_Button*, void*);
public:
  Fl_Group *alsaTab;
  Fl_Input *alsaSource;
private:
  inline void cb_alsaSource_i(Fl_Input*, void*);
  static void cb_alsaSource(Fl_Input*, void*);
public:
  Fl_Check_Button *alsaMidi;
private:
  inline void cb_alsaMidi_i(Fl_Check_Button*, void*);
  static void cb_alsaMidi(Fl_Check_Button*, void*);
public:
  Fl_Input *alsaDevice;
private:
  inline void cb_alsaDevice_i(Fl_Input*, void*);
  static void cb_alsaDevice(Fl_Input*, void*);
public:
  Fl_Check_Button *alsaAudio;
private:
  inline void cb_alsaAudio_i(Fl_Check_Button*, void*);
  static void cb_alsaAudio(Fl_Check_Button*, void*);
public:
  Fl_Check_Browser *alsaRate;
private:
  inline void cb_alsaRate_i(Fl_Check_Browser*, void*);
  static void cb_alsaRate(Fl_Check_Browser*, void*);
  inline void cb_MIDI_i(Fl_Group*, void*);
  static void cb_MIDI(Fl_Group*, void*);
public:
  Fl_Spinner *BankRoot;
private:
  inline void cb_BankRoot_i(Fl_Spinner*, void*);
  static void cb_BankRoot(Fl_Spinner*, void*);
public:
  Fl_Button *Rpend;
private:
  inline void cb_Rpend_i(Fl_Button*, void*);
  static void cb_Rpend(Fl_Button*, void*);
public:
  Fl_Check_Button *rootcheck;
private:
  inline void cb_rootcheck_i(Fl_Check_Button*, void*);
  static void cb_rootcheck(Fl_Check_Button*, void*);
public:
  Fl_Choice *bankchange;
private:
  inline void cb_bankchange_i(Fl_Choice*, void*);
  static void cb_bankchange(Fl_Choice*, void*);
  static Fl_Menu_Item menu_bankchange[];
public:
  static Fl_Menu_Item *banklsb;
  static Fl_Menu_Item *bankusb;
  static Fl_Menu_Item *bankoff;
  Fl_Check_Button *progenable;
private:
  inline void cb_progenable_i(Fl_Check_Button*, void*);
  static void cb_progenable(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *progpartenable;
private:
  inline void cb_progpartenable_i(Fl_Check_Button*, void*);
  static void cb_progpartenable(Fl_Check_Button*, void*);
public:
  Fl_Spinner *EPCspinner;
private:
  inline void cb_EPCspinner_i(Fl_Spinner*, void*);
  static void cb_EPCspinner(Fl_Spinner*, void*);
public:
  Fl_Button *Epend;
private:
  inline void cb_Epend_i(Fl_Button*, void*);
  static void cb_Epend(Fl_Button*, void*);
public:
  Fl_Check_Button *Epcheck;
private:
  inline void cb_Epcheck_i(Fl_Check_Button*, void*);
  static void cb_Epcheck(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *ignoreReset;
private:
  inline void cb_ignoreReset_i(Fl_Check_Button*, void*);
  static void cb_ignoreReset(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *midiMon;
private:
  inline void cb_midiMon_i(Fl_Check_Button*, void*);
  static void cb_midiMon(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *midiLearned;
private:
  inline void cb_midiLearned_i(Fl_Check_Button*, void*);
  static void cb_midiLearned(Fl_Check_Button*, void*);
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
  inline void cb_Save_i(Fl_Button*, void*);
  static void cb_Save(Fl_Button*, void*);
public:
  Fl_Double_Window *presets;
  Fl_Browser *presetbrowse;
private:
  inline void cb_presetbrowse_i(Fl_Browser*, void*);
  static void cb_presetbrowse(Fl_Browser*, void*);
public:
  Fl_Button *addpreset;
private:
  inline void cb_addpreset_i(Fl_Button*, void*);
  static void cb_addpreset(Fl_Button*, void*);
public:
  Fl_Button *removepresetbutton;
private:
  inline void cb_removepresetbutton_i(Fl_Button*, void*);
  static void cb_removepresetbutton(Fl_Button*, void*);
public:
  Fl_Button *makedefaultpresetbutton;
private:
  inline void cb_makedefaultpresetbutton_i(Fl_Button*, void*);
  static void cb_makedefaultpresetbutton(Fl_Button*, void*);
  inline void cb_Save1_i(Fl_Button*, void*);
  static void cb_Save1(Fl_Button*, void*);
  inline void cb_Close1_i(Fl_Button*, void*);
  static void cb_Close1(Fl_Button*, void*);
public:
  void send_data(int control, float value, int type, int par = 0xff, int par2 = 0xff);
  void returns_update(CommandBlock *getData);
  ConfigUI(SynthEngine *_synth);
  void activatebutton_presetdir(bool active);
  int recoverID();
  void readpresetcfg();
  void writepresetcfg();
  void update_config(int tabnumber);
  void Show();
  void Hide();
  string testCC(int value, int control);
private:
  SynthEngine *synth; 
  long selectedRootID; 
  int EPCvalue; 
  int BankRootvalue; 
  int oldBank; 
  int oldrootID; 
};
#endif
