// generated by Fast Light User Interface Designer (fluid) version 1.0304

#include "MasterUI.h"
// MasterUI.cc
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2017, Will Godfrey & others

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is a derivative of the ZynAddSubFX original.

// Modified October 2017


extern bool mainCreateNewInstance(unsigned int forceId);

void MasterUI::cb_masterwindow_i(Fl_Double_Window*, void*) {
  //
      if (synth->getRuntime().configChanged)
      {
          int r = fl_choice("Parameters Changed", "Save Changes", "Cancel", "Don't Save");
          switch (r)
          {
              case 0:
                  synth->getRuntime().configChanged = false;
                  // this seems backwards but it *always* saves.
                  // seeing configChanged makes it reload the old settings first.
                  synth->guiClosed(true);
                  break;
              case 2:
                  synth->guiClosed(true);
                  break;
              default:
                  break;
          }
      }
      else
      {
          synth->guiClosed(true);
      };
}
void MasterUI::cb_masterwindow(Fl_Double_Window* o, void* v) {
  ((MasterUI*)(o->user_data()))->cb_masterwindow_i(o,v);
}

void MasterUI::cb_About_i(Fl_Menu_*, void*) {
  aboutwindow->show();
}
void MasterUI::cb_About(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_About_i(o,v);
}

void MasterUI::cb_newinstanceid_i(Fl_Menu_*, void*) {
  //
            if(synth->getIsLV2Plugin())
                return;

            const char *sId = fl_input("Accept next, or enter desired instance id...", "next");
            if (sId == NULL)
                return;
            unsigned int forceId = 0;
            if (sId)
                forceId = string2uint(sId);
            mainCreateNewInstance(forceId);
}
void MasterUI::cb_newinstanceid(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_newinstanceid_i(o,v);
}

void MasterUI::cb_Settings_i(Fl_Menu_*, void*) {
  configui->Show();
}
void MasterUI::cb_Settings(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Settings_i(o,v);
}

void MasterUI::cb_MIDI_i(Fl_Menu_*, void*) {
  midilearnui->Show();
}
void MasterUI::cb_MIDI(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_MIDI_i(o,v);
}

void MasterUI::cb_View_i(Fl_Menu_*, void*) {
  //
            string path = findfile("/", "yoshimi-user-manual", "pdf");
            if (path == "")
            {
                fl_alert("Can't find manual :(");
                return;
            }
            string command = "xdg-open " + path + "&";
            FILE *fp = popen(command.c_str(), "r");
            if (fp == NULL)
            {
                fl_alert("Can't find PDF reader :(");
                return;
            }
            pclose(fp);
            return;
}
void MasterUI::cb_View(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_View_i(o,v);
}

void MasterUI::cb_E_i(Fl_Menu_*, void*) {
  masterwindow->do_callback();
}
void MasterUI::cb_E(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_E_i(o,v);
}

void MasterUI::cb_S_i(Fl_Menu_*, void*) {
  bankui->Show();
}
void MasterUI::cb_S(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_S_i(o,v);
}

void MasterUI::cb_Load_i(Fl_Menu_*, void*) {
  //
                const char *filename;
                filename = fl_file_chooser("Load:", "({*.xiz})", NULL, 0);
                if (filename == NULL)
                    return;
                send_data(78, npart, 0xc8, 240, 255, 255, 255, miscMsgPush(filename));
}
void MasterUI::cb_Load(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Load_i(o,v);
}

void MasterUI::cb_Save_i(Fl_Menu_*, void*) {
  //
                if (synth->part[npart]->Pname == "Simple Sound")
                {
                    fl_alert("Nothing to save!");
                    return;
                }
                char *filename = fl_file_chooser("Save:", "({*.xiz})", synth->part[npart]->Pname.c_str(), 0);
                if (filename == NULL)
                    return;
                filename = fl_filename_setext(filename, ".xiz");
                if (isRegFile(string(filename)))
                    if (fl_choice("The file exists. \nOverwrite it?", NULL, "No", "Yes") < 2)
                        return;

                bool result = synth->part[npart]->saveXML(string(filename));

                if (!result)
                    fl_alert("Failed to save instrument file");
}
void MasterUI::cb_Save(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

void MasterUI::cb_Clear_i(Fl_Menu_*, void*) {
  //
            if(fl_choice("Clear parameters of instrument %d ?", NULL, "No", "Yes", npart + 1) > 1)
                send_data(96, 0, 0xd0, npart);
}
void MasterUI::cb_Clear(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Clear_i(o,v);
}

void MasterUI::cb_S1_i(Fl_Menu_*, void*) {
  //
            bankui->bankuiwindow->show();
}
void MasterUI::cb_S1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_S1_i(o,v);
}

void MasterUI::cb_Load1_i(Fl_Menu_*, void*) {
  //
            do_load_master(true, NULL);
}
void MasterUI::cb_Load1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Load1_i(o,v);
}

void MasterUI::cb_Save1_i(Fl_Menu_*, void*) {
  //
            bool valid = false;
            for(int npart = 0; npart < NUM_MIDI_PARTS; npart ++)
                if (synth->part[npart]->Pname != "Simple Sound")
                {
                    valid = true;
                    npart = NUM_MIDI_PARTS;
                }
            if (valid)
                do_save_master();
            else
                fl_alert("Nothing to save!");
}
void MasterUI::cb_Save1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save1_i(o,v);
}

void MasterUI::cb_RecentParams_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
            paramsui->Show(2);
}
void MasterUI::cb_RecentParams(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentParams_i(o,v);
}

void MasterUI::cb_Bank_i(Fl_Menu_*, void*) {
  //
            bankui->rootuiwindow->show();
}
void MasterUI::cb_Bank(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Bank_i(o,v);
}

void MasterUI::cb_Preset_i(Fl_Menu_*, void*) {
  //
            configui->presets->show();
}
void MasterUI::cb_Preset(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Preset_i(o,v);
}

void MasterUI::cb_S2_i(Fl_Menu_*, void*) {
  //
            microtonalui->Show();
}
void MasterUI::cb_S2(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_S2_i(o,v);
}

void MasterUI::cb_Load2_i(Fl_Menu_*, void*) {
  //

    const char *filename = fl_file_chooser("Open:", "({*.xsz})", NULL, 0);
    if (filename != NULL)
        do_load_scale(string(filename));
}
void MasterUI::cb_Load2(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Load2_i(o,v);
}

void MasterUI::cb_Save2_i(Fl_Menu_*, void*) {
  //
                char *filename;
                filename = fl_file_chooser("Save:", "({*.xsz})", NULL, 0);
                if (filename == NULL)
                    return;
                filename = fl_filename_setext(filename, ".xsz");
                if (isRegFile(string(filename)))
                    if (fl_choice("The file exists. \nOverwrite it?", NULL, "No", "Yes") < 2)
                        return;
                send_data(89, 0, 0xf0, 0xf0, 0xff, 0xff, 0x80, miscMsgPush(string(filename)));
}
void MasterUI::cb_Save2(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save2_i(o,v);
}

void MasterUI::cb_RecentScale_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
paramsui->Show(3);
}
void MasterUI::cb_RecentScale(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentScale_i(o,v);
}

void MasterUI::cb_Clear1_i(Fl_Menu_*, void*) {
  #
            if (fl_choice("Set scales to the defaults?", NULL, "No", "Yes") > 1)
            {
                synth->microtonal.defaults();
                synth->setAllPartMaps();
                if (NULL != microtonalui)
                    delete microtonalui;
                microtonalui = new MicrotonalUI(&synth->microtonal, synth);
                send_data(96, 0, 0xd0, 0xe8);
            };
}
void MasterUI::cb_Clear1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Clear1_i(o,v);
}

void MasterUI::cb_loadState_i(Fl_Menu_*, void*) {
  // for Alessandro
            char *fle = fl_file_chooser("Load:", "({*.state})", laststatefile.c_str(), 0);
            if (fle)
            {
                setState(fle);
                RecentState->activate();
            }
            else
                refresh_master_ui(0x80 | (miscMsgPush(" ") << 8));
}
void MasterUI::cb_loadState(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_loadState_i(o,v);
}

void MasterUI::cb_saveState_i(Fl_Menu_*, void*) {
  // for Alessandro
            char *fle = fl_file_chooser("Save:", "({*.state})",
                                            laststatefile.c_str(), 0);
            if (fle)
            {
                send_data(93, 0, 0xf0, 0xf0, 0xff, 0xff, 0x80, miscMsgPush(string(fle)));
                laststatefile = string(fle);
                RecentState->activate();
            };
}
void MasterUI::cb_saveState(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_saveState_i(o,v);
}

void MasterUI::cb_RecentState_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
            paramsui->Show(4);
}
void MasterUI::cb_RecentState(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentState_i(o,v);
}

Fl_Menu_Item MasterUI::menu_mastermenu[] = {
 {"&Yoshimi", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&About...", 0,  (Fl_Callback*)MasterUI::cb_About, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&New instance...", 0,  (Fl_Callback*)MasterUI::cb_newinstanceid, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Settings...", 0,  (Fl_Callback*)MasterUI::cb_Settings, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&MIDI Learn...", 0,  (Fl_Callback*)MasterUI::cb_MIDI, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&View Manual", 0,  (Fl_Callback*)MasterUI::cb_View, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {"E&xit", 0,  (Fl_Callback*)MasterUI::cb_E, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Instruments", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"S&how Stored...", 0,  (Fl_Callback*)MasterUI::cb_S, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load External...", 0,  (Fl_Callback*)MasterUI::cb_Load, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save External...", 0,  (Fl_Callback*)MasterUI::cb_Save, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Clear", 0,  (Fl_Callback*)MasterUI::cb_Clear, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Patch Sets", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"S&how Patch Banks...", 0,  (Fl_Callback*)MasterUI::cb_S1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load External...", 0,  (Fl_Callback*)MasterUI::cb_Load1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save External...", 0,  (Fl_Callback*)MasterUI::cb_Save1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent Sets...", 0,  (Fl_Callback*)MasterUI::cb_RecentParams, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Pat&hs", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Bank Root Dirs...", 0,  (Fl_Callback*)MasterUI::cb_Bank, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Preset Dirs...", 0,  (Fl_Callback*)MasterUI::cb_Preset, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Scales", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"S&how Settings...", 0,  (Fl_Callback*)MasterUI::cb_S2, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load...", 0,  (Fl_Callback*)MasterUI::cb_Load2, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save...", 0,  (Fl_Callback*)MasterUI::cb_Save2, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent Scales...", 0,  (Fl_Callback*)MasterUI::cb_RecentScale, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Clear", 0,  (Fl_Callback*)MasterUI::cb_Clear1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"S&tate", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load...", 0,  (Fl_Callback*)MasterUI::cb_loadState, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save...", 0,  (Fl_Callback*)MasterUI::cb_saveState, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent States...", 0,  (Fl_Callback*)MasterUI::cb_RecentState, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* MasterUI::newinstanceid = MasterUI::menu_mastermenu + 2;
Fl_Menu_Item* MasterUI::Parameters = MasterUI::menu_mastermenu + 14;
Fl_Menu_Item* MasterUI::Save = MasterUI::menu_mastermenu + 17;
Fl_Menu_Item* MasterUI::RecentParams = MasterUI::menu_mastermenu + 18;
Fl_Menu_Item* MasterUI::Scales = MasterUI::menu_mastermenu + 24;
Fl_Menu_Item* MasterUI::RecentScale = MasterUI::menu_mastermenu + 28;
Fl_Menu_Item* MasterUI::loadState = MasterUI::menu_mastermenu + 32;
Fl_Menu_Item* MasterUI::saveState = MasterUI::menu_mastermenu + 33;
Fl_Menu_Item* MasterUI::RecentState = MasterUI::menu_mastermenu + 34;

void MasterUI::cb_globalfinedetune_i(WidgetPDial* o, void*) {
  //
          send_data(32, o->value(), 0xc8);
}
void MasterUI::cb_globalfinedetune(WidgetPDial* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_globalfinedetune_i(o,v);
}

void MasterUI::cb_Reset_i(Fl_Button*, void*) {
  //
          if (fl_choice("Set *ALL* dynamic values to their defaults?", NULL, "No", "Yes") > 1)
              send_data(96, 0, 0xf0, 0xf0, 0xff, 0xff, 0xc0);
}
void MasterUI::cb_Reset(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Reset_i(o,v);
}

void MasterUI::cb_Stop_i(Fl_Button* o, void*) {
  //
          send_data(128, o->value(), 0xc0);
}
void MasterUI::cb_Stop(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Stop_i(o,v);
}

void MasterUI::cb_mastervolumedial_i(WidgetPDial* o, void*) {
  //
          send_data(0, o->value(), 0x48);
}
void MasterUI::cb_mastervolumedial(WidgetPDial* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_mastervolumedial_i(o,v);
}

void MasterUI::cb_Virtual_i(Fl_Button*, void*) {
  //
          virkeyboard->Show();
}
void MasterUI::cb_Virtual(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Virtual_i(o,v);
}

void MasterUI::cb_mixerpanel_i(Fl_Button*, void*) {
  //
          updatepanel();
          panelwindow->show();
}
void MasterUI::cb_mixerpanel(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_mixerpanel_i(o,v);
}

void MasterUI::cb_Reports_i(Fl_Button*, void*) {
  //
          yoshiLog->Show();
}
void MasterUI::cb_Reports(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Reports_i(o,v);
}

void MasterUI::cb_vectors_i(Fl_Button*, void*) {
  //
          vectorui->Show();
}
void MasterUI::cb_vectors(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_vectors_i(o,v);
}

void MasterUI::cb_sysinsgroup_i(Fl_Tabs* o, void*) {
  //
        if (o->value() == SystemEffectsGrp)
            showSysEfxUI();
        else if (o->value() == InsertionEffectsGrp)
            showInsEfxUI();
}
void MasterUI::cb_sysinsgroup(Fl_Tabs* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_sysinsgroup_i(o,v);
}

void MasterUI::cb_syseffnocounter_i(Fl_Spinner* o, void*) {
  //
            send_data(0, o->value() - 1, 0xd0, 0xf1, o->value() - 1);
}
void MasterUI::cb_syseffnocounter(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_syseffnocounter_i(o,v);
}

void MasterUI::cb_sysefftype_i(Fl_Choice* o, void*) {
  //
            send_data(1, o->value(), 0xd0, 0xf1, nsyseff);
}
void MasterUI::cb_sysefftype(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_sysefftype_i(o,v);
}

Fl_Menu_Item MasterUI::menu_sysefftype[] = {
 {"No Effect", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Reverb", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Echo", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Chorus", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Phaser", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"AlienWah", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Distortion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"EQ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"DynFilter", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_Send_i(Fl_Button*, void*) {
  //
            syseffsendwindow->show();
}
void MasterUI::cb_Send(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_Send_i(o,v);
}

void MasterUI::cb_C_i(Fl_Button*, void*) {
  presetsui->copy(synth->sysefx[nsyseff]);
}
void MasterUI::cb_C(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_C_i(o,v);
}

void MasterUI::cb_P_i(Fl_Button*, void*) {
  //
            presetsui->paste(synth->sysefx[nsyseff], syseffectui);
}
void MasterUI::cb_P(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_P_i(o,v);
}

void MasterUI::cb_inseffnocounter_i(Fl_Spinner* o, void*) {
  //
            send_data(0, o->value() - 1, 0xd0, 0xf2, o->value() - 1);
}
void MasterUI::cb_inseffnocounter(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_inseffnocounter_i(o,v);
}

void MasterUI::cb_insefftype_i(Fl_Choice* o, void*) {
  //
            send_data(1, o->value(), 0xd0, 0xf2, ninseff);
}
void MasterUI::cb_insefftype(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_insefftype_i(o,v);
}

Fl_Menu_Item MasterUI::menu_insefftype[] = {
 {"No Effect", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Reverb", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Echo", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Chorus", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Phaser", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"AlienWah", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Distortion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"EQ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"DynFilter", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_inseffpart_i(Fl_Choice* o, void*) {
  //
            send_data(2, o->value() - 2, 0xd0, 0xf2, ninseff);
}
void MasterUI::cb_inseffpart(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_inseffpart_i(o,v);
}

void MasterUI::cb_C1_i(Fl_Button*, void*) {
  presetsui->copy(synth->insefx[ninseff]);
}
void MasterUI::cb_C1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_C1_i(o,v);
}

void MasterUI::cb_P1_i(Fl_Button*, void*) {
  //
            presetsui->paste(synth->insefx[ninseff], inseffectui);
}
void MasterUI::cb_P1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_P1_i(o,v);
}

void MasterUI::cb_masterkeyshift_i(Fl_Spinner* o, void*) {
  //
        send_data(35, o->value(), 0xc0);
}
void MasterUI::cb_masterkeyshift(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_masterkeyshift_i(o,v);
}

void MasterUI::cb_npartcounter_i(Fl_Spinner* o, void*) {
  //
        int nval = o->value() - 1;
        synth->getRuntime().currentPart = nval;
        partNew(nval);
        send_data(14, nval, 0xc0);
}
void MasterUI::cb_npartcounter(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_npartcounter_i(o,v);
}

void MasterUI::cb_maxparts_i(Fl_Spinner* o, void*) {
  //
        int tmp = o->value();
        if (tmp == 48)
        {
            if (partmax == 32)
                tmp = 64;
            else
                tmp = 32;
            o->value(tmp);
        }
        partmax = tmp;
        updatepart();
        updatepanel();
        setinspartlist();
        send_data(15, tmp, 0xc0);
}
void MasterUI::cb_maxparts(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_maxparts_i(o,v);
}

void MasterUI::cb_Close_i(Fl_Button*, void*) {
  //
        aboutwindow->hide();
}
void MasterUI::cb_Close(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void MasterUI::cb_Close1_i(Fl_Button*, void*) {
  //
        syseffsendwindow->hide();
}
void MasterUI::cb_Close1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

void MasterUI::cb_Panelclose_i(Fl_Button*, void*) {
  //
        panelwindow->hide();
}
void MasterUI::cb_Panelclose(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Panelclose_i(o,v);
}

void MasterUI::cb_Change_i(Fl_Button*, void*) {
  //
        Panelbox1->hide();
        synth->getRuntime().single_row_panel = 1;
        updatepanel();
}
void MasterUI::cb_Change(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Change_i(o,v);
}

void MasterUI::cb_Change1_i(Fl_Button*, void*) {
  //
        synth->getRuntime().single_row_panel = 0;
        updatepanel();
        Panelbox1->show();
}
void MasterUI::cb_Change1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Change1_i(o,v);
}

void MasterUI::cb_Panelgroups_i(Fl_Choice* o, void*) {
  //
        panelgroup = o->value() * NUM_MIDI_CHANNELS;
        Panelsmallgroups->value(o->value());
        updatepanel();
}
void MasterUI::cb_Panelgroups(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Panelgroups_i(o,v);
}

Fl_Menu_Item MasterUI::menu_Panelgroups[] = {
 {"1 to 16", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {"17 to 32", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {"33 to 48", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {"49 to 64", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_Panelsmallgroups_i(Fl_Choice* o, void*) {
  //
        panelgroup = o->value() * NUM_MIDI_CHANNELS;
        Panelgroups->value(o->value());
        updatepanel();
}
void MasterUI::cb_Panelsmallgroups(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Panelsmallgroups_i(o,v);
}

Fl_Menu_Item MasterUI::menu_Panelsmallgroups[] = {
 {"1 to 16", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {"17 to 32", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_CSspinner_i(Fl_Spinner*, void*) {
  //
        CSpend->show();
}
void MasterUI::cb_CSspinner(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_CSspinner_i(o,v);
}

void MasterUI::cb_CSpend_i(Fl_Button* o, void*) {
  //
        int candidate = CSspinner->value();
        if (candidate == CS_CC)
        {
            o->hide();
            return;
        }

        string name = synth->getRuntime().testCCvalue(candidate);
        if (!name.empty())
        {
            fl_alert("In use for %s",name.c_str());
            if (CS_CC < 128)
            {
            CSspinner->value(CS_CC);
            CSspinner->redraw();
            }
        }
        else
        {
            CS_CC = candidate;
            o->hide();
        }
        send_data(49, CSspinner->value(), 0xc0);
}
void MasterUI::cb_CSpend(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_CSpend_i(o,v);
}

void MasterUI::cb_channelswitch_i(Fl_Choice* o, void*) {
  //
        if (o->value() == 0)
        {
            CS_CC = 128;
            CSspinner->value(115);
            CSspinner->hide();
            CSpend->hide();
        }
        else
        {
            CSspinner->show();
            if(CS_CC == 128)
                CSpend->show();
        }
        send_data(48, o->value(), 0xc0);
}
void MasterUI::cb_channelswitch(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_channelswitch_i(o,v);
}

Fl_Menu_Item MasterUI::menu_channelswitch[] = {
 {"Off", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Row", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Col", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Loop", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* MasterUI::switchoff = MasterUI::menu_channelswitch + 0;
Fl_Menu_Item* MasterUI::switchrow = MasterUI::menu_channelswitch + 1;
Fl_Menu_Item* MasterUI::switchcolumn = MasterUI::menu_channelswitch + 2;
Fl_Menu_Item* MasterUI::switchloop = MasterUI::menu_channelswitch + 3;

MasterUI::MasterUI(SynthEngine *_synth) {
  //
        synth = _synth;
        presetsui = NULL;
        ninseff = 0;
        nsyseff = 0;
        npart = 0;
        panelgroup = 0;
        for (int i = 0; i < NUM_SYS_EFX; ++i)
        {
            for (int j = 0; j < NUM_SYS_EFX; ++j)
                syseffsend[i][j] = NULL;
        }
        microtonalui = NULL;
        bankui = NULL;
        virkeyboard = NULL;
        configui = NULL;
        presetsui = NULL;
        paramsui = NULL;
        yoshiLog = NULL;
        laststatefile = synth->getRuntime().StateFile;
}

MasterUI::~MasterUI() {
  //
        saveWindowData();
        masterwindow->hide();
        aboutwindow->hide();
        delete aboutwindow;
        syseffsendwindow->hide();
        delete syseffsendwindow;
        panelwindow->hide();
        delete panelwindow;
        if (microtonalui)
        {
            microtonalui->Hide();
            delete microtonalui;
        }
        if (bankui)
        {
            bankui->Hide();
            delete bankui;
        }
        if (virkeyboard)
        {
            virkeyboard->Hide();
            delete virkeyboard;
        }
        if (configui)
        {
            configui->Hide();
            delete configui;
        }
        if (presetsui)
        {
            presetsui->Hide();
            delete presetsui;
        }
        if (paramsui)
        {
            paramsui->Hide();
            delete paramsui;
        }
        if (vectorui)
        {
            vectorui->Hide();
            delete vectorui;
        }
        if (midilearnui)
        {
            midilearnui->Hide();
            delete midilearnui;
        }
  
        if (yoshiLog)
        {
            yoshiLog->Hide();
            delete yoshiLog;
        }
        delete masterwindow;
}

void MasterUI::Init(const char *_label) {
  //
        instance = synth->getUniqueId();
  
        filename = synth->getRuntime().ConfigDir + "/" +synth->getRuntime().programCmd();
        if (instance > 0)
        {
            filename += ("-" + asString(instance));
        }
        partmax = synth->getRuntime().NumAvailableParts;
        filename += ".windows";
        microtonalui = new MicrotonalUI(&synth->microtonal, synth);
        bankui = new BankUI(&npart, synth);
        virkeyboard = new VirKeyboard(synth);
        configui = new ConfigUI(synth);
        presetsui = new PresetsUI(synth);
        paramsui = new ParametersUI(synth);
        vectorui = new VectorUI(synth, bankui, paramsui);
        midilearnui = new MidiLearnUI(synth);
        yoshiLog = new ConsoleUI();
  
        make_window();
        loadWindowData();
        if(synth->getIsLV2Plugin())
        {
            masterwindow->label(_label);
        }
        else
        {
            setMasterLabel(synth->getRuntime().paramsLoad);
        }
        masterwindow->show();
  
        // these don't have access to synth ->
        microtonalui->microtonaluiwindow->copy_label(synth->makeUniqueName("Scales").c_str());
        yoshiLog->logConsole->copy_label(synth->makeUniqueName("Console").c_str());
  
        if (panelO)
            mixerpanel->do_callback();
        if (instrumentsO)
            bankui->Show();
        if (banksO)
            bankui->bankuiwindow->show();
        if (presetsO)
            configui->presets->show();
        if (rootsO)
            bankui->rootuiwindow->show();
        if (scalesO)
            microtonalui->microtonaluiwindow->show();
        if (virkbdO)
            virkeyboard->Show();
        if (settingsO)
            configui->Show();
        if (yoshiLogO)
            yoshiLog->Show();
        if (vectorO)
            vectorui->Show();
        if (mlearnO)
            midilearnui->Show();
        if (controllersO)
            partui->ctlwindow->show();
        if (midictlO)
            partui->ctlmidi->show();
        if (inseditO)
            partui->instrumenteditwindow->show();
        //if (kitlistO)
            //partui->instrumentkitlist->show();
        //if (partfxO)
            //partui->partfx->show();
}

Fl_Double_Window* MasterUI::make_window() {
  { masterwindow = new Fl_Double_Window(385, 465, "Yoshimi meets ZynAddSubFX");
    masterwindow->labelfont(13);
    masterwindow->labelsize(12);
    masterwindow->callback((Fl_Callback*)cb_masterwindow, (void*)(this));
    { Fl_Box* o = new Fl_Box(279, 28, 103, 85);
      o->box(FL_ENGRAVED_FRAME);
    } // Fl_Box* o
    { mastermenu = new ClearMenuBar(-7, 0, 395, 25);
      mastermenu->box(FL_UP_BOX);
      mastermenu->color(FL_BACKGROUND_COLOR);
      mastermenu->selection_color(FL_SELECTION_COLOR);
      mastermenu->labeltype(FL_NORMAL_LABEL);
      mastermenu->labelfont(0);
      mastermenu->labelsize(12);
      mastermenu->labelcolor(FL_FOREGROUND_COLOR);
      mastermenu->textsize(12);
      mastermenu->align(Fl_Align(FL_ALIGN_CENTER));
      mastermenu->when(FL_WHEN_RELEASE_ALWAYS);
      { Fl_Menu_Item* o = &menu_mastermenu[14];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(2);
        if (listType.size() == 0) RecentParams->deactivate(); else RecentParams->activate();
      }
      { Fl_Menu_Item* o = &menu_mastermenu[24];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(3);
        if (listType.size() == 0) RecentScale->deactivate(); else RecentScale->activate();
      }
      { Fl_Menu_Item* o = &menu_mastermenu[31];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(4);
        if (listType.size() == 0) RecentState->deactivate(); else RecentState->activate();
      }
      mastermenu->menu(menu_mastermenu);
    } // ClearMenuBar* mastermenu
    { MasterControls = new Fl_Group(3, 24, 380, 91, "Master  ");
      MasterControls->labeltype(FL_NO_LABEL);
      MasterControls->labelsize(11);
      MasterControls->labelcolor((Fl_Color)96);
      MasterControls->align(Fl_Align(FL_ALIGN_BOTTOM_LEFT|FL_ALIGN_INSIDE));
      { WidgetPDial* o = globalfinedetune = new WidgetPDial(286, 32, 40, 40, "Detune");
        globalfinedetune->tooltip("Global Fine Detune");
        globalfinedetune->box(FL_ROUND_UP_BOX);
        globalfinedetune->color((Fl_Color)29);
        globalfinedetune->selection_color(FL_INACTIVE_COLOR);
        globalfinedetune->labeltype(FL_NORMAL_LABEL);
        globalfinedetune->labelfont(0);
        globalfinedetune->labelsize(10);
        globalfinedetune->labelcolor(FL_FOREGROUND_COLOR);
        globalfinedetune->maximum(127);
        globalfinedetune->step(1);
        globalfinedetune->value(64);
        globalfinedetune->callback((Fl_Callback*)cb_globalfinedetune);
        globalfinedetune->align(Fl_Align(FL_ALIGN_BOTTOM));
        globalfinedetune->when(FL_WHEN_CHANGED);
        o->setValueType(VC_GlobalFineDetune);
        o->value(synth->microtonal.Pglobalfinedetune);
        o->init(64);
      } // WidgetPDial* globalfinedetune
      { Fl_Button* o = new Fl_Button(7, 60, 70, 24, "Reset");
        o->tooltip("Clear all dynamic settings");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)228);
        o->selection_color(FL_GRAY0);
        o->labelfont(1);
        o->labelsize(11);
        o->callback((Fl_Callback*)cb_Reset);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(7, 30, 70, 24, "Stop!");
        o->tooltip("Cease all sound immediately!");
        o->box(FL_PLASTIC_UP_BOX);
        o->color(FL_RED);
        o->selection_color(FL_FOREGROUND_COLOR);
        o->labelfont(1);
        o->labelsize(11);
        o->callback((Fl_Callback*)cb_Stop);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      } // Fl_Button* o
      { WidgetPDial* o = mastervolumedial = new WidgetPDial(335, 32, 40, 40, "Volume");
        mastervolumedial->tooltip("Master Volume");
        mastervolumedial->box(FL_ROUND_UP_BOX);
        mastervolumedial->color((Fl_Color)29);
        mastervolumedial->selection_color(FL_INACTIVE_COLOR);
        mastervolumedial->labeltype(FL_NORMAL_LABEL);
        mastervolumedial->labelfont(0);
        mastervolumedial->labelsize(10);
        mastervolumedial->labelcolor(FL_FOREGROUND_COLOR);
        mastervolumedial->maximum(127);
        mastervolumedial->step(1);
        mastervolumedial->callback((Fl_Callback*)cb_mastervolumedial);
        mastervolumedial->align(Fl_Align(FL_ALIGN_BOTTOM));
        mastervolumedial->when(FL_WHEN_CHANGED);
        o->setValueType(VC_MasterVolume);
        o->value(synth->Pvolume);
        o->init(90);
      } // WidgetPDial* mastervolumedial
      { Fl_Button* o = new Fl_Button(85, 60, 110, 24, "Virtual Keyboard");
        o->tooltip("Virtual Keyboard");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)228);
        o->labelsize(11);
        o->labelcolor(FL_GRAY0);
        o->callback((Fl_Callback*)cb_Virtual);
      } // Fl_Button* o
      { mixerpanel = new Fl_Button(85, 30, 110, 24, "Mixer Panel");
        mixerpanel->tooltip("Mixer Panel Window");
        mixerpanel->box(FL_PLASTIC_UP_BOX);
        mixerpanel->color((Fl_Color)228);
        mixerpanel->labelsize(11);
        mixerpanel->labelcolor(FL_GRAY0);
        mixerpanel->callback((Fl_Callback*)cb_mixerpanel);
      } // Fl_Button* mixerpanel
      { Fl_Button* o = Reports = new Fl_Button(203, 60, 70, 24, "Reports");
        Reports->tooltip("Message Log");
        Reports->box(FL_PLASTIC_UP_BOX);
        Reports->color((Fl_Color)228);
        Reports->labelsize(11);
        Reports->callback((Fl_Callback*)cb_Reports);
        if (synth->getRuntime().toConsole == false){o->deactivate();yoshiLog->Hide();}
      } // Fl_Button* Reports
      { vectors = new Fl_Button(203, 30, 70, 24, "Vectors");
        vectors->tooltip("Vector Setup Window");
        vectors->box(FL_PLASTIC_UP_BOX);
        vectors->color((Fl_Color)228);
        vectors->labelsize(11);
        vectors->labelcolor(FL_GRAY0);
        vectors->callback((Fl_Callback*)cb_vectors);
      } // Fl_Button* vectors
      MasterControls->end();
    } // Fl_Group* MasterControls
    { sysinsgroup = new Fl_Tabs(3, 88, 379, 68, "System/Insert");
      sysinsgroup->box(FL_PLASTIC_UP_BOX);
      sysinsgroup->color((Fl_Color)44);
      sysinsgroup->selection_color((Fl_Color)221);
      sysinsgroup->labeltype(FL_NO_LABEL);
      sysinsgroup->labelsize(12);
      sysinsgroup->callback((Fl_Callback*)cb_sysinsgroup);
      sysinsgroup->align(Fl_Align(FL_ALIGN_TOP_LEFT));
      { SystemEffectsGrp = new Fl_Group(3, 116, 379, 40, "  System Effects  ");
        SystemEffectsGrp->color((Fl_Color)221);
        SystemEffectsGrp->selection_color((Fl_Color)31);
        SystemEffectsGrp->labelfont(1);
        SystemEffectsGrp->labelsize(12);
        SystemEffectsGrp->align(Fl_Align(FL_ALIGN_LEFT));
        { Fl_Spinner* o = syseffnocounter = new Fl_Spinner(40, 126, 36, 20, "Effect");
          syseffnocounter->labeltype(FL_NO_LABEL);
          syseffnocounter->labelsize(11);
          syseffnocounter->maximum(4);
          syseffnocounter->textfont(1);
          syseffnocounter->textsize(11);
          syseffnocounter->callback((Fl_Callback*)cb_syseffnocounter);
          syseffnocounter->align(Fl_Align(FL_ALIGN_CENTER));
          o->range(1, NUM_SYS_EFX);
          o->value(nsyseff + 1);
        } // Fl_Spinner* syseffnocounter
        { Fl_Choice* o = sysefftype = new Fl_Choice(120, 126, 96, 20, "Type");
          sysefftype->down_box(FL_BORDER_BOX);
          sysefftype->labeltype(FL_NO_LABEL);
          sysefftype->labelsize(10);
          sysefftype->callback((Fl_Callback*)cb_sysefftype);
          sysefftype->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
          sysefftype->menu(menu_sysefftype);
          o->value(synth->sysefx[nsyseff]->geteffect());
        } // Fl_Choice* sysefftype
        { Fl_Button* o = new Fl_Button(256, 126, 62, 20, "Send to");
          o->box(FL_THIN_UP_BOX);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)97);
          o->callback((Fl_Callback*)cb_Send);
        } // Fl_Button* o
        { Fl_Button* o = new Fl_Button(350, 122, 25, 14, "C");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_C);
        } // Fl_Button* o
        { Fl_Button* o = new Fl_Button(350, 137, 25, 14, "P");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_P);
        } // Fl_Button* o
        SystemEffectsGrp->end();
      } // Fl_Group* SystemEffectsGrp
      { InsertionEffectsGrp = new Fl_Group(3, 116, 379, 40, " Insertion Effects ");
        InsertionEffectsGrp->color((Fl_Color)221);
        InsertionEffectsGrp->selection_color((Fl_Color)31);
        InsertionEffectsGrp->labelfont(1);
        InsertionEffectsGrp->labelsize(12);
        InsertionEffectsGrp->labelcolor((Fl_Color)33);
        InsertionEffectsGrp->align(Fl_Align(FL_ALIGN_LEFT));
        InsertionEffectsGrp->hide();
        { Fl_Spinner* o = inseffnocounter = new Fl_Spinner(40, 126, 36, 20, "Effect");
          inseffnocounter->labeltype(FL_NO_LABEL);
          inseffnocounter->labelsize(11);
          inseffnocounter->maximum(8);
          inseffnocounter->textfont(1);
          inseffnocounter->textsize(11);
          inseffnocounter->callback((Fl_Callback*)cb_inseffnocounter);
          inseffnocounter->align(Fl_Align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE));
          o->range(1, NUM_INS_EFX);
          o->value(ninseff + 1);
        } // Fl_Spinner* inseffnocounter
        { Fl_Choice* o = insefftype = new Fl_Choice(120, 126, 96, 20, "Type");
          insefftype->down_box(FL_BORDER_BOX);
          insefftype->labeltype(FL_NO_LABEL);
          insefftype->labelsize(11);
          insefftype->textsize(12);
          insefftype->callback((Fl_Callback*)cb_insefftype);
          insefftype->align(Fl_Align(FL_ALIGN_CENTER));
          insefftype->menu(menu_insefftype);
          o->value(synth->insefx[ninseff]->geteffect());
          if (synth->Pinsparts[ninseff]== -1) o->deactivate();
        } // Fl_Choice* insefftype
        { Fl_Choice* o = inseffpart = new Fl_Choice(242, 126, 96, 20, "To ");
          inseffpart->down_box(FL_BORDER_BOX);
          inseffpart->labelfont(1);
          inseffpart->labelsize(10);
          inseffpart->textfont(1);
          inseffpart->textsize(11);
          inseffpart->callback((Fl_Callback*)cb_inseffpart);
          setinspartlist();
          o->value(synth->Pinsparts[ninseff]+2);
        } // Fl_Choice* inseffpart
        { Fl_Button* o = new Fl_Button(350, 122, 25, 14, "C");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_C1);
        } // Fl_Button* o
        { Fl_Button* o = new Fl_Button(350, 137, 25, 14, "P");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_P1);
        } // Fl_Button* o
        InsertionEffectsGrp->end();
      } // Fl_Group* InsertionEffectsGrp
      sysinsgroup->end();
    } // Fl_Tabs* sysinsgroup
    { Fl_Group* o = syseffectuigroup = new Fl_Group(3, 158, 384, 95);
      syseffectuigroup->box(FL_FLAT_BOX);
      syseffectuigroup->color((Fl_Color)48);
      syseffectuigroup->labeltype(FL_NO_LABEL);
      { EffUI* o = syseffectui = new EffUI(3, 158, 384, 95);
        syseffectui->box(FL_NO_BOX);
        syseffectui->color(FL_BACKGROUND_COLOR);
        syseffectui->selection_color(FL_BACKGROUND_COLOR);
        syseffectui->labeltype(FL_NO_LABEL);
        syseffectui->labelfont(0);
        syseffectui->labelsize(14);
        syseffectui->labelcolor(FL_FOREGROUND_COLOR);
        syseffectui->align(Fl_Align(FL_ALIGN_TOP));
        syseffectui->when(FL_WHEN_RELEASE);
        o->init(synth->sysefx[nsyseff], 0xf1, nsyseff);o->activate();o->show();
        syseffectui->end();
      } // EffUI* syseffectui
      o->show();
      syseffectuigroup->end();
    } // Fl_Group* syseffectuigroup
    { Fl_Group* o = inseffectuigroup = new Fl_Group(3, 158, 384, 95);
      inseffectuigroup->box(FL_FLAT_BOX);
      inseffectuigroup->color((Fl_Color)48);
      { EffUI* o = inseffectui = new EffUI(3, 158, 379, 95);
        inseffectui->box(FL_NO_BOX);
        inseffectui->color(FL_LIGHT2);
        inseffectui->selection_color(FL_BACKGROUND_COLOR);
        inseffectui->labeltype(FL_NORMAL_LABEL);
        inseffectui->labelfont(0);
        inseffectui->labelsize(14);
        inseffectui->labelcolor(FL_FOREGROUND_COLOR);
        inseffectui->align(Fl_Align(FL_ALIGN_TOP));
        inseffectui->when(FL_WHEN_RELEASE);
        o->init(synth->insefx[ninseff], 0xf2, ninseff);o->hide();
        if (synth->Pinsparts[ninseff]== -1) o->deactivate();
        inseffectui->end();
      } // EffUI* inseffectui
      o->hide();
      inseffectuigroup->end();
    } // Fl_Group* inseffectuigroup
    { partuigroup = new Fl_Group(3, 255, 380, 170);
      partuigroup->box(FL_ENGRAVED_FRAME);
      { PartUI* o = partui = new PartUI(3, 255, 379, 170);
        partui->box(FL_NO_BOX);
        partui->color(FL_DARK1);
        partui->selection_color(FL_BACKGROUND_COLOR);
        partui->labeltype(FL_NORMAL_LABEL);
        partui->labelfont(0);
        partui->labelsize(14);
        partui->labelcolor(FL_FOREGROUND_COLOR);
        partui->align(Fl_Align(FL_ALIGN_TOP));
        partui->when(FL_WHEN_RELEASE);
        o->init(synth->part[0],0,bankui);
        o->show();
        partui->end();
      } // PartUI* partui
      partuigroup->end();
    } // Fl_Group* partuigroup
    { Fl_Group* o = new Fl_Group(3, 427, 379, 36);
      o->box(FL_DOWN_BOX);
      o->color((Fl_Color)43);
      o->labelsize(12);
      { VUMeter* o = vumeter = new VUMeter(3, 429, 379, 34, "VU-Meter");
        vumeter->box(FL_NO_BOX);
        vumeter->color((Fl_Color)48);
        vumeter->selection_color((Fl_Color)75);
        vumeter->labeltype(FL_NORMAL_LABEL);
        vumeter->labelfont(0);
        vumeter->labelsize(14);
        vumeter->labelcolor(FL_FOREGROUND_COLOR);
        vumeter->align(Fl_Align(FL_ALIGN_CENTER));
        vumeter->when(FL_WHEN_RELEASE);
        o->init(-1, synth);
      } // VUMeter* vumeter
      o->end();
    } // Fl_Group* o
    { Fl_Spinner* o = masterkeyshift = new Fl_Spinner(336, 88, 38, 20, "Key Shift");
      masterkeyshift->tooltip("Shift pitch +/- N semitones");
      masterkeyshift->labelsize(10);
      masterkeyshift->minimum(-36);
      masterkeyshift->maximum(36);
      masterkeyshift->textsize(10);
      masterkeyshift->callback((Fl_Callback*)cb_masterkeyshift);
      o->range(MIN_KEY_SHIFT, MAX_KEY_SHIFT);o->step(1.0);
      o->value(synth->Pkeyshift - 64);
    } // Fl_Spinner* masterkeyshift
    { Fl_Spinner* o = npartcounter = new Fl_Spinner(36, 264, 40, 20, "Part");
      npartcounter->labelsize(11);
      npartcounter->minimum(0);
      npartcounter->maximum(127);
      npartcounter->textsize(11);
      npartcounter->callback((Fl_Callback*)cb_npartcounter);
      npartcounter->when(FL_WHEN_RELEASE_ALWAYS);
      o->range(1.0, partmax);
      o->value(synth->getRuntime().currentPart + 1);
      bankui->init(o);
    } // Fl_Spinner* npartcounter
    { Fl_Spinner* o = maxparts = new Fl_Spinner(93, 264, 40, 20, "of");
      maxparts->tooltip("Set the number of available parts");
      maxparts->labelsize(11);
      maxparts->minimum(16);
      maxparts->maximum(64);
      maxparts->step(16);
      maxparts->value(16);
      maxparts->textsize(11);
      maxparts->callback((Fl_Callback*)cb_maxparts);
      o->value(partmax);
    } // Fl_Spinner* maxparts
    masterwindow->xclass("Yoshimi");
    masterwindow->end();
  } // Fl_Double_Window* masterwindow
  { aboutwindow = new Fl_Double_Window(365, 290, "About Yoshimi");
    aboutwindow->color(FL_LIGHT3);
    aboutwindow->labelfont(13);
    aboutwindow->labelsize(13);
    aboutwindow->user_data((void*)(this));
    aboutwindow->when(FL_WHEN_NEVER);
    { Fl_Box* o = new Fl_Box(10, 17, 345, 70, "Yoshimi\nmeets\nZynAddSubFX");
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(13);
      o->labelsize(18);
      o->labelcolor(FL_BLUE);
      o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      o->when(FL_WHEN_NEVER);
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(25, 93, 315, 91, "copyright notice");
      o->color((Fl_Color)51);
      o->selection_color((Fl_Color)30);
      o->labelfont(13);
      o->labelsize(11);
      o->align(Fl_Align(192|FL_ALIGN_INSIDE));
      o->when(FL_WHEN_NEVER);
      o->copy_label(string("Copyright (c) 2002-2009 Nasca O. PAUL and others"
                               "\nCopyright 2009-2011, Alan Calvert"
                               "\nCopyright 2012-2013, Jeremy Jongepier and others"
                               "\nCopyright 2014-2017, Will Godfrey and others"
                               "\nLV2 plugin Copyright 2014, Andrew Deryabin"
                               "\nSplash Image Copyright 2017, Jesper Lloyd").c_str());
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(10, 198, 340, 53, "copy terms");
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_WRAP|FL_ALIGN_INSIDE));
      o->when(FL_WHEN_NEVER);
      //
            o->copy_label(string("This is free software, and comes with ABSOLUTELY NO WARRANTY; "
                                 "you may redistribute it and/or modify it under the terms of "
                                 "GPL version 2, or (at your option) any later version.\n\n").c_str());
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(55, 254, 240, 20, " version");
      o->labelfont(1);
      o->labelsize(12);
      o->labelcolor((Fl_Color)145);
      //
            o->copy_label((string("Yoshimi version ")
                           + string( YOSHIMI_VERSION )).c_str());
    } // Fl_Box* o
    { Fl_Button* o = new Fl_Button(305, 253, 43, 22, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(11);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    aboutwindow->end();
  } // Fl_Double_Window* aboutwindow
  { syseffsendwindow = new Fl_Double_Window(120, 250, "Sys Send");
    syseffsendwindow->labelfont(13);
    syseffsendwindow->labelsize(13);
    syseffsendwindow->user_data((void*)(this));
    { Fl_Scroll* o = new Fl_Scroll(10, 45, 107, 170);
      o->box(FL_FLAT_BOX);
      //
            for (int neff1 = 0; neff1 < NUM_SYS_EFX; neff1++)
                for (int neff2 = neff1 + 1; neff2 < NUM_SYS_EFX; neff2++)
      {
                syseffsend[neff1][neff2] =
                    new SysEffSend(o->x()+(neff2 - 1) * 35, o->y() + 20 + neff1 * 52, 30, 30);
                syseffsend[neff1][neff2]->label("aaa");
                syseffsend[neff1][neff2]->init(neff1, neff2, synth);
                syseffsend[neff1][neff2]->setValueType(VC_FXSysSend);
            }
      o->end();
    } // Fl_Scroll* o
    { Fl_Button* o = new Fl_Button(20, 220, 80, 25, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    { Fl_Box* o = new Fl_Box(5, 5, 110, 35, "Send system effect\'s output to other system effects");
      o->labelsize(10);
      o->align(Fl_Align(192));
    } // Fl_Box* o
    syseffsendwindow->end();
  } // Fl_Double_Window* syseffsendwindow
  { Fl_Double_Window* o = panelwindow = new Fl_Double_Window(550, 675, "Yoshimi Mixer Panel");
    panelwindow->labelfont(13);
    panelwindow->labelsize(13);
    panelwindow->user_data((void*)(this));
    { Fl_Pack* o = Panelpack1 = new Fl_Pack(8, 10, 533, 286);
      Panelpack1->type(1);
      //
          for (int i = 0; i < 8; i++)
          {
              panellistitem[i] = new Panellistitem(0, 0, 70, 260, "");
              panellistitem[i]->init(i, bankui, synth);
          }
      o->spacing(-3);
      Panelpack1->end();
    } // Fl_Pack* Panelpack1
    { Panelbox1 = new Fl_Box(-4, 316, 563, 7);
      Panelbox1->box(FL_THIN_DOWN_BOX);
      Panelbox1->deactivate();
    } // Fl_Box* Panelbox1
    { Fl_Pack* o = Panelpack2 = new Fl_Pack(8, 325, 533, 286);
      Panelpack2->type(1);
      //
            for (int i = 8; i < 16; i++)
            {
                 panellistitem[i] = new Panellistitem(0, 0, 70, 260, "");
                 panellistitem[i]->init(i, bankui, synth);
            }
      o->spacing(-3);
      Panelpack2->end();
    } // Fl_Pack* Panelpack2
    { PanelBox2 = new Fl_Box(-4, 632, 563, 7);
      PanelBox2->box(FL_THIN_DOWN_BOX);
      PanelBox2->deactivate();
    } // Fl_Box* PanelBox2
    { Panelclose = new Fl_Button(482, 645, 55, 25, "Close");
      Panelclose->box(FL_THIN_UP_BOX);
      Panelclose->labelsize(13);
      Panelclose->callback((Fl_Callback*)cb_Panelclose);
    } // Fl_Button* Panelclose
    { Fl_Button* o = new Fl_Button(356, 645, 116, 25, "Change to 1 x 16");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(13);
      o->callback((Fl_Callback*)cb_Change);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(821, 314, 116, 25, "Change to 2 x 8");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(13);
      o->callback((Fl_Callback*)cb_Change1);
    } // Fl_Button* o
    { Panelgroups = new Fl_Choice(12, 653, 86, 18, "Part Group");
      Panelgroups->down_box(FL_BORDER_BOX);
      Panelgroups->labelsize(12);
      Panelgroups->textsize(12);
      Panelgroups->callback((Fl_Callback*)cb_Panelgroups);
      Panelgroups->align(Fl_Align(FL_ALIGN_TOP));
      Panelgroups->menu(menu_Panelgroups);
    } // Fl_Choice* Panelgroups
    { Panelsmallgroups = new Fl_Choice(12, 653, 86, 18, "Part Group");
      Panelsmallgroups->down_box(FL_BORDER_BOX);
      Panelsmallgroups->labelsize(12);
      Panelsmallgroups->textsize(12);
      Panelsmallgroups->callback((Fl_Callback*)cb_Panelsmallgroups);
      Panelsmallgroups->align(Fl_Align(FL_ALIGN_TOP));
      Panelsmallgroups->menu(menu_Panelsmallgroups);
    } // Fl_Choice* Panelsmallgroups
    { Fl_Spinner* o = CSspinner = new Fl_Spinner(216, 653, 50, 18, "CC");
      CSspinner->labelsize(12);
      CSspinner->minimum(0);
      CSspinner->maximum(127);
      CSspinner->value(115);
      CSspinner->textsize(12);
      CSspinner->callback((Fl_Callback*)cb_CSspinner);
      CSspinner->align(Fl_Align(FL_ALIGN_TOP));
      CS_CC = synth->getRuntime().channelSwitchCC;
      if (CS_CC < 128) o->value(CS_CC); else o->value(115);
    } // Fl_Spinner* CSspinner
    { CSpend = new Fl_Button(276, 651, 70, 20, "Pending");
      CSpend->tooltip("Click to set");
      CSpend->box(FL_PLASTIC_UP_BOX);
      CSpend->color((Fl_Color)90);
      CSpend->labelsize(12);
      CSpend->callback((Fl_Callback*)cb_CSpend);
      CSpend->hide();
    } // Fl_Button* CSpend
    { Fl_Choice* o = channelswitch = new Fl_Choice(130, 653, 53, 18, "Solo");
      channelswitch->tooltip("Assign groups of parts to Ch 1, singly enabled by MIDI");
      channelswitch->down_box(FL_BORDER_BOX);
      channelswitch->labelsize(12);
      channelswitch->textsize(12);
      channelswitch->callback((Fl_Callback*)cb_channelswitch);
      channelswitch->align(Fl_Align(FL_ALIGN_TOP));
      channelswitch->menu(menu_channelswitch);
      o->value(synth->getRuntime().channelSwitchType);
      if (o->value() == 0) CSspinner->hide(); else CSspinner->show();
      CS_CC = o->value();
    } // Fl_Choice* channelswitch
    if (synth->getRuntime().single_row_panel) Panelbox1->hide();
    o->copy_label(synth->makeUniqueName("Mixer Panel").c_str());
    panelwindow->end();
  } // Fl_Double_Window* panelwindow
  return panelwindow;
}

void MasterUI::send_data(int control, float value, int type, int part , int engine , int insert , int parameter , int par2 ) {
  //
      if (parameter == 0)
      {
          collect_data(synth, 0, (Fl::event_button() | type), control, part, 0xff, 0xff, 0xff, 0xff, par2);
          return;
      }
      if (part == 0xff)
          part = 0xf0;
  
      collect_data(synth, value, (Fl::event_button() | type), control, part, 0xff, engine, insert, parameter, par2);
}

void MasterUI::returns_update(CommandBlock *getData) {
  //
      float value = getData->data.value;
      bool wasFromHere = getData->data.type & 0x20;
      unsigned char control = getData->data.control;
      unsigned char npart = getData->data.part;
      unsigned char engine = getData->data.engine;
      unsigned char insert = getData->data.insert;
      unsigned char par2 = getData->data.par2;
      int nval = lrint(value);
      if (npart == 0xf1)
      {
          if (insert == 16)
          {
              if (!wasFromHere)
                  syseffsend[engine][control]->value(value);
          }
          else
          {
              if (control == 0)
              {
                  syseffnocounter->value(engine + 1);
                  nsyseff = engine;
                  sysefftype->value(synth->sysefx[nsyseff]->geteffect());
                  syseffectui->refresh(synth->sysefx[nsyseff], 0xf1, nsyseff);
              }
              else if (control == 1)
              {
                  syseffnocounter->value(engine + 1);
                  nsyseff = engine;
                  sysefftype->value(nval);
                  syseffectui->refresh(synth->sysefx[nsyseff], 0xf1, nsyseff);
                  showSysEfxUI();
              }
          }
          return;
      }
      else if (npart == 0xf2)
      {
          if (control == 0)
          {
              ninseff = engine;
              setInsEff(ninseff);
          }
          else if (control == 1)
          {
              insefftype->value(nval);
              inseffectui->refresh(synth->insefx[nsyseff], 0xf1, ninseff);
              showInsEfxUI();
          }
          else if (control == 2)
          {
              inseffpart->value(nval + 2);
              if (value == -1)
                  insefftype->deactivate();
              else
                  insefftype->activate();
          }
          return;
      }
      string name;
  
      switch(control)
      {
          case 0:
              mastervolumedial->value(value);
              break;
  
          case 14:
              partuigroup->remove(partui);
              delete partui;
              partui = new PartUI(0, 0, 765, 525);
              partuigroup->add(partui);
              partui->init(synth->part[nval], nval, bankui);
              partui->redraw();
              npart = nval;
              npartcounter->value(nval + 1);
              npartcounter->redraw();
              updatepanel();
              break;
  
          case 15:
              partmax = nval;
              npartcounter->range(1, partmax);
              updatepart();
              updatepanel();
              setinspartlist();
              break;
  
          case 32:
              globalfinedetune->value(value);
              break;
  
          case 35:
              masterkeyshift->value(value);
              break;
  
          case 48:
          case 49:
              updatepanel();
              break;
  
          case 80:
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  setMasterLabel(findleafname(name));
                  refresh_master_ui(0);
              }
  
              break;
  
          case 81: // save patch set
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  setMasterLabel(findleafname(name));
                  RecentParams->activate();
                  updatepanel();
              }
              break;
  
          case 84: // load vector
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  vectorui->setLoadLabelRemote(insert, synth->getRuntime().vectordata.Name[insert]);
                  vectorui->recenthistory->activate();
                  refresh_master_ui(2);
              }
              break;
  
          case 85: // save vector
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
                  vectorui->recenthistory->activate();
              break;
  
          case 88: // load scales
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  microtonalui->Hide();
                  microtonalui->make_window();
              }
              break;
  
          case 89: // save scales
              name = miscMsgPop(par2);
              if (wasFromHere && name.find("FAILED") == 1)
                      fl_alert("%s",name.c_str());
              break;
  
          case 92: // load state
              name = miscMsgPop(par2);
              if (wasFromHere && name.find("FAILED") == 1)
                  fl_alert("%s",name.c_str());
              refresh_master_ui(0);
              break;
  
          case 93: // save state
              name = miscMsgPop(par2);
              if (wasFromHere && name.find("FAILED") == 1)
                  fl_alert("%s",name.c_str());
              break;
  
          case 96:
              if (npart == 240)
                  refresh_master_ui(1);
              else if (npart < 64)
                  partNew(npart);
              break;
  
          case 128:
              virkeyboard->relaseallkeys();
              vumeter->init(-1, synth);
              for(int i = 0; i < NUM_MIDI_CHANNELS; ++i)
              {
                  if(panelwindow)
                  {
                      if(panellistitem[i]->partVUMeter)
                      panellistitem[i]->partVUMeter->resetPart();
                  }
              }
              break;
      }
}

void MasterUI::updatesendwindow() {
  //
      for (int neff1 = 0; neff1 < NUM_SYS_EFX; ++neff1)
          for (int neff2 = neff1 + 1; neff2 < NUM_SYS_EFX; ++neff2)
              syseffsend[neff1][neff2]->value(synth->Psysefxsend[neff1][neff2]);
}

void MasterUI::updatelistitem(int part) {
  //
      int tmp = part % NUM_MIDI_CHANNELS;
      panellistitem[tmp]->refresh();
}

void MasterUI::updatepanel() {
  //
      for (int npart = 0; npart < partmax; ++npart)
      {
          if (npart < NUM_MIDI_CHANNELS)
              panellistitem[npart]->refresh();
          vectorui->setInstrumentLabel(npart);
      }
  
      if (synth->getRuntime().single_row_panel)
      {
              panelwindow->size(1085,345);
              Panelpack2->position(544,10);
              Panelclose->position(1018,314);
              Panelgroups->position(12,323);
              Panelsmallgroups->position(12,323);
              channelswitch->position(130,323);
              CSspinner->position(216,323);
              CSpend->position(276,321);
      }
      else
      {
              panelwindow->size(550,675);
              Panelpack2->position(8,325);
              Panelclose->position(482,645);
              Panelgroups->position(12,653);
              Panelsmallgroups->position(12,653);
              channelswitch->position(130,653);
              CSspinner->position(216,653);
              CSpend->position(276,651);
      }
  
      if (partmax == 64)
          Panelgroups->show();
      else
          Panelgroups->hide();
      if (partmax == 32)
          Panelsmallgroups->show();
      else
          Panelsmallgroups->hide();
  
      int oldswitch = channelswitch->value();
      channelswitch->value(synth->getRuntime().channelSwitchType);
      if (synth->getRuntime().channelSwitchType > 0)
      {
          if (oldswitch == 0)
          {
              CSspinner->value(115);
              CSpend->show();
          }
          else
          {
              CSspinner->value(synth->getRuntime().channelSwitchCC);
              CSpend->hide();
          }
          CSspinner->show();
      }
      else
      {
          synth->getRuntime().channelSwitchCC = 128;
          CSspinner->hide();
          CSpend->hide();
      }
      panelwindow->changed();
}

void MasterUI::partNew(int _npart) {
  //
      int nval = _npart;
      partuigroup->remove(partui);
      delete partui;
      partui = new PartUI(0, 0, 765, 525);
      partuigroup->add(partui);
      partui->init(synth->part[nval], nval, bankui);
      partui->redraw();
      npartcounter->value(nval + 1);
      npartcounter->redraw();
      npart = nval;
      updatepanel();
}

void MasterUI::updatepart() {
  //
      if (checkmaxparts())
      {
          npart = 0;
          npartcounter->value(npart + 1);
          npartcounter->do_callback();
          maxparts->value(partmax);
          maxparts->redraw();
          return;
      }
  
      if (synth->partonoffRead(npart))
          partui->partgroupui->activate();
      else
          partui->partgroupui->deactivate();
  
      partui->partGroupEnable->value(synth->partonoffRead(npart));
      partui->partpan->value(synth->part[npart]->Ppanning);
      partui->partvol->value(synth->part[npart]->Pvolume);
      partui->partkeylimit->value(synth->part[npart]->Pkeylimit);
      partui->velocitysense->value(synth->part[npart]->Pvelsns);
      partui->velocityoffset->value(synth->part[npart]->Pveloffs);
      partui->partkeyshift->value(synth->part[npart]->Pkeyshift - 64);
      partui->minkcounter->value(synth->part[npart]->Pminkey);
      partui->maxkcounter->value(synth->part[npart]->Pmaxkey);
      partui->enportamento->value(synth->part[npart]->ctl->portamento.portamento);
  
      if (synth->part[npart]->Ppolymode)
          partui->keymode->value(0);
      else
          partui->keymode->value(1);
      if (!synth->part[npart]->Ppolymode && synth->part[npart]->Plegatomode)
          partui->keymode->value(2);
  
      maxparts->value(partmax);
      maxparts->redraw();
      npartcounter->value(npart + 1);
      npartcounter->redraw();
      partui->checkEngines();
}

void MasterUI::updatepartprogram(int _npart) {
  //
      if (vectorui)
          vectorui->setInstrumentLabel(_npart);
      if (_npart != npart)
          return;
  
      if (partui->part->Prcvchn <  NUM_MIDI_CHANNELS)
      {
          partui->midich->value(partui->part->Prcvchn + 1);
          partui->midich->textcolor(FL_BLACK);
      }
      else
      {
           partui->midich->textcolor(FL_WHITE);
           partui->midich->redraw();
      }
      npartcounter->do_callback();
      updatepanel();
}

void MasterUI::updateeffects(int data) {
  //
      int partnum = data >> 24;
      int effclass = (data >> 22) & 3;
      int parameter = (data >> 8) & 0x7f;
  
      if (effclass == 2)
      {
           // will be part effects
      }
      else if (effclass == 1)
      {
          ninseff = parameter & 0x3f;
          sysinsgroup->value(InsertionEffectsGrp);
          showInsEfxUI();
          inseffnocounter->value(ninseff + 1);
          inseffpart->value(partnum);
          if (partnum != 1) // off
          {
              insefftype->activate();
              inseffectui->activate();
          }
          else
          {
              insefftype->deactivate();
              inseffectui->deactivate();
          }
          insefftype->value(synth->insefx[ninseff]->geteffect());
          inseffectui->refresh(synth->insefx[ninseff], 0xf2, ninseff);
      }
      else
      {
          nsyseff = parameter & 0x3f;
          sysinsgroup->value(SystemEffectsGrp);
          syseffnocounter->value(nsyseff + 1);
          sysefftype->value(synth->sysefx[nsyseff]->geteffect());
          syseffectui->refresh(synth->sysefx[nsyseff], 0xf1, nsyseff);
          showSysEfxUI();
      }
}

void MasterUI::updatecontrollers(int _npart) {
  //
      if (npart == _npart)
          partui->ctlmidirefresh();
}

void MasterUI::setMasterLabel(string name) {
  //
      string prefix;
      string panel;
      if  (name.size())
      {
          prefix = synth->makeUniqueName(name);
          panel = synth->makeUniqueName("Mixer Panel - "+name);
      }
      else
      {
          prefix = synth->makeUniqueName("");
          prefix = prefix.substr(0, prefix.length() - 3);
          panel = prefix + " : Mixer Panel";
      }
      masterwindow->copy_label(prefix.c_str());
      panelwindow->copy_label(panel.c_str());
      masterwindow->changed();
}

void MasterUI::do_load_scale(string fname) {
  //
      send_data(88, 0, 0xf0, 0xf0, 0xff, 0xff, 0x80, miscMsgPush(fname));
}

void MasterUI::do_load_master(bool updatehistory, const char* file) {
  //
      const char *fname;
      if (NULL != file)
          fname = file;
      else
      {
          fname = fl_file_chooser("Open:", "({*.xmz})", NULL, 0);
          if (fname == NULL)
              return;
      }
      send_data(80, 0, 0xf0, 240, 255, 255, 192, miscMsgPush(fname));
}

void MasterUI::do_save_master(const char* file ) {
  //
      const char *fname;
      bool result = false;
      if (file == NULL)
      {
          char *tmp = fl_file_chooser("Save:", "({*.xmz})", NULL, 0);
          if (tmp == NULL)
              return;
          tmp = fl_filename_setext(tmp, ".xmz");
          fname = tmp;
          result = isRegFile(tmp);
          if (result)
          {
              result = false;
              if (fl_choice("The file exists. Overwrite it?", NULL, "No", "Yes") < 2)
                  return;
          }
      }
      else
          fname = file;
      send_data(81, 0, 0xf0, 240, 255, 255, 128, miscMsgPush(string(fname)));
}

void MasterUI::refresh_master_ui(int type) {
  //
      if (microtonalui) // not taking chances!
          delete microtonalui;
      partmax = synth->getRuntime().NumAvailableParts;
      maxparts->value(partmax);
      checkmaxparts();
  
      npartcounter->value((synth->getRuntime().currentPart) + 1);
      int nval = synth->getRuntime().currentPart;
      synth->getRuntime().currentPart = nval;
      partNew(nval);
  
      nsyseff = 0;
      syseffnocounter->value(nsyseff + 1);
      sysefftype->value(synth->sysefx[nsyseff]->geteffect());
      syseffectui->refresh(synth->sysefx[nsyseff], 0xf1, nsyseff);
  
      ninseff = 0;
      inseffnocounter->value(nsyseff + 1);
      setInsEff(ninseff);
  
      sysinsgroup->value(SystemEffectsGrp);
      showSysEfxUI();
  
      masterkeyshift->value(synth->Pkeyshift - 64);
      mastervolumedial->value(synth->Pvolume);
      globalfinedetune->value(synth->microtonal.Pglobalfinedetune);
      microtonalui = new MicrotonalUI(&synth->microtonal, synth);
      if (type & 0x80)
          setMasterLabel(miscMsgPop((type >> 8) & 0xff));
      else
          setMasterLabel(findleafname(synth->lastPatchSetSeen()));
      updatesendwindow();
      updatepanel();
      if (!(type & 2))
          vectorui->RefreshChans();
      bankui->Hide();
      if (synth->getRuntime().toConsole == false)
          Reports->deactivate();
      else
          Reports->activate();
      if (type & 1)
          configui->update_config(4);
}

bool MasterUI::checkmaxparts() {
  //
      bool changed = false;
      if(panelgroup >= partmax)
      {
          panelgroup = 0;
          Panelgroups->value(0);
          Panelsmallgroups->value(0);
          changed = true;
      }
      npartcounter->range(1, partmax);
      if (npart >= partmax)
      {
          npartcounter->value(1);
          changed = true;
      }
      return changed;
}

void MasterUI::strategicRetreat(void) {
  fl_alert("Bad things happened,\nYoshimi strategically retreats.");
}

void MasterUI::Log(string msg) {
  yoshiLog->log(msg);
}

void MasterUI::showSysEfxUI(void) {
  //
      inseffectui->hide();
      inseffectui->deactivate();
      inseffectuigroup->hide();
      inseffectuigroup->deactivate();
  
      syseffectui->activate();
      syseffectui->show();
      syseffectuigroup->activate();
      syseffectuigroup->show();
}

void MasterUI::showInsEfxUI(void) {
  //
      syseffectui->hide();
      syseffectui->deactivate();
      syseffectuigroup->hide();
      syseffectuigroup->deactivate();
  
      inseffectui->activate();
      inseffectui->show();
      inseffectuigroup->activate();
      inseffectuigroup->show();
}

void MasterUI::setinspartlist() {
  //
      inseffpart->clear();
      inseffpart->add("Master Out");
      inseffpart->add("Off");
      int size = synth->getRuntime().NumAvailableParts;
      for (int i = 0; i < size; ++i)
      {
          string num = string("00") + asString(i + 1);
          inseffpart->add((string("Part ") + asString(i + 1)).c_str());
      }
      int current = synth->Pinsparts[ninseff];
      if (current >= size)
      {
          current = -1; // off is safe
          synth->Pinsparts[ninseff] = current;
      }
      inseffpart->value(current + 2);
}

PresetsUI * MasterUI::getPresetsUi() {
  //
      return presetsui;
}

void MasterUI::resetPartsClip() {
  //
      for (int i = 0; i < NUM_MIDI_CHANNELS; i++)
      {
          if(panellistitem[i] && panellistitem[i]->partVUMeter)
          {
              panellistitem[i]->partVUMeter->resetPart(true);
          }
      }
}

void MasterUI::setInsEff(int effnum) {
  //
      int ninseff = effnum;
      insefftype->value(synth->insefx[ninseff]->geteffect());
      inseffpart->value(synth->Pinsparts[ninseff] + 2);
      inseffectui->refresh(synth->insefx[ninseff], 0xf2, ninseff);
      if (synth->Pinsparts[ninseff] != -1)
      {
          insefftype->activate();
          inseffectui->activate();
          inseffectuigroup->activate();
      }
      else
      {
          insefftype->deactivate();
          inseffectui->deactivate();
          inseffectuigroup->deactivate();
      }
}

void MasterUI::setState(string filename) {
  //
      send_data(92, 0, 0xf0, 0xf0, 0xff, 0xff, 0xc0, miscMsgPush(filename));
}

string MasterUI::setPartWindowTitle(string prefix) {
  //
      string extension = " - Part " + asString(partui->npart + 1) + " " + partui->part->Pname;
      if (partui->part->Pkitmode)
          extension += ", Kit ";
      return synth->makeUniqueName(prefix + extension);
}

void MasterUI::setPartActive(int _npart, bool active) {
  //
      if (_npart == npart)
      {
          partui->partGroupEnable->value(active);
          if (active)
          {
              partui->partgroupui->activate();
              partui->toSysEfx->activate();
          }
          else
          {
              partui->partgroupui->deactivate();
              partui->toSysEfx->deactivate();
          }
      }
}

void MasterUI::setPartVolWidget(int _npart, float _value) {
  //
      if (_npart == npart)
          partui->partvol->value(_value);
}

void MasterUI::setPartPanWidget(int _npart, float _value) {
  //
      if (_npart == npart)
          partui->partpan->value(_value);
}

void MasterUI::setPanelPartVolWidget(int _npart, float _value) {
  //
      panellistitem[_npart]->partvolume->value(_value);
}

void MasterUI::setPanelPartPanWidget(int _npart, float _value) {
  //
      panellistitem[_npart]->partpanning->value(_value);
}

void MasterUI::setPartMidiWidget(int _npart, unsigned char _value) {
  //
      if (_npart == npart)
          partui->midich->value(_value);
      partui->midich->textcolor(FL_BLACK);
}

void MasterUI::setPanelPartMidiWidget(int _npart, unsigned char _value) {
  //
      panellistitem[_npart]->partrcv->value(_value);
      panellistitem[_npart]->partrcv->textcolor(FL_BLACK);
      panellistitem[_npart]->partrcv->redraw();
}

void MasterUI::setPanelPartLabel(int _npart, int _engine) {
  //
      panellistitem[_npart % NUM_MIDI_CHANNELS]->setPartLabel(_engine);
}

void MasterUI::setLogging(bool isConsole) {
  //
      if (isConsole)
      {
          Reports->activate();
          yoshiLog->Show();
      }
      else
      {
          Reports->deactivate();
          yoshiLog->Hide();
      }
}

void MasterUI::showInstrumentEditWindow(int _npart) {
  //
      if (_npart == npart)
          partui->instrumenteditwindow->show();
}

void MasterUI::updateBankRootDirs() {
  bankui->readbankcfg();
}

void MasterUI::updatepaths(int type) {
  //
      if (type == 0)
      {
          bankui->readbankcfg();
          bankui-> rescan_for_banks(false);
      }
}

void MasterUI::ShowAlert(int num) {
  fl_alert("%s", miscMsgPop(num).c_str());
}

SynthEngine * MasterUI::getSynth() {
  return synth;
}

void MasterUI::loadWindowData() {
  //
  
      bool ok = false;
      bool tmpWindows;
      int masterX;
      int masterY;
      int masterO;
  
      windows = fopen(filename.c_str(), "r");
      if (windows == NULL)
          NewWindows = true;
      else
          NewWindows = false;
      ok = !NewWindows;
      tmpWindows = NewWindows;
      // we carry on anyway to set defaults
      ok = getData(ok,
                  "master",
                   masterX,
                   masterY,
                   masterO);
      ok = getData(ok,
                  "panel",
                   panelX,
                   panelY,
                   panelO);
      ok = getData(ok,
                  "instruments",
                   instrumentsX,
                   instrumentsY,
                   instrumentsO);
      ok = getData(ok,
                  "banks",
                   banksX,
                   banksY,
                   banksO);
      ok = getData(ok,
                  "roots",
                   rootsX,
                   rootsY,
                   rootsO);
      ok = getData(ok,
                  "presets",
                   presetsX,
                   presetsY,
                   presetsO);
      ok = getData(ok,
                  "scales",
                   scalesX,
                   scalesY,
                   scalesO);
      if (NewWindows)
      {
           NewWindows = false;
           virkbdX = 400;
           virkbdY = 1;
           virkbdO = 1;
      }
      ok = getData(ok,
                  "virtkeybd",
                   virkbdX,
                   virkbdY,
                   virkbdO);
      NewWindows = tmpWindows;
      ok = getData(ok,
                  "settings",
                   settingsX,
                   settingsY,
                   settingsO);
      ok = getData(ok,
                  "yoshiLog",
                   yoshiLogX,
                   yoshiLogY,
                   yoshiLogO);
      ok = getData(ok,
                  "vectors",
                   vectorX,
                   vectorY,
                   vectorO);
      ok = getData(ok,
                  "MIDIlearn",
                   mlearnX,
                   mlearnY,
                   mlearnO);
      ok = getData(ok,
                  "controllers",
                   controllersX,
                   controllersY,
                   controllersO);
      ok = getData(ok,
                  "midicontrols",
                   midictlX,
                   midictlY,
                   midictlO);
      ok = getData(ok,
                  "instrumentedit",
                   inseditX,
                   inseditY,
                   inseditO);
      ok = getData(ok,
                  "kitlist",
                   kitlistX,
                   kitlistY,
                   kitlistO);
      ok = getData(ok,
                  "partFX",
                   partfxX,
                   partfxY,
                   partfxO);
  
      ok = getData(ok,
                  "SUBnote",
                   subNoteX,
                   subNoteY,
                   subNoteO);
      ok = getData(ok,
                  "PADnote",
                   padNoteX,
                   padNoteY,
                   padNoteO);
      ok = getData(ok,
                  "ADDnote",
                   addNoteX,
                   addNoteY,
                   addNoteO);
  
     if (windows != NULL)
          fclose(windows);
  
      masterwindow->position(masterX, masterY);
      panelwindow->position(panelX, panelY);
      bankui->instrumentuiwindow->position(instrumentsX, instrumentsY);
      bankui->bankuiwindow->position(banksX, banksY);
      bankui->rootuiwindow->position(rootsX, rootsY);
      configui->presets->position(presetsX, presetsY);
      microtonalui->microtonaluiwindow->position(scalesX, scalesY);
      virkeyboard->virkeyboardwindow->position(virkbdX, virkbdY);
      configui->configwindow->position(settingsX, settingsY);
      yoshiLog->logConsole->position(yoshiLogX, yoshiLogY);
      vectorui->vectorwindow->position(vectorX, vectorY);
      midilearnui->midilearnwindow->position(mlearnX, mlearnY);
      partui->ctlwindow->position(controllersX, controllersY);
      partui->ctlmidi->position(midictlX, midictlY);
      partui->instrumenteditwindow->position(inseditX, inseditY);
      partui->instrumentkitlist->position(kitlistX, kitlistY);
      partui->partfx->position(partfxX, partfxY);
}

void MasterUI::saveWindowData() {
  //
      windows = fopen(filename.c_str(), "w");
  
      putData("master",
               masterwindow->x(),
               masterwindow->y(),
               masterwindow->visible());
      putData("panel",
               panelwindow->x(),
               panelwindow->y(),
               panelwindow->visible());
      putData("instruments",
               bankui->instrumentuiwindow->x(),
               bankui->instrumentuiwindow->y(),
               bankui->instrumentuiwindow->visible());
      putData("banks",
               bankui->bankuiwindow->x(),
               bankui->bankuiwindow->y(),
               bankui->bankuiwindow->visible());
      putData("roots",
               bankui->rootuiwindow->x(),
               bankui->rootuiwindow->y(),
               bankui->rootuiwindow->visible());
      putData("presets",
               configui->presets->x(),
               configui->presets->y(),
               configui->presets->visible());
      putData("scales",
               microtonalui->microtonaluiwindow->x(),
               microtonalui->microtonaluiwindow->y(),
               microtonalui->microtonaluiwindow->visible());
      putData("virtkeybd",
               virkeyboard->virkeyboardwindow->x(),
               virkeyboard->virkeyboardwindow->y(),
               virkeyboard->virkeyboardwindow->visible());
      putData("settings",
               configui->configwindow->x(),
               configui->configwindow->y(),
               configui->configwindow->visible());
      putData("yoshiLog",
               yoshiLog->logConsole->x(),
               yoshiLog->logConsole->y(),
               yoshiLog->logConsole->visible());
      putData("vectors",
               vectorui->vectorwindow->x(),
               vectorui->vectorwindow->y(),
               vectorui->vectorwindow->visible());
      putData("MIDIlearn",
               midilearnui->midilearnwindow->x(),
               midilearnui->midilearnwindow->y(),
               midilearnui->midilearnwindow->visible());
  
      if (partui->ctlwindow->x())
          putData("controllers",
                   partui->ctlwindow->x(),
                   partui->ctlwindow->y(),
                   partui->ctlwindow->visible());
      else // no window so store previous values
          putData("controllers",
                   controllersX,
                   controllersY,
                   controllersO);
  
      if (partui->ctlwindow->x())
          putData("midcontrols",
                   partui->ctlmidi->x(),
                   partui->ctlmidi->y(),
                   partui->ctlmidi->visible());
      else // no window so store previous values
          putData("controllers",
                   midictlX,
                   midictlY,
                   midictlO);
  
      if (partui->instrumenteditwindow->x())
          putData("instrumentedit",
                   partui->instrumenteditwindow->x(),
                   partui->instrumenteditwindow->y(),
                   partui->instrumenteditwindow->visible());
      else
          putData("instrumentedit",
                   inseditX,
                   inseditY,
                   inseditO);
  
      if (partui->instrumentkitlist->x())
          putData("kitlist",
                   partui->instrumentkitlist->x(),
                   partui->instrumentkitlist->y(),
                   partui->instrumentkitlist->visible());
      else
          putData("kitlist",
                   kitlistX,
                   kitlistY,
                   kitlistO);
  
      if(partui->partfx->x())
          putData("partFX",
                   partui->partfx->x(),
                   partui->partfx->y(),
                   partui->partfx->visible());
      else
          putData("partFX",
                   partfxX,
                   partfxY,
                   partfxO);
  
      putData("SUBnote",
               subNoteX,
               subNoteY,
               subNoteO);
      putData("PADnote",
               padNoteX,
               padNoteY,
               padNoteO);
      putData("ADDnote",
               addNoteX,
               addNoteY,
               addNoteO);
  
     fclose(windows);
}

bool MasterUI::getData(bool ok, string name, int& X, int& Y, int& O) {
  //
      if (NewWindows)
      {
          X = 1;
          Y = 1;
          O = 0;
      }
      if (!ok)
          return false;
  
      ok = (fgets(word, 20, windows) != NULL);
      if (ok)
          ok = strstr(word, name.c_str());
      if (true)
      {
          ok = false;
          if (fgets(word, 20, windows) != NULL)
              X = atoi(word);
          if (fgets(word, 20, windows) != NULL)
              Y = atoi(word);
          if (fgets(word, 20, windows) != NULL)
          {
              O = atoi(word);
              ok = true;
          }
      }
      return ok;
}

void MasterUI::putData(string name, int X, int Y, int O) {
  //
      string tosend = name + "\n"
                    + asString(X)+ "\n"
                    + asString(Y) + "\n"
                    + asString(O) + "\n";
      fputs(tosend.c_str(), windows);
}
