// MicrotonalUI.h
// generated by Fast Light User Interface Designer (fluid) version 1.0304

#ifndef MicrotonalUI_h
#define MicrotonalUI_h
#include <FL/Fl.H>
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009, Alan Calvert
// Copyright 2016-2017, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is a derivative of the ZynAddSubFX original.

// Modified June 2017

#include <FL/Fl_File_Chooser.H>
#include <FL/fl_ask.H>
#include "Misc/Microtonal.h"
#include "UI/MiscGui.h"
    #include "EffUI.h"
    #include "BankUI.h"
    #include "ADnoteUI.h"
    #include "SUBnoteUI.h"
    #include "PADnoteUI.h"
    #include "UI/WidgetMWSlider.h"
    #include "Params/Controller.h"
    #include "Misc/MiscFuncs.h"
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Spinner.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Value_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Return_Button.H>

class MicrotonalUI : private MiscFuncs {
public:
  Fl_Double_Window* make_window();
  Fl_Double_Window *microtonaluiwindow;
  Fl_Check_Button *invertKeys;
private:
  inline void cb_invertKeys_i(Fl_Check_Button*, void*);
  static void cb_invertKeys(Fl_Check_Button*, void*);
public:
  Fl_Spinner *centerinvertcounter;
private:
  inline void cb_centerinvertcounter_i(Fl_Spinner*, void*);
  static void cb_centerinvertcounter(Fl_Spinner*, void*);
public:
  Fl_Group *microtonalgroup;
  Fl_Input *nameinput;
private:
  inline void cb_nameinput_i(Fl_Input*, void*);
  static void cb_nameinput(Fl_Input*, void*);
public:
  Fl_Input *commentinput;
private:
  inline void cb_commentinput_i(Fl_Input*, void*);
  static void cb_commentinput(Fl_Input*, void*);
public:
  Fl_Spinner *scaleShift;
private:
  inline void cb_scaleShift_i(Fl_Spinner*, void*);
  static void cb_scaleShift(Fl_Spinner*, void*);
public:
  Fl_Group *Tuning;
  Fl_Input *tuningsinput;
  Fl_Value_Output *octavesizeoutput;
private:
  inline void cb_octavesizeoutput_i(Fl_Value_Output*, void*);
  static void cb_octavesizeoutput(Fl_Value_Output*, void*);
  inline void cb_Import_i(Fl_Button*, void*);
  static void cb_Import(Fl_Button*, void*);
public:
  Fl_Group *keymappinggroup;
  Fl_Input *mappinginput;
  Fl_Spinner *firstnotecounter;
private:
  inline void cb_firstnotecounter_i(Fl_Spinner*, void*);
  static void cb_firstnotecounter(Fl_Spinner*, void*);
public:
  Fl_Spinner *middlenotecounter;
private:
  inline void cb_middlenotecounter_i(Fl_Spinner*, void*);
  static void cb_middlenotecounter(Fl_Spinner*, void*);
public:
  Fl_Spinner *lastnotecounter;
private:
  inline void cb_lastnotecounter_i(Fl_Spinner*, void*);
  static void cb_lastnotecounter(Fl_Spinner*, void*);
public:
  Fl_Value_Output *mapsizeoutput;
private:
  inline void cb_mapsizeoutput_i(Fl_Value_Output*, void*);
  static void cb_mapsizeoutput(Fl_Value_Output*, void*);
  inline void cb_Import1_i(Fl_Button*, void*);
  static void cb_Import1(Fl_Button*, void*);
public:
  Fl_Check_Button *mappingenabledbutton;
private:
  inline void cb_mappingenabledbutton_i(Fl_Check_Button*, void*);
  static void cb_mappingenabledbutton(Fl_Check_Button*, void*);
public:
  Fl_Button *applybutton;
private:
  inline void cb_applybutton_i(Fl_Button*, void*);
  static void cb_applybutton(Fl_Button*, void*);
public:
  Fl_Spinner *anotecounter;
private:
  inline void cb_anotecounter_i(Fl_Spinner*, void*);
  static void cb_anotecounter(Fl_Spinner*, void*);
public:
  Fl_Value_Input *afreqinput;
private:
  inline void cb_afreqinput_i(Fl_Value_Input*, void*);
  static void cb_afreqinput(Fl_Value_Input*, void*);
public:
  Fl_Button *AsetBack;
private:
  inline void cb_AsetBack_i(Fl_Button*, void*);
  static void cb_AsetBack(Fl_Button*, void*);
public:
  Fl_Return_Button *afreqset;
private:
  inline void cb_afreqset_i(Fl_Return_Button*, void*);
  static void cb_afreqset(Fl_Return_Button*, void*);
public:
  Fl_Check_Button *enableMicrotonal;
private:
  inline void cb_enableMicrotonal_i(Fl_Check_Button*, void*);
  static void cb_enableMicrotonal(Fl_Check_Button*, void*);
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
public:
  void send_data(int control, float value, int type, int par = 0xff, int par2 = 0xff);
  void returns_update(CommandBlock *getData);
  void updateTuningsInput();
  void updateMappingInput();
  MicrotonalUI(Microtonal *microtonal_, SynthEngine *synth_);
  ~MicrotonalUI();
  void Show();
  void Hide();
  void apply();
  void checkInvert();
  void errors(int value, bool type);
private:
  Microtonal *microtonal; 
  string winlabel; 
  SynthEngine *synth; 
  float Afreq; 
  int oldFirst; 
  int oldMid; 
  int oldLast; 
};
#endif
