// MidiLearnUI.h
// generated by Fast Light User Interface Designer (fluid) version 1.0304

#ifndef MidiLearnUI_h
#define MidiLearnUI_h
#include <FL/Fl.H>
// Copyright (C) 2016-2017, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// Modified September 2017
using namespace std;
#include "UI/MiscGui.h"
    #include "EffUI.h"
    #include "BankUI.h"
    #include "ADnoteUI.h"
    #include "SUBnoteUI.h"
    #include "PADnoteUI.h"
    #include "UI/WidgetMWSlider.h"
    #include "Params/Controller.h"
    #include "Misc/MiscFuncs.h"
#include <FL/Fl_Group.H>
#include <FL/Fl_Spinner.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Light_Button.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Check_Button.H>

class MidiLearnKitItem : public Fl_Group {
public:
  Fl_Group* make_window();
  Fl_Group *midilearnkititem;
  Fl_Group *midilearnkititemgroup;
  Fl_Spinner *CCcounter;
private:
  inline void cb_CCcounter_i(Fl_Spinner*, void*);
  static void cb_CCcounter(Fl_Spinner*, void*);
  inline void cb__i(Fl_Button*, void*);
  static void cb_(Fl_Button*, void*);
public:
  Fl_Button *nrpn;
  Fl_Light_Button *sevenbit;
private:
  inline void cb_sevenbit_i(Fl_Light_Button*, void*);
  static void cb_sevenbit(Fl_Light_Button*, void*);
public:
  Fl_Choice *channelchoice;
private:
  inline void cb_channelchoice_i(Fl_Choice*, void*);
  static void cb_channelchoice(Fl_Choice*, void*);
  static Fl_Menu_Item menu_channelchoice[];
public:
  Fl_Check_Button *compresscheck;
private:
  inline void cb_compresscheck_i(Fl_Check_Button*, void*);
  static void cb_compresscheck(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *blockcheck;
private:
  inline void cb_blockcheck_i(Fl_Check_Button*, void*);
  static void cb_blockcheck(Fl_Check_Button*, void*);
public:
  Fl_Light_Button *activity;
private:
  inline void cb_activity_i(Fl_Light_Button*, void*);
  static void cb_activity(Fl_Light_Button*, void*);
public:
  Fl_Spinner *minval;
private:
  inline void cb_minval_i(Fl_Spinner*, void*);
  static void cb_minval(Fl_Spinner*, void*);
  inline void cb_1_i(Fl_Button*, void*);
  static void cb_1(Fl_Button*, void*);
public:
  Fl_Spinner *maxval;
private:
  inline void cb_maxval_i(Fl_Spinner*, void*);
  static void cb_maxval(Fl_Spinner*, void*);
  inline void cb_2_i(Fl_Button*, void*);
  static void cb_2(Fl_Button*, void*);
public:
  Fl_Button *commandName;
private:
  inline void cb_commandName_i(Fl_Button*, void*);
  static void cb_commandName(Fl_Button*, void*);
public:
  Fl_Check_Button *mutecheck;
private:
  inline void cb_mutecheck_i(Fl_Check_Button*, void*);
  static void cb_mutecheck(Fl_Check_Button*, void*);
public:
  void send_data(int control);
  MidiLearnKitItem(int x,int y, int w, int h, const char *label=0);
  ~MidiLearnKitItem();
  void init(SynthEngine *synth_, int n_);
private:
  int n; 
  char label[50]; 
  SynthEngine *synth; 
public:
  unsigned char stat; 
};
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Box.H>

class MidiLearnUI : private MiscFuncs {
public:
  Fl_Double_Window* make_window();
  Fl_Double_Window *midilearnwindow;
  Fl_Scroll *kitlist;
  Fl_Box *none;
private:
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
public:
  Fl_Button *load;
private:
  inline void cb_load_i(Fl_Button*, void*);
  static void cb_load(Fl_Button*, void*);
public:
  Fl_Button *save;
private:
  inline void cb_save_i(Fl_Button*, void*);
  static void cb_save(Fl_Button*, void*);
public:
  Fl_Button *clear;
private:
  inline void cb_clear_i(Fl_Button*, void*);
  static void cb_clear(Fl_Button*, void*);
public:
  Fl_Button *recent;
private:
  inline void cb_recent_i(Fl_Button*, void*);
  static void cb_recent(Fl_Button*, void*);
public:
  Fl_Double_Window *message;
  Fl_Box *words;
private:
  inline void cb_Close1_i(Fl_Button*, void*);
  static void cb_Close1(Fl_Button*, void*);
public:
  Fl_Button *cancel;
private:
  inline void cb_cancel_i(Fl_Button*, void*);
  static void cb_cancel(Fl_Button*, void*);
public:
  void send_data(int control, float value, int type, int kititem = 0xff, int engine = 0xff, int insert = 0xff, int parameter = 0xff, int par2 = 0xff);
  void returns_update(CommandBlock *getData);
  void addLine(CommandBlock *getData);
  MidiLearnUI(SynthEngine *_synth);
  ~MidiLearnUI();
  void Show();
  void Hide();
  void clearAll(bool empty);
  void loadMidi(string file);
  void setWindowTitle(string name = "");
  int lastkititem; 
private:
  SynthEngine *synth; 
  MidiLearnKitItem *midilearnkititem[MIDI_LEARN_BLOCK]; 
  int num; 
};
#endif
