// PartUI.h
// generated by Fast Light User Interface Designer (fluid) version 1.0304

#ifndef PartUI_h
#define PartUI_h
#include <FL/Fl.H>
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2017, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code.

// Modified October 2017

#include "UI/MiscGui.h"
    #include "EffUI.h"
    #include "BankUI.h"
    #include "ADnoteUI.h"
    #include "SUBnoteUI.h"
    #include "PADnoteUI.h"
    #include "UI/WidgetMWSlider.h"
    #include "Params/Controller.h"
    #include "Misc/MiscFuncs.h"
#include "Misc/Part.h"
    #define MAX_INFO_TEXT_SIZE 256

class PartSysEffSend : public Fl_Group, private MiscFuncs {
public:
  Fl_Group* make_window();
  Fl_Group *syseffsend;
  WidgetPDial *sysend;
private:
  inline void cb_sysend_i(WidgetPDial*, void*);
  static void cb_sysend(WidgetPDial*, void*);
public:
  PartSysEffSend(int x, int y, int w, int h) ;
  void send_data(int control, float value, int type);
  void init(int npart_, int neff_, SynthEngine *_synth);
  ~PartSysEffSend();
private:
  int neff; 
  int npart; 
  SynthEngine *synth; 
};

class PartUI_ {
public:
  virtual void showparameters(int kititem,int engine);
};
#include <FL/Fl_Group.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Choice.H>

class PartKitItem : public Fl_Group {
public:
  Fl_Group* make_window();
  Fl_Group *partkititem;
  Fl_Group *partkititemgroup;
  Fl_Check_Button *mutedcheck;
private:
  inline void cb_mutedcheck_i(Fl_Check_Button*, void*);
  static void cb_mutedcheck(Fl_Check_Button*, void*);
public:
  Fl_Button *labelbutton;
private:
  inline void cb_labelbutton_i(Fl_Button*, void*);
  static void cb_labelbutton(Fl_Button*, void*);
public:
  Fl_Counter *minkcounter;
private:
  inline void cb_minkcounter_i(Fl_Counter*, void*);
  static void cb_minkcounter(Fl_Counter*, void*);
  inline void cb_m_i(Fl_Button*, void*);
  static void cb_m(Fl_Button*, void*);
  inline void cb_M_i(Fl_Button*, void*);
  static void cb_M(Fl_Button*, void*);
  inline void cb_R_i(Fl_Button*, void*);
  static void cb_R(Fl_Button*, void*);
public:
  Fl_Counter *maxkcounter;
private:
  inline void cb_maxkcounter_i(Fl_Counter*, void*);
  static void cb_maxkcounter(Fl_Counter*, void*);
public:
  Fl_Button *adeditbutton;
private:
  inline void cb_adeditbutton_i(Fl_Button*, void*);
  static void cb_adeditbutton(Fl_Button*, void*);
public:
  Fl_Check_Button *adcheck;
private:
  inline void cb_adcheck_i(Fl_Check_Button*, void*);
  static void cb_adcheck(Fl_Check_Button*, void*);
public:
  Fl_Button *subeditbutton;
private:
  inline void cb_subeditbutton_i(Fl_Button*, void*);
  static void cb_subeditbutton(Fl_Button*, void*);
public:
  Fl_Check_Button *subcheck;
private:
  inline void cb_subcheck_i(Fl_Check_Button*, void*);
  static void cb_subcheck(Fl_Check_Button*, void*);
public:
  Fl_Button *padeditbutton;
private:
  inline void cb_padeditbutton_i(Fl_Button*, void*);
  static void cb_padeditbutton(Fl_Button*, void*);
public:
  Fl_Check_Button *padcheck;
private:
  inline void cb_padcheck_i(Fl_Check_Button*, void*);
  static void cb_padcheck(Fl_Check_Button*, void*);
public:
  Fl_Choice *sendtoeffect;
private:
  inline void cb_sendtoeffect_i(Fl_Choice*, void*);
  static void cb_sendtoeffect(Fl_Choice*, void*);
public:
  Fl_Check_Button *enabledcheck;
private:
  inline void cb_enabledcheck_i(Fl_Check_Button*, void*);
  static void cb_enabledcheck(Fl_Check_Button*, void*);
public:
  void send_data(int control, float value, int type, int kititem = 0xff, int engine = 0xff, int insert = 0xff);
  PartKitItem(int x,int y, int w, int h, const char *label=0);
  void clearLine();
  void init(Part *part_, int n_, int npart_, PartUI_ *partui_);
  ~PartKitItem();
  Part *part; 
private:
  int n; 
  int npart; 
  char label[10]; 
  PartUI_ *partui; 
  SynthEngine *synth; 
};
#include <FL/Fl_Box.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Spinner.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Pack.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Input.H>

class PartUI : public Fl_Group, PartUI_, private MiscFuncs {
public:
  Fl_Group* make_window();
  Fl_Group *partgroup;
  Fl_Group *partgroupui;
  Fl_Box *instrumentaddbox;
  Fl_Box *instrumentsubbox;
  Fl_Box *instrumentpadbox;
  Fl_Text_Display *instrumentlabel;
  Fl_Button *instrumentlab;
private:
  inline void cb_instrumentlab_i(Fl_Button*, void*);
  static void cb_instrumentlab(Fl_Button*, void*);
  inline void cb_Edit_i(Fl_Button*, void*);
  static void cb_Edit(Fl_Button*, void*);
public:
  WidgetPDial *velocitysense;
private:
  inline void cb_velocitysense_i(WidgetPDial*, void*);
  static void cb_velocitysense(WidgetPDial*, void*);
public:
  WidgetPDial *velocityoffset;
private:
  inline void cb_velocityoffset_i(WidgetPDial*, void*);
  static void cb_velocityoffset(WidgetPDial*, void*);
public:
  WidgetPDial *partpan;
private:
  inline void cb_partpan_i(WidgetPDial*, void*);
  static void cb_partpan(WidgetPDial*, void*);
public:
  WidgetPDial *partvol;
private:
  inline void cb_partvol_i(WidgetPDial*, void*);
  static void cb_partvol(WidgetPDial*, void*);
public:
  Fl_Check_Button *enportamento;
private:
  inline void cb_enportamento_i(Fl_Check_Button*, void*);
  static void cb_enportamento(Fl_Check_Button*, void*);
public:
  Fl_Spinner *midich;
private:
  inline void cb_midich_i(Fl_Spinner*, void*);
  static void cb_midich(Fl_Spinner*, void*);
public:
  Fl_Choice *keymode;
private:
  inline void cb_keymode_i(Fl_Choice*, void*);
  static void cb_keymode(Fl_Choice*, void*);
  inline void cb_Controllers_i(Fl_Button*, void*);
  static void cb_Controllers(Fl_Button*, void*);
public:
  Fl_Spinner *partkeyshift;
private:
  inline void cb_partkeyshift_i(Fl_Spinner*, void*);
  static void cb_partkeyshift(Fl_Spinner*, void*);
public:
  Fl_Spinner *partkeylimit;
private:
  inline void cb_partkeylimit_i(Fl_Spinner*, void*);
  static void cb_partkeylimit(Fl_Spinner*, void*);
public:
  Fl_Spinner *minkcounter;
private:
  inline void cb_minkcounter1_i(Fl_Spinner*, void*);
  static void cb_minkcounter1(Fl_Spinner*, void*);
public:
  Fl_Spinner *maxkcounter;
private:
  inline void cb_maxkcounter1_i(Fl_Spinner*, void*);
  static void cb_maxkcounter1(Fl_Spinner*, void*);
  inline void cb_Set_i(Fl_Button*, void*);
  static void cb_Set(Fl_Button*, void*);
  inline void cb_R1_i(Fl_Button*, void*);
  static void cb_R1(Fl_Button*, void*);
  inline void cb_Set1_i(Fl_Button*, void*);
  static void cb_Set1(Fl_Button*, void*);
public:
  Fl_Check_Button *partGroupEnable;
private:
  inline void cb_partGroupEnable_i(Fl_Check_Button*, void*);
  static void cb_partGroupEnable(Fl_Check_Button*, void*);
public:
  Fl_Scroll *toSysEfx;
  Fl_Double_Window *ctlwindow;
  WidgetPDial *volrng;
private:
  inline void cb_volrng_i(WidgetPDial*, void*);
  static void cb_volrng(WidgetPDial*, void*);
public:
  Fl_Check_Button *vol;
private:
  inline void cb_vol_i(Fl_Check_Button*, void*);
  static void cb_vol(Fl_Check_Button*, void*);
public:
  WidgetPDial *panwidth;
private:
  inline void cb_panwidth_i(WidgetPDial*, void*);
  static void cb_panwidth(WidgetPDial*, void*);
public:
  WidgetPDial *modwh;
private:
  inline void cb_modwh_i(WidgetPDial*, void*);
  static void cb_modwh(WidgetPDial*, void*);
public:
  Fl_Check_Button *expmwh;
private:
  inline void cb_expmwh_i(Fl_Check_Button*, void*);
  static void cb_expmwh(Fl_Check_Button*, void*);
public:
  WidgetPDial *bwdpth;
private:
  inline void cb_bwdpth_i(WidgetPDial*, void*);
  static void cb_bwdpth(WidgetPDial*, void*);
public:
  Fl_Check_Button *expbw;
private:
  inline void cb_expbw_i(Fl_Check_Button*, void*);
  static void cb_expbw(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *expr;
private:
  inline void cb_expr_i(Fl_Check_Button*, void*);
  static void cb_expr(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *fmamp;
private:
  inline void cb_fmamp_i(Fl_Check_Button*, void*);
  static void cb_fmamp(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *sustain;
private:
  inline void cb_sustain_i(Fl_Check_Button*, void*);
  static void cb_sustain(Fl_Check_Button*, void*);
public:
  Fl_Counter *pwheelbrng;
private:
  inline void cb_pwheelbrng_i(Fl_Counter*, void*);
  static void cb_pwheelbrng(Fl_Counter*, void*);
public:
  WidgetPDial *filtq;
private:
  inline void cb_filtq_i(WidgetPDial*, void*);
  static void cb_filtq(WidgetPDial*, void*);
public:
  WidgetPDial *fltcut;
private:
  inline void cb_fltcut_i(WidgetPDial*, void*);
  static void cb_fltcut(WidgetPDial*, void*);
  inline void cb_Close_i(Fl_Button*, void*);
  static void cb_Close(Fl_Button*, void*);
  inline void cb_Reset_i(Fl_Button*, void*);
  static void cb_Reset(Fl_Button*, void*);
public:
  WidgetPDial *cfdpth;
private:
  inline void cb_cfdpth_i(WidgetPDial*, void*);
  static void cb_cfdpth(WidgetPDial*, void*);
public:
  WidgetPDial *rbwdpth;
private:
  inline void cb_rbwdpth_i(WidgetPDial*, void*);
  static void cb_rbwdpth(WidgetPDial*, void*);
public:
  WidgetPDial *prtime;
private:
  inline void cb_prtime_i(WidgetPDial*, void*);
  static void cb_prtime(WidgetPDial*, void*);
public:
  WidgetPDial *timedu;
private:
  inline void cb_timedu_i(WidgetPDial*, void*);
  static void cb_timedu(WidgetPDial*, void*);
public:
  Fl_Counter *thresh;
private:
  inline void cb_thresh_i(Fl_Counter*, void*);
  static void cb_thresh(Fl_Counter*, void*);
public:
  Fl_Check_Button *thtype;
private:
  inline void cb_thtype_i(Fl_Check_Button*, void*);
  static void cb_thtype(Fl_Check_Button*, void*);
public:
  WidgetPDial *propta;
private:
  inline void cb_propta_i(WidgetPDial*, void*);
  static void cb_propta(WidgetPDial*, void*);
public:
  WidgetPDial *proptb;
private:
  inline void cb_proptb_i(WidgetPDial*, void*);
  static void cb_proptb(WidgetPDial*, void*);
public:
  Fl_Check_Button *rcv;
private:
  inline void cb_rcv_i(Fl_Check_Button*, void*);
  static void cb_rcv(Fl_Check_Button*, void*);
public:
  Fl_Check_Button *proprt;
private:
  inline void cb_proprt_i(Fl_Check_Button*, void*);
  static void cb_proprt(Fl_Check_Button*, void*);
public:
  Fl_Double_Window *ctlmidi;
  WidgetPDial *modulation;
private:
  inline void cb_modulation_i(WidgetPDial*, void*);
  static void cb_modulation(WidgetPDial*, void*);
public:
  WidgetPDial *expression;
private:
  inline void cb_expression_i(WidgetPDial*, void*);
  static void cb_expression(WidgetPDial*, void*);
public:
  WidgetPDial *filterq;
private:
  inline void cb_filterq_i(WidgetPDial*, void*);
  static void cb_filterq(WidgetPDial*, void*);
public:
  WidgetPDial *filtercutoff;
private:
  inline void cb_filtercutoff_i(WidgetPDial*, void*);
  static void cb_filtercutoff(WidgetPDial*, void*);
public:
  WidgetPDial *masterbandwidth;
private:
  inline void cb_masterbandwidth_i(WidgetPDial*, void*);
  static void cb_masterbandwidth(WidgetPDial*, void*);
  inline void cb_Close1_i(Fl_Button*, void*);
  static void cb_Close1(Fl_Button*, void*);
public:
  Fl_Double_Window *partfx;
  Fl_Spinner *inseffnocounter;
private:
  inline void cb_inseffnocounter_i(Fl_Spinner*, void*);
  static void cb_inseffnocounter(Fl_Spinner*, void*);
public:
  Fl_Choice *insefftype;
private:
  inline void cb_insefftype_i(Fl_Choice*, void*);
  static void cb_insefftype(Fl_Choice*, void*);
  static Fl_Menu_Item menu_insefftype[];
public:
  Fl_Group *inseffectuigroup;
  EffUI *inseffectui;
private:
  inline void cb_Close2_i(Fl_Button*, void*);
  static void cb_Close2(Fl_Button*, void*);
public:
  Fl_Choice *sendtochoice;
private:
  inline void cb_sendtochoice_i(Fl_Choice*, void*);
  static void cb_sendtochoice(Fl_Choice*, void*);
  static Fl_Menu_Item menu_sendtochoice[];
public:
  Fl_Check_Button *bypasseff;
private:
  inline void cb_bypasseff_i(Fl_Check_Button*, void*);
  static void cb_bypasseff(Fl_Check_Button*, void*);
  inline void cb_C_i(Fl_Button*, void*);
  static void cb_C(Fl_Button*, void*);
  inline void cb_P_i(Fl_Button*, void*);
  static void cb_P(Fl_Button*, void*);
public:
  Fl_Double_Window *instrumentkitlist;
private:
  inline void cb_Close3_i(Fl_Button*, void*);
  static void cb_Close3(Fl_Button*, void*);
public:
  Fl_Scroll *kitlist;
  Fl_Choice *kitMode;
private:
  inline void cb_kitMode_i(Fl_Choice*, void*);
  static void cb_kitMode(Fl_Choice*, void*);
  static Fl_Menu_Item menu_kitMode[];
public:
  Fl_Check_Button *drumMode;
private:
  inline void cb_drumMode_i(Fl_Check_Button*, void*);
  static void cb_drumMode(Fl_Check_Button*, void*);
public:
  Fl_Double_Window *instrumenteditwindow;
  Fl_Group *ADD;
  Fl_Check_Button *adsynenabledcheck;
private:
  inline void cb_adsynenabledcheck_i(Fl_Check_Button*, void*);
  static void cb_adsynenabledcheck(Fl_Check_Button*, void*);
public:
  Fl_Box *addbox;
  Fl_Button *adeditbutton;
private:
  inline void cb_adeditbutton1_i(Fl_Button*, void*);
  static void cb_adeditbutton1(Fl_Button*, void*);
public:
  Fl_Group *SUB;
  Fl_Check_Button *subsynenabledcheck;
private:
  inline void cb_subsynenabledcheck_i(Fl_Check_Button*, void*);
  static void cb_subsynenabledcheck(Fl_Check_Button*, void*);
public:
  Fl_Box *subbox;
  Fl_Button *subeditbutton;
private:
  inline void cb_subeditbutton1_i(Fl_Button*, void*);
  static void cb_subeditbutton1(Fl_Button*, void*);
public:
  Fl_Group *PAD;
  Fl_Check_Button *padsynenabledcheck;
private:
  inline void cb_padsynenabledcheck_i(Fl_Check_Button*, void*);
  static void cb_padsynenabledcheck(Fl_Check_Button*, void*);
public:
  Fl_Box *padbox;
  Fl_Button *padeditbutton;
private:
  inline void cb_padeditbutton1_i(Fl_Button*, void*);
  static void cb_padeditbutton1(Fl_Button*, void*);
  inline void cb_Kit_i(Fl_Button*, void*);
  static void cb_Kit(Fl_Button*, void*);
  inline void cb_Effects_i(Fl_Button*, void*);
  static void cb_Effects(Fl_Button*, void*);
  inline void cb_Author_i(Fl_Input*, void*);
  static void cb_Author(Fl_Input*, void*);
  inline void cb_Comments_i(Fl_Input*, void*);
  static void cb_Comments(Fl_Input*, void*);
  inline void cb_Type_i(Fl_Choice*, void*);
  static void cb_Type(Fl_Choice*, void*);
  static Fl_Menu_Item menu_Type[];
public:
  mwheel_val_slider_rev *humanise;
private:
  inline void cb_humanise_i(mwheel_val_slider_rev*, void*);
  static void cb_humanise(mwheel_val_slider_rev*, void*);
  inline void cb_Close4_i(Fl_Button*, void*);
  static void cb_Close4(Fl_Button*, void*);
public:
  void send_data(int control, float value, int type, int kititem = 0xff, int engine = 0xff, int insert = 0xff, int parameter = 0xff, int par2 = 0xff);
  void returns_update(CommandBlock *getData);
  PartUI(int x,int y, int w, int h, const char *label=0);
  void updatecontrollers();
  void init(Part *part_,int npart_,BankUI *bankui_);
  void checkEngines();
  void showparameters(int kititem, int engine);
  void setinstrumentlabel();
  void seteditname();
  void ctlmidirefresh();
  ~PartUI();
  Part *part; 
private:
  BankUI *bankui; 
public:
  ADnoteUI *adnoteui; 
  SUBnoteUI *subnoteui; 
  PADnoteUI *padnoteui; 
private:
  PartSysEffSend *psyef[NUM_SYS_EFX]; 
public:
  int npart; 
private:
  int ninseff; 
public:
  int lastkititem; 
private:
  PartKitItem *partkititem[NUM_KIT_ITEMS]; 
  SynthEngine *synth; 
  int *plgroup; 
  int engine; 
public:
  bool partKitOn; 
};
#endif
